# OMEinsumContractionOrders

OMEinsumContractionOrders is a Julia package that provides an `optimize_code` function for finding optimal contraction orders for tensor networks. It is designed to work with multiple tensor network packages, such as: [OMEinsum.jl](https://github.com/under-Peter/OMEinsum.jl/issues) package and [ITensorNetworks.jl](https://github.com/mtfishman/ITensorNetworks.jl).

[![Documentation](https://img.shields.io/badge/docs-dev-blue.svg)](https://tensorbfs.github.io/OMEinsumContractionOrders.jl/dev/)
[![Build Status](https://github.com/TensorBFS/OMEinsumContractionOrders.jl/workflows/CI/badge.svg)](https://github.com/TensorBFS/OMEinsumContractionOrders.jl/actions)
[![codecov](https://codecov.io/gh/TensorBFS/OMEinsumContractionOrders.jl/branch/master/graph/badge.svg?token=BwaF0cV6q1)](https://codecov.io/gh/TensorBFS/OMEinsumContractionOrders.jl)

## Installation

To install OMEinsumContractionOrders, please follow these steps:

1. Open Julia's interactive session (known as [REPL](https://docs.julialang.org/en/v1/manual/getting-started/)) by typing `julia` in your terminal.
2. Press the <kbd>]</kbd> key in the REPL to enter the package mode.
3. Type `add OMEinsumContractionOrders` to install the stable release of the package.

For using, please check the [documentation](https://tensorbfs.github.io/OMEinsumContractionOrders.jl/dev/).

## Contributing

For a contributor guide, please refer to [CLAUDE.md](CLAUDE.md) for details.

## References

If you find this package useful in your research, please cite the *relevant* papers in [CITATION.bib](CITATION.bib).

# Examples

## Setup

Navigate to the repo root and run:
```bash
$ make init  # or make update
```
It will install the dependencies for your examples environment.

## Run examples

### Contraction order optimization in practical cases

1. [nqueens.jl](nqueens.jl) - N-Queens problem counting.
    ```bash
    $ julia --project=examples examples/nqueens.jl
    ```
    Source: https://github.com/nzy1997/TensorNQueens.jl/
2. [circuit.jl](circuit.jl) - Quantum circuit simulation.
    ```bash
    $ julia --project=examples examples/circuit.jl
    ```
    Source: https://github.com/CodingThrust/AMAT5315-2025Spring-Homeworks/tree/main/hw8
3. [mis.jl](mis.jl) - Maximum Independent Set problem.
    ```bash
    $ julia --project=examples examples/mis.jl
    ```
4. [inference.jl](inference.jl) - Inference in a Bayesian network, the relational dataset that difficult to solve with TreeSA.
    ```bash
    $ julia --project=examples examples/inference.jl
    ```
    Source: https://github.com/TensorBFS/TensorInference.jl/issues/15
5. [qec.jl](qec.jl) - Quantum error correction.
    ```bash
    $ julia --project=examples examples/qec.jl
    ```
    Source: https://github.com/nzy1997/TensorQEC.jl/blob/main/test/decoding/tndecoder.jl

### Multi-GPU simulation of a quantum circuit

Additionally, we have a [slicing_multigpu.jl](slicing_multigpu.jl) example for multi-GPU simulation of a quantum circuit (parallel in slices).
```bash
$ julia -e 'using Pkg; Pkg.add("CUDA")'
$ julia --project=examples examples/slicing_multigpu.jl
```
Here, we first install `CUDA` package in the global environment, and then run the example.

using Graphs
using Test, Random
using SparseArrays
using OMEinsumContractionOrders
using OMEinsumContractionOrders: get_coarse_grained_graph, _connected_components, bipartite_sc, group_sc, coarse_grained_optimize,
    map_tree_to_parts, ContractionTree, optimize_greedy, recursive_bipartite_optimize
using KaHyPar
using OMEinsum: decorate

@testset "graph coarse graining" begin
    Random.seed!(2)
    adj = zeros(5, 6)
    for ind in [[1,1], [1,3], [2,2], [3,2], [4,4], [4,5], [4,3], [5, 4]]
        adj[ind...] = 1
    end
    parts = [[1,3], [2], [4]]
    incidence_list = get_coarse_grained_graph(sparse(adj), parts)
    @test incidence_list.v2e[1] == [1,2,3]
    @test incidence_list.v2e[2] == [2]
    @test incidence_list.v2e[3] == [3,4,5]
    @test incidence_list.openedges == [4]

    @test length(_connected_components(adj, parts[1])) == 2

    res = coarse_grained_optimize(adj, parts, ones(6), GreedyMethod())
    @test res == ContractionTree(ContractionTree(1,2), 3)
    @test map_tree_to_parts(res, [[[1,2], 3], [7,6], [9, [4,1]]]) == [[[[1,2], 3], [7,6]], [9, [4,1]]]
end

@testset "kahypar" begin
    Random.seed!(2)
    function random_regular_eincode(n, k)
        g = Graphs.random_regular_graph(n, k)
        ixs = [[minmax(e.src,e.dst)...] for e in Graphs.edges(g)]
        return OMEinsumContractionOrders.EinCode([ixs..., [[i] for i in Graphs.vertices(g)]...], Int[])
    end

    function random_regular_open_eincode(n, k, m)
        g = Graphs.random_regular_graph(n, k)
        ixs = [[minmax(e.src,e.dst)...] for e in Graphs.edges(g)]
        iy = Int[]
        while length(iy) < m
            v = rand(1:n)
            if !(v in iy)
                push!(iy, v)
            end
        end
        sort!(iy)
        return OMEinsumContractionOrders.EinCode([ixs..., [[i] for i in Graphs.vertices(g)]...], iy)
    end

    g = random_regular_graph(220, 3)
    rows = Int[]
    cols = Int[]
    for (i,edge) in enumerate(edges(g))
        push!(rows, edge.src, edge.dst)
        push!(cols, i, i)
    end
    graph = sparse(rows, cols, ones(Int, length(rows)))
    sc_target = 30.0
    log2_sizes = fill(1, size(graph, 2))
    b = KaHyParBipartite(sc_target=sc_target, imbalances=[0.0:0.02:0.8...])
    res = bipartite_sc(b, graph, collect(1:size(graph, 1)), log2_sizes)
    @test group_sc(graph, res.part1, log2_sizes) <= sc_target
    @test group_sc(graph, res.part2, log2_sizes) <= sc_target
    sc_target = 30.0
    res = bipartite_sc(b, graph, collect(1:size(graph, 1)), log2_sizes)
    @test group_sc(graph, res.part1, log2_sizes) <= sc_target
    @test group_sc(graph, res.part2, log2_sizes) <= sc_target

    code = random_regular_eincode(220, 3)
    res = recursive_bipartite_optimize(KaHyParBipartite(sc_target=30, max_group_size=50), code, uniformsize(code, 2))
    cc = contraction_complexity(res, uniformsize(code, 2))
    @test cc.sc <= 30

    # contraction test
    code = random_regular_eincode(50, 3)
    codeg = recursive_bipartite_optimize(KaHyParBipartite(sc_target=10, max_group_size=10), code, uniformsize(code, 2))
    codet = recursive_bipartite_optimize(KaHyParBipartite(sc_target=10, max_group_size=10, sub_optimizer = TreeSA()), code, uniformsize(code, 2))
    codek = optimize_greedy(code, uniformsize(code, 2); α=0.0, temperature=0.0)

    cc_kg = contraction_complexity(codeg, uniformsize(code, 2))
    cc_kt = contraction_complexity(codet, uniformsize(code, 2))
    cc_g = contraction_complexity(codek, uniformsize(code, 2))

    @test cc_kg.sc <= 12
    @test cc_kt.sc <= 12
    @test cc_g.sc <= 12

    xs = [[2*randn(2, 2) for i=1:75]..., [randn(2) for i=1:50]...]
    resg = decorate(codeg)(xs...)
    resk = decorate(codek)(xs...)
    @test resg ≈ resk

    Random.seed!(2)
    code = random_regular_open_eincode(50, 3, 3)
    codeg = recursive_bipartite_optimize(KaHyParBipartite(sc_target=10, max_group_size=10), code, uniformsize(code, 2))
    codet = recursive_bipartite_optimize(KaHyParBipartite(sc_target=10, max_group_size=10, sub_optimizer = TreeSA()), code, uniformsize(code, 2))
    codek = optimize_greedy(code, uniformsize(code, 2); α=0.0, temperature=0.0)

    xs = [[2*randn(2, 2) for i=1:75]..., [randn(2) for i=1:50]...]
    resg = decorate(codeg)(xs...)
    rest = decorate(codet)(xs...)
    resk = decorate(codek)(xs...)
    @test rest ≈ resk
    @test resg ≈ resk
end

@testset "kahypar no error" begin
    function random_regular_open_eincode(n, k, m)
        g = Graphs.random_regular_graph(n, k)
        ixs = [[minmax(e.src,e.dst)...] for e in Graphs.edges(g)]
        iy = Int[]
        while length(iy) < m
            v = rand(1:n)
            if !(v in iy)
                push!(iy, v)
            end
        end
        sort!(iy)
        return OMEinsumContractionOrders.EinCode([ixs..., [[i] for i in Graphs.vertices(g)]...], iy)
    end


    Random.seed!(2)
    code = random_regular_open_eincode(50, 3, 3)
    codeg = recursive_bipartite_optimize(KaHyParBipartite(sc_target=5, max_group_size=10), code, uniformsize(code, 2))
    codek = optimize_greedy(code, uniformsize(code, 2); α=0.0, temperature=0.0)

    xs = [[2*randn(2, 2) for i=1:75]..., [randn(2) for i=1:50]...]
    resg = decorate(codeg)(xs...)
    resk = decorate(codek)(xs...)
    @test resg ≈ resk
end

struct ContractionTree
    left
    right
end

struct LegInfo{ET}
    # We use number 0, 1, 2 to denote the output tensor, the first input tensor and the second input tensor,and use e.g. `l01` to denote the set of labels that appear in both the output tensor and the input tensor.
    l1::Vector{ET}
    l2::Vector{ET}
    l12::Vector{ET}
    l01::Vector{ET}
    l02::Vector{ET}
    l012::Vector{ET}
end

"""
    tree_greedy(incidence_list, log2_sizes; α = 0.0, temperature = 0.0)

Compute greedy order, and the time and space complexities, the rows of the `incidence_list` are vertices and columns are edges.
`log2_sizes` are defined on edges.
`α` is the parameter for the loss function, for pairwise interaction, L = size(out) - α * (size(in1) + size(in2))
`temperature` is the parameter for sampling, if it is zero, the minimum loss is selected; for non-zero, the loss is selected by the Boltzmann distribution, given by p ~ exp(-loss/temperature).
"""
function tree_greedy(incidence_list::IncidenceList{Int, ET}, log2_edge_sizes; α::TA = 0.0, temperature::TT = 0.0) where {TA,TT, ET}
    incidence_list = copy(incidence_list)
    n = nv(incidence_list)
    if n == 0
        return nothing
    elseif n == 1
        return collect(vertices(incidence_list))[1]
    end
    log2_tcs = Float64[] # time complexity
    log2_scs = Float64[]

    tree = Dict{Int,Any}([v=>v for v in vertices(incidence_list)])
    cost_values, cost_graph = evaluate_costs(α, incidence_list, log2_edge_sizes)
    while true
        if isempty(cost_values)
            vpool = collect(vertices(incidence_list))
            pair = minmax(vpool[1], vpool[2])  # to prevent empty intersect
        else
            pair = find_best_cost!(temperature, cost_values, cost_graph)
        end
        log2_tc_step, sc, code = contract_pair!(incidence_list, pair..., log2_edge_sizes)
        push!(log2_tcs, log2_tc_step)
        push!(log2_scs, sc)   # NOTE: the original one is computed with `space_complexity`, why did I made such a mistake?
        if nv(incidence_list) > 1
            tree[pair[1]] = ContractionTree(tree[pair[1]], tree[pair[2]])
        else
            return ContractionTree(tree[pair[1]], tree[pair[2]]), log2_tcs, log2_scs
        end
        update_costs!(cost_values, cost_graph, pair..., α, incidence_list, log2_edge_sizes)
    end
end

function contract_pair!(incidence_list::IncidenceList{Int,ET}, vi::Int, vj::Int, log2_edge_sizes) where {ET}
    # Compute dimensions and edge lists in one pass
    eout, eremove = ET[], ET[]
    D1, D2, D12, D01, D02, D012 = compute_contraction_dims(incidence_list, log2_edge_sizes, vi, vj, eout, eremove)
    
    tc = D12 + D01 + D02 + D012  # dangling legs D1 and D2 do not contribute
    sc = D01 + D02 + D012  # space complexity is the output tensor size

    # einsum code
    code = (edges(incidence_list, vi), edges(incidence_list, vj)) => eout

    # change incidence_list
    delete_vertex!(incidence_list, vj)
    change_edges!(incidence_list, vi, eout)
    for e in eout
        replace_vertex!(incidence_list, e, vj=>vi)
    end
    remove_edges!(incidence_list, eremove)
    return tc, sc, code
end

function evaluate_costs(α::TA, incidence_list::IncidenceList{Int,ET}, log2_edge_sizes) where {TA,ET}
    # initialize cost values
    cost_values = PriorityQueue{Tuple{Int,Int},Float64}()#Dict{Tuple{VT,VT},Float64}()
    cost_graph = SimpleGraph(nv(incidence_list))
    for vi in vertices(incidence_list)
        for vj in neighbors(incidence_list, vi)
            if vj > vi
                push!(cost_values, (vi,vj) => greedy_loss(α, incidence_list, log2_edge_sizes, vi, vj))
                add_edge!(cost_graph, vi, vj)
            end
        end
    end
    return cost_values, cost_graph
end

function update_costs!(cost_values, cost_graph, va, vb, α::TA, incidence_list::IncidenceList{Int,ET}, log2_edge_sizes) where {TA,ET}
    for vj in neighbors(incidence_list, va)
        vx, vy = minmax(vj, va)
        if has_edge(cost_graph, vx, vy)
            delete!(cost_values, (vx,vy))
            push!(cost_values, (vx,vy) => greedy_loss(α, incidence_list, log2_edge_sizes, vx, vy))
        else
            push!(cost_values, (vx,vy) => greedy_loss(α, incidence_list, log2_edge_sizes, vx, vy))
            add_edge!(cost_graph, vx, vy)
        end
    end
    for vj in copy(Graphs.neighbors(cost_graph, vb))
        vx, vy = minmax(vj, vb)
        delete!(cost_values, (vx,vy))
        rem_edge!(cost_graph, vx, vy)
    end
end

function find_best_cost!(temperature::TT, cost_values::PriorityQueue{PT}, cost_graph) where {PT,TT}
    length(cost_values) < 1 && error("cost value information missing")
    pair, cost = popfirst!(cost_values)
    if iszero(temperature) || isempty(cost_values)
        rem_edge!(cost_graph, pair...)
        return pair
    else
        pair2, cost2 = popfirst!(cost_values)
        if rand() < exp(-(cost2 - cost) / temperature)   # pick 2
            push!(cost_values, pair => cost)
            rem_edge!(cost_graph, pair2...)
            return pair2
        else
            push!(cost_values, pair2 => cost2)
            rem_edge!(cost_graph, pair...)
            return pair
        end
    end
end

"""
    compute_contraction_dims(incidence_list, log2_edge_sizes, vi, vj, eout, eremove) -> (D1, D2, D12, D01, D02, D012)

Compute the log2 dimensions and edge lists for contracting vertices `vi` and `vj`.
Returns a tuple of six Float64 dimension values:
- D1: edges only in vi and internal
- D2: edges only in vj and internal
- D12: edges in both vi and vj and internal
- D01: edges only in vi and external
- D02: edges only in vj and external
- D012: edges in both vi and vj and external
"""
function compute_contraction_dims(incidence_list, log2_edge_sizes, vi, vj, eout, eremove)
    ei = edges(incidence_list, vi)
    ej = edges(incidence_list, vj)
    
    # Initialize dimension accumulators
    D1, D2, D12, D01, D02, D012 = 0.0, 0.0, 0.0, 0.0, 0.0, 0.0
    
    # Process edges from vi
    for leg in ei
        isext = leg ∈ incidence_list.openedges || !all(x->x==vi || x==vj, vertices(incidence_list, leg))
        in_ej = leg ∈ ej
        leg_size = log2_edge_sizes[leg]
        
        if isext
            eout !== nothing && push!(eout, leg)
            if in_ej
                D012 += leg_size
            else
                D01 += leg_size
            end
        else
            eremove !== nothing && push!(eremove, leg)
            if in_ej
                D12 += leg_size
            else
                D1 += leg_size
            end
        end
    end
    
    # Process edges from vj that are not in vi
    for leg in ej
        if leg ∉ ei
            isext = leg ∈ incidence_list.openedges || !all(x->x==vi || x==vj, vertices(incidence_list, leg))
            leg_size = log2_edge_sizes[leg]
            
            if isext
                eout !== nothing && push!(eout, leg)
                D02 += leg_size
            else
                eremove !== nothing && push!(eremove, leg)
                D2 += leg_size
            end
        end
    end
    
    return (D1, D2, D12, D01, D02, D012)
end

function greedy_loss(α, incidence_list, log2_edge_sizes, vi, vj)
    D1, D2, D12, D01, D02, D012 = compute_contraction_dims(incidence_list, log2_edge_sizes, vi, vj, nothing, nothing)
    loss = exp2(D01+D02+D012) - α * (exp2(D01+D12+D012) + exp2(D02+D12+D012))  # out - in
    return loss
end

function space_complexity(incidence_list, log2_sizes)
    sc = 0.0
    for v in vertices(incidence_list)
        for e in edges(incidence_list, v)
            sc += log2_sizes[e]
        end
    end
    return sc
end

function contract_tree!(incidence_list::IncidenceList, tree::ContractionTree, log2_edge_sizes, tcs, scs)
    vi = tree.left isa ContractionTree ? contract_tree!(incidence_list, tree.left, log2_edge_sizes, tcs, scs) : tree.left
    vj = tree.right isa ContractionTree ? contract_tree!(incidence_list, tree.right, log2_edge_sizes, tcs, scs) : tree.right
    tc, sc, code = contract_pair!(incidence_list, vi, vj, log2_edge_sizes)
    push!(tcs, tc)
    push!(scs, sc)
    return vi
end

#################### parse to code ####################
function parse_eincode!(::IncidenceList{IT,LT}, tree, vertices_order, size_dict, level=0) where {IT,LT}
    ti = findfirst(==(tree), vertices_order)::Int
    return ti, NestedEinsum{LT}(ti)
end

function parse_eincode!(incidence_list::IncidenceList{IT,LT}, tree::ContractionTree, vertices_order, size_dict, level=0) where {IT,LT}
    ti, codei = parse_eincode!(incidence_list, tree.left, vertices_order, size_dict, level+1)
    tj, codej = parse_eincode!(incidence_list, tree.right, vertices_order, size_dict, level+1)
    _, _, code = contract_pair!(incidence_list, vertices_order[ti], vertices_order[tj], size_dict)
    return ti, NestedEinsum([codei, codej], EinCode([code.first...], level==0 ? incidence_list.openedges : code.second))
end

function parse_eincode(incidence_list::IncidenceList, tree::ContractionTree; vertices = collect(keys(incidence_list.v2e)))
    size_dict = Dict([v=>0 for (i,v) in enumerate(vertices)])  # dummy size_dict
    parse_eincode!(copy(incidence_list), tree, vertices, size_dict)[2]
end

function parse_nested(code::EinCode{LT}, tree::ContractionTree) where LT
    ixs, iy = getixsv(code), getiyv(code)
    incidence_list = IncidenceList(Dict([i=>ixs[i] for i=1:length(ixs)]); openedges=iy)
    parse_eincode!(incidence_list, tree, 1:length(ixs), size_dict)[2]
end

function parse_tree(ein, vertices)
    if isleaf(ein)
        vertices[ein.tensorindex]
    else
        if length(ein.args) != 2
            error("This eincode is not a binary tree.")
        end
        left, right = parse_tree.(ein.args, Ref(vertices))
        ContractionTree(left, right)
    end
end

"""
    optimize_greedy(eincode, size_dict; α, temperature)

Greedy optimizing the contraction order and return a `NestedEinsum` object.
Check the docstring of `tree_greedy` for detailed explaination of other input arguments.
"""
function optimize_greedy(code::AbstractEinsum, size_dict::Dict{L, T2}; α, temperature) where {L, T2}
    optimize_greedy_log2size(code, _log2_size_dict(size_dict); α, temperature)
end

function optimize_greedy_log2size(code::EinCode{L}, log2_size_dict::Dict{L}; α, temperature) where {L}
    _optimize_greedy_log2size(getixsv(code), getiyv(code), log2_size_dict; α, temperature)
end
function _optimize_greedy_log2size(ixs::AbstractVector{<:AbstractVector}, iy::AbstractVector, log2_size_dict::Dict{L}; α, temperature) where {L}
    if length(ixs) <= 2
        return NestedEinsum(NestedEinsum{L}.(1:length(ixs)), EinCode(ixs, iy))
    end
    incidence_list = IncidenceList(Dict([i=>ixs[i] for i=1:length(ixs)]); openedges=iy)
    tree, _, _ = tree_greedy(incidence_list, log2_size_dict; α, temperature)
    parse_eincode!(incidence_list, tree, 1:length(ixs), log2_size_dict)[2]
end

function optimize_greedy_log2size(code::NestedEinsum{L}, log2_size_dict; α, temperature) where {L}
    # construct first-child next-sibling representation of `code`
    queue = [code]
    child = [0]
    brother = [0]

    for (i, code) in enumerate(queue)
        if !isleaf(code)
            for arg in code.args
                push!(queue, arg)
                push!(brother, child[i])
                push!(child, 0)
                child[i] = length(queue)
            end
        end
    end

    # construct postordering of `code`
    order = similar(queue)
    stack = [1]

    for i in eachindex(queue)
        j = pop!(stack); k = child[j]

        while !iszero(k)
            push!(stack, j); child[j] = brother[k]; j = k; k = child[j]
        end

        order[i] = queue[j]
    end

    # optimize `code` using dynamic programming
    empty!(queue)

    for code in order
        if isleaf(code)
            push!(queue, code)
        else
            args = NestedEinsum{L}[]

            for _ in code.args
                push!(args, pop!(queue))
            end

            if length(args) > 2
                code = replace_args(optimize_greedy_log2size(code.eins, log2_size_dict; α, temperature), args)
            else
                code = NestedEinsum(args, code.eins)
            end

            push!(queue, code)
        end
    end

    return only(queue)
end

function replace_args(nested::NestedEinsum{LT}, trueargs) where LT
    isleaf(nested) && return trueargs[nested.tensorindex]
    NestedEinsum(replace_args.(nested.args, Ref(trueargs)), nested.eins)
end

"""
    GreedyMethod{MT}
    GreedyMethod(; α = 0.0, temperature = 0.0)

It may not be optimal, but it is fast.

# Fields
- `α` is the parameter for the loss function, for pairwise interaction, L = size(out) - α * (size(in1) + size(in2))
- `temperature` is the parameter for sampling, if it is zero, the minimum loss is selected; for non-zero, the loss is selected by the Boltzmann distribution, given by p ~ exp(-loss/temperature).
"""
Base.@kwdef struct GreedyMethod{TA, TT} <: CodeOptimizer
    α::TA = 0.0
    temperature::TT = 0.0
end

using OMEinsumContractionOrders
using OMEinsumContractionOrders: ContractionTree, IncidenceList,
    getixsv, getiyv, parse_eincode!, optimize_exhaustive
using OMEinsum: decorate
using Test, Random

const OCO = OMEinsumContractionOrders

# Independent reference: enumerate every full binary contraction tree over the
# tensor indices, score each with the trusted `flop`, and return the minimum.
# This validates that the DP picks an optimal *topology* without sharing code
# with the DP itself.
function all_binary_trees(leaves::Vector{Int})
    length(leaves) == 1 && return Any[leaves[1]]
    res = Any[]
    first = leaves[1]
    rest = leaves[2:end]
    m = length(rest)
    for mask in 1:(2^m - 1)  # nonempty subset of `rest` forms the right subtree
        right = [rest[i] for i in 1:m if (mask >> (i - 1)) & 1 == 1]
        left = [first; [rest[i] for i in 1:m if (mask >> (i - 1)) & 1 == 0]]
        for tl in all_binary_trees(left), tr in all_binary_trees(right)
            push!(res, ContractionTree(tl, tr))
        end
    end
    return res
end

function brute_force_min_flop(code::OCO.EinCode, size_dict)
    ixs, iy = getixsv(code), getiyv(code)
    n = length(ixs)
    best = Inf
    for tree in all_binary_trees(collect(1:n))
        il = IncidenceList(Dict(i => ixs[i] for i in 1:n); openedges = iy)
        ne = parse_eincode!(il, tree, collect(1:n), size_dict)[2]
        best = min(best, Float64(flop(ne, size_dict)))
    end
    return best
end

@testset "exhaustive search: optimality" begin
    optimizer = ExhaustiveSearch()
    size_dict = Dict([c => (1 << i) for (i, c) in enumerate(['a', 'b', 'c', 'd', 'e', 'f'])]...)

    # fully-contracted network (all indices appear exactly twice, empty output)
    eincode = OCO.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], Char[])
    optcode = optimize_code(eincode, size_dict, optimizer)
    cc = contraction_complexity(optcode, size_dict)
    @test cc.tc ≈ log2(flop(optcode, size_dict))
    @test flop(optcode, size_dict) == brute_force_min_flop(eincode, size_dict)
    # never worse than greedy
    greedycode = optimize_code(eincode, size_dict, GreedyMethod())
    @test flop(optcode, size_dict) <= flop(greedycode, size_dict)

    # matrix chain with open (once-appearing) output indices
    sd2 = Dict('a' => 2, 'b' => 3, 'c' => 4, 'd' => 5, 'e' => 6)
    chain = OCO.EinCode([['a', 'b'], ['b', 'c'], ['c', 'd'], ['d', 'e']], ['a', 'e'])
    optchain = optimize_code(chain, sd2, optimizer)
    @test flop(optchain, sd2) == brute_force_min_flop(chain, sd2)
end

@testset "exhaustive search: correctness" begin
    optimizer = ExhaustiveSearch()
    size_dict = Dict([c => (1 << i) for (i, c) in enumerate(['a', 'b', 'c', 'd', 'e', 'f'])]...)

    eincode = OCO.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], Char[])
    tensors = [rand([size_dict[j] for j in ixs]...) for ixs in getixsv(eincode)]
    optcode = optimize_code(eincode, size_dict, optimizer)
    @test decorate(eincode)(tensors...) ≈ decorate(optcode)(tensors...)

    # output preserved at the root
    @test sort(getiyv(optcode)) == sort(getiyv(eincode))
end

@testset "exhaustive search: open indices and disconnected" begin
    optimizer = ExhaustiveSearch()
    sd = Dict(c => 2 + i for (i, c) in enumerate(['a', 'b', 'c', 'd', 'e', 'f']))

    # two disconnected chains, combined via outer product
    eincode = OCO.EinCode([['a', 'b'], ['b', 'c'], ['d', 'e'], ['e', 'f']], ['a', 'c', 'd', 'f'])
    tensors = [rand([sd[j] for j in ixs]...) for ixs in getixsv(eincode)]
    optcode = optimize_code(eincode, sd, optimizer)
    @test sort(getiyv(optcode)) == sort(getiyv(eincode))
    @test decorate(eincode)(tensors...) ≈ decorate(optcode)(tensors...)
    @test flop(optcode, sd) == brute_force_min_flop(eincode, sd)

    # trivial small cases
    one_t = OCO.EinCode([['a', 'b']], ['a', 'b'])
    @test optimize_code(one_t, sd, optimizer) isa OCO.NestedEinsum
    two_t = OCO.EinCode([['a', 'b'], ['b', 'c']], ['a', 'c'])
    t2 = [rand(sd['a'], sd['b']), rand(sd['b'], sd['c'])]
    @test decorate(two_t)(t2...) ≈ decorate(optimize_code(two_t, sd, optimizer))(t2...)
end

@testset "exhaustive search: hyperedges and batch outputs" begin
    optimizer = ExhaustiveSearch()
    sd = Dict(c => 2 + i for (i, c) in enumerate(['a', 'b', 'c', 'd', 'e']))

    # hyperedge: index 'a' is shared by three tensors and summed out
    hyper = OCO.EinCode([['a', 'b'], ['a', 'c'], ['a', 'd']], ['b', 'c', 'd'])
    th = [rand([sd[j] for j in ixs]...) for ixs in getixsv(hyper)]
    oc = optimize_code(hyper, sd, optimizer)
    @test sort(getiyv(oc)) == sort(getiyv(hyper))
    @test decorate(hyper)(th...) ≈ decorate(oc)(th...)
    @test flop(oc, sd) == brute_force_min_flop(hyper, sd)

    # batch/diagonal output: index 'a' is shared by two tensors and kept
    batch = OCO.EinCode([['a', 'b'], ['a', 'c'], ['c', 'd']], ['a', 'b', 'd'])
    tb = [rand([sd[j] for j in ixs]...) for ixs in getixsv(batch)]
    ocb = optimize_code(batch, sd, optimizer)
    @test sort(getiyv(ocb)) == sort(getiyv(batch))
    @test decorate(batch)(tb...) ≈ decorate(ocb)(tb...)
    @test flop(ocb, sd) == brute_force_min_flop(batch, sd)
end

@testset "exhaustive search: dimension-1 indices" begin
    optimizer = ExhaustiveSearch()

    # some contracted indices have dimension 1
    sd = Dict('a' => 4, 'b' => 1, 'c' => 3, 'd' => 1, 'e' => 2)
    mixed = OCO.EinCode([['a', 'b'], ['b', 'c'], ['c', 'd'], ['d', 'e']], ['a', 'e'])
    tm = [rand([sd[j] for j in ix]...) for ix in getixsv(mixed)]
    ocm = optimize_code(mixed, sd, optimizer)
    @test decorate(mixed)(tm...) ≈ decorate(ocm)(tm...)
    @test flop(ocm, sd) == brute_force_min_flop(mixed, sd)

    # every index has dimension 1 (the costfac == 1 cost-cap edge case)
    sd1 = Dict(c => 1 for c in ['a', 'b', 'c', 'd'])
    allone = OCO.EinCode([['a', 'b'], ['b', 'c'], ['c', 'd'], ['a', 'd']], Char[])
    t1 = [rand([sd1[j] for j in ix]...) for ix in getixsv(allone)]
    oc1 = optimize_code(allone, sd1, optimizer)
    @test decorate(allone)(t1...) ≈ decorate(oc1)(t1...)
    @test flop(oc1, sd1) == brute_force_min_flop(allone, sd1)

    # dimension-1 output indices
    sd2 = Dict('a' => 1, 'b' => 2, 'c' => 2, 'd' => 1)
    out1 = OCO.EinCode([['a', 'b'], ['b', 'c'], ['c', 'd']], ['a', 'd'])
    to = [rand([sd2[j] for j in ix]...) for ix in getixsv(out1)]
    oco = optimize_code(out1, sd2, optimizer)
    @test sort(getiyv(oco)) == sort(getiyv(out1))
    @test decorate(out1)(to...) ≈ decorate(oco)(to...)
end

@testset "exhaustive search: scope errors" begin
    optimizer = ExhaustiveSearch()
    sd = Dict(c => 2 for c in ['a', 'b', 'c', 'd'])

    # partial trace within a single tensor
    selftrace = OCO.EinCode([['a', 'a', 'b'], ['b', 'c'], ['c', 'd']], ['d'])
    @test_throws ArgumentError optimize_code(selftrace, sd, optimizer)

    # dangling index: 'x' appears once but is not an output
    dangling = OCO.EinCode([['a', 'b', 'x'], ['b', 'c'], ['c', 'd']], ['a', 'd'])
    @test_throws ArgumentError optimize_code(dangling, sd, optimizer)
end

using TensorQEC, Random, OMEinsumContractionOrders, CliqueTrees, Metis

d = 9
tanner = CSSTannerGraph(SurfaceCode(d, d))

optimizer = Treewidth(; alg=ND(MF(), METISND(; ufactor=150); limit=200, level=6));
ct = compile(TNMAP(; optimizer),tanner)

# NOTE: TreeSA gives sc = 25
contraction_complexity(ct.net)

#################### compute peak memory ###########################
"""
    peak_memory(code, size_dict::Dict) -> Int

Estimate peak memory in number of elements.
"""
function peak_memory(code::NestedEinsum, size_dict::Dict)
    ixs = getixsv(code.eins)
    iy = getiyv(code.eins)
    # `largest_size` is the largest size during contraction
    largest_size = 0
    # `tempsize` is the memory to store contraction results from previous branches
    tempsize = 0
    for (i, arg) in enumerate(code.args)
        if isleaf(arg)
            largest_size_i = _mem(ixs[i], size_dict) + tempsize
        else
            largest_size_i = peak_memory(arg, size_dict) + tempsize
        end
        tempsize += _mem(ixs[i], size_dict)
        largest_size = max(largest_size, largest_size_i)
    end
    # compare with currect contraction
    return max(largest_size, tempsize + _mem(iy, size_dict))
end
_mem(iy, size_dict::Dict{LT,VT}) where {LT,VT} = isempty(iy) ? zero(VT) : prod(l->size_dict[l], iy)

function peak_memory(code::EinCode, size_dict::Dict)
    ixs = getixsv(code)
    iy = getiyv(code)
    return sum(ix->_mem(ix, size_dict), ixs) + _mem(iy, size_dict)
end

function peak_memory(code::SlicedEinsum, size_dict::Dict)
    size_dict_sliced = copy(size_dict)
    for l in code.slicing
        size_dict_sliced[l] = 1
    end
    return peak_memory(code.eins, size_dict_sliced) + _mem(getiyv(code.eins), size_dict)
end

###################### Time space complexity ###################
function __timespacereadwrite_complexity(ei::NestedEinsum, size_dict)
    log2_sizes = Dict([k=>log2(v) for (k,v) in size_dict])
    _timespacereadwrite_complexity(ei, log2_sizes)
end

function __timespacereadwrite_complexity(ei::EinCode, size_dict)
    log2_sizes = Dict([k=>log2(v) for (k,v) in size_dict])
    _timespacereadwrite_complexity(getixsv(ei), getiyv(ei), log2_sizes)
end

function _timespacereadwrite_complexity(ei::NestedEinsum, log2_sizes::Dict{L, VT}) where {L, VT}
    min = typemin(VT)

    tcs = [min]
    scs = [min]
    rws = [min]
    stack = [ei]

    while !isempty(stack)
        ei = pop!(stack)

        if !isleaf(ei)
            tc, sc, rw = _timespacereadwrite_complexity(
                getixsv(ei.eins),
                getiyv(ei.eins),
                log2_sizes,
            ) 

            append!(stack, ei.args)
            push!(tcs, tc)
            push!(scs, sc)
            push!(rws, rw)
        end
    end

    tc = log2sumexp2(tcs)
    sc = maximum(scs)
    rw = log2sumexp2(rws)
    return tc, sc, rw
end

function _timespacereadwrite_complexity(ixs::AbstractVector, iy::AbstractVector{T}, log2_sizes::Dict{L,VT}) where {T, L, VT}
    loop_inds = get_loop_inds(ixs, iy)
    tc = isempty(loop_inds) ? zero(VT) : sum(l->log2_sizes[l], loop_inds)
    sc = isempty(iy) ? zero(VT) : sum(l->log2_sizes[l], iy)
    rw = log2sumexp2([[isempty(ix) ? zero(VT) : sum(l->log2_sizes[l], ix) for ix in ixs]..., sc])
    return tc, sc, rw
end

function get_loop_inds(ixs::AbstractVector, iy::AbstractVector{LT}) where {LT}
    # remove redundant legs
    counts = Dict{LT,Int}()
    for ix in ixs
        for l in ix
            if haskey(counts, l)
                counts[l] += 1
            else
                counts[l] = 1
            end
        end
    end
    for l in iy
        if haskey(counts, l)
            counts[l] += 1
        else
            counts[l] = 1
        end
    end
    loop_inds = LT[]
    for ix in ixs
        for l in ix
            c = count(==(l), ix)
            if counts[l] > c && l ∉ loop_inds
                push!(loop_inds, l)
            end
        end
    end
    return loop_inds
end


"""
    flop(eincode, size_dict) -> Int

Returns the number of iterations, which is different with the true floating point operations (FLOP) by a factor of 2.
"""
function flop(ei::EinCode, size_dict::Dict{LT,VT}) where {LT,VT}
    loop_inds = uniquelabels(ei)
    return isempty(loop_inds) ? zero(VT) : prod(l->size_dict[l], loop_inds)
end

function flop(ei::NestedEinsum, size_dict::Dict{L,VT}) where {L,VT}
    isleaf(ei) && return zero(VT)
    return sum(ei.args) do arg
        flop(arg, size_dict)
    end + flop(ei.eins, size_dict)
end


############### Sliced methods   ##################
function __timespacereadwrite_complexity(code::SlicedEinsum, size_dict)
    size_dict_sliced = copy(size_dict)
    for l in code.slicing
        size_dict_sliced[l] = 1
    end
    tc, sc, rw = __timespacereadwrite_complexity(code.eins, size_dict_sliced)
    sliceoverhead = sum(log2.(getindex.(Ref(size_dict), code.slicing)))
    tc + sliceoverhead, sc, rw+sliceoverhead
end
function flop(code::SlicedEinsum, size_dict)
    size_dict_sliced = copy(size_dict)
    for l in code.slicing
        size_dict_sliced[l] = 1
    end
    fl = flop(code.eins, size_dict_sliced)
    fl * prod(getindex.(Ref(size_dict), code.slicing))
end

"""
    uniformsize(code::AbstractEinsum, size::Int) -> Dict

Returns a dictionary that maps each label to the given size.
"""
uniformsize(code::AbstractEinsum, size) = Dict([l=>size for l in uniquelabels(code)])

"""
    label_elimination_order(code) -> Vector

Returns a vector of labels sorted by the order they are eliminated in the contraction tree.
The contraction tree is specified by `code`, which e.g. can be a `NestedEinsum` instance.
"""
label_elimination_order(code::NestedEinsum) = label_elimination_order!(code, labeltype(code)[])
function label_elimination_order!(code, eliminated_vertices)
    isleaf(code) && return eliminated_vertices
    for arg in code.args
        label_elimination_order!(arg, eliminated_vertices)
    end
    append!(eliminated_vertices, setdiff(vcat(getixsv(code.eins)...), getiyv(code.eins)))
    return eliminated_vertices
end
label_elimination_order(code::SlicedEinsum) = label_elimination_order(code.eins)

# to replace timespacereadwrite_complexity
struct ContractionComplexity
    tc::Float64
    sc::Float64
    rwc::Float64
end

function Base.show(io::IO, cc::ContractionComplexity)
    print(io, "Time complexity: 2^$(cc.tc)
Space complexity: 2^$(cc.sc)
Read-write complexity: 2^$(cc.rwc)")
end
Base.iterate(cc::ContractionComplexity) = Base.iterate((cc.tc, cc.sc, cc.rwc))
Base.iterate(cc::ContractionComplexity, state) = Base.iterate((cc.tc, cc.sc, cc.rwc), state)

"""
    contraction_complexity(eincode, size_dict) -> ContractionComplexity

Returns the time, space and read-write complexity of the einsum contraction.
The returned `ContractionComplexity` object contains 3 fields:
- `tc`: time complexity defined as `log2(number of element-wise multiplications)`.
- `sc`: space complexity defined as `log2(size of the maximum intermediate tensor)`.
- `rwc`: read-write complexity defined as `log2(the number of read-write operations)`.
"""
contraction_complexity(code::AbstractEinsum, size_dict) = ContractionComplexity(__timespacereadwrite_complexity(code, size_dict)...)

using TensorInference, OMEinsumContractionOrders

problems = dataset_from_artifact("uai2014")["MAR"]
problem_set_name = "relational"
tamaki = [251, 3, 8, 101, 11]
for (id, problem) in problems[problem_set_name]
    @info "Testing: $(problem_set_name)_$id"
    # optimizer = TreeSA(ntrials=1, niters=5, βs=0.1:0.1:100)
    optimizer = Treewidth(; alg=ND(MF(), METISND(; ufactor=150); limit=200, level=6))

    tn = TensorNetworkModel(read_model(problem); optimizer, evidence=read_evidence(problem))
    ref_sol = read_solution(problem)
    evidence = read_evidence(problem)

    # does not optimize over open vertices
    @info "Contraction complexity: $(contraction_complexity(tn)), tamaki tw = $(tamaki[id])"
end

module KaHyParExt

using OMEinsumContractionOrders: KaHyParBipartite, SparseMatrixCSC, group_sc, induced_subhypergraph, convert2int
import KaHyPar
import OMEinsumContractionOrders: bipartite_sc, BipartiteResult
using Suppressor: @suppress

function bipartite_sc(bipartiter::KaHyParBipartite, adj::SparseMatrixCSC, vertices, log2_sizes)
    n_v = length(vertices)
    subgraph, remaining_edges = induced_subhypergraph(adj, vertices)
    hypergraph = KaHyPar.HyperGraph(subgraph, ones(n_v), convert2int(log2_sizes[remaining_edges]))
    local best_part0, best_part1
    best_sc = typemax(Int)
    for imbalance in bipartiter.imbalances
        parts = @suppress KaHyPar.partition(hypergraph, 2; imbalance=imbalance, configuration=:edge_cut)
        part0 = vertices[parts .== 0]
        part1 = vertices[parts .== 1]
        sc0, sc1 = group_sc(adj, part0, log2_sizes), group_sc(adj, part1, log2_sizes)
        sc = max(sc0, sc1)
        if sc <= best_sc
            best_sc = sc
            best_part0, best_part1 = part0, part1
        end
        @debug "imbalance $imbalance: sc = $sc, group = ($(length(part0)), $(length(part1)))"
        if best_sc <= bipartiter.sc_target  # first encountered valid partition
            return BipartiteResult(best_part0, best_part1, best_sc, true)
        end
    end
    return BipartiteResult(best_part0, best_part1, best_sc, false)
end

@debug "`OMEinsumContractionOrders` loads `KaHyParExt` extension successfully."
end

"""
    writejson(filename::AbstractString, ne::Union{NestedEinsum, SlicedEinsum})

Write the contraction order to a JSON file.

# Arguments
- `filename`: the name of the file to write to.
- `ne`: the contraction order to write. It can be a [`NestedEinsum`](@ref) or a [`SlicedEinsum`](@ref) object.
"""
function writejson(filename::AbstractString, ne::Union{NestedEinsum, SlicedEinsum})
    dict = _todict(ne)
    open(filename, "w") do f
        JSON.print(f, dict, 0)
    end
end
function _todict(ne::SlicedEinsum)
    dict = _todict(ne.eins)
    dict["slices"] = ne.slicing
    return dict
end
function _todict(ne::NestedEinsum)
    LT = labeltype(ne)
    dict = Dict{String,Any}("label-type"=>string(LT), "inputs"=>getixsv(ne), "output"=>getiyv(ne))
    dict["tree"] = todict(ne)
    return dict
end

"""
    readjson(filename::AbstractString)

Read the contraction order from a JSON file.

# Arguments
- `filename`: the name of the file to read from.
"""
function readjson(filename::AbstractString)
    dict = JSON.parsefile(filename)
    return _fromdict(dict)
end
function _fromdict(dict)
    lt = dict["label-type"]
    LT = if lt == "Char"
        Char
    elseif lt ∈ ("Int64", "Int", "Int32")
        Int
    else
        error("label type `$lt` not known.")
    end
    ne = fromdict(LT, dict["tree"])
    if haskey(dict, "slices")
        return SlicedEinsum(LT[_convert(LT, l) for l in dict["slices"]], ne)
    else
        return ne
    end
end

function todict(ne::NestedEinsum)
    dict = Dict{String,Any}()
    if isleaf(ne)
        dict["isleaf"] = true
        dict["tensorindex"] = ne.tensorindex
        return dict
    end
    dict["args"] = collect(todict.(ne.args))
    dict["eins"] = einstodict(ne.eins)
    dict["isleaf"] = false
    return dict
end
function einstodict(eins::EinCode)
    ixs = getixsv(eins)
    iy = getiyv(eins)
    return Dict("ixs"=>ixs, "iy"=>iy)
end

function fromdict(::Type{LT}, dict::AbstractDict) where LT
    if dict["isleaf"]
        return NestedEinsum{LT}(dict["tensorindex"])
    end
    eins = einsfromdict(LT, dict["eins"])
    return NestedEinsum(fromdict.(LT, dict["args"]), eins)
end

function einsfromdict(::Type{LT}, dict::AbstractDict) where LT
    return EinCode([collect(LT, _convert.(LT, ix)) for ix in dict["ixs"]], collect(LT, _convert.(LT, dict["iy"])))
end

_convert(::Type{LT}, x) where LT = convert(LT, x)
_convert(::Type{Char}, x::String) = (@assert length(x)==1; x[1])

using TensorQEC, OMEinsumContractionOrders

function main(optimizer)
    @info "Running QEC with optimizer: $(optimizer)"
    for d in [9, 13, 17, 21]
        @info "Running surface code for d = $d"
        tanner = CSSTannerGraph(SurfaceCode(d, d))
        time_elapsed = @elapsed ct = compile(TNMAP(; optimizer),tanner)

        # NOTE: TreeSA gives sc = 16, tc=21.74 for d = 9
        @info "Contraction complexity: $(contraction_complexity(ct.cd.net)), time cost: $(time_elapsed)s"
        return contraction_complexity(ct.cd.net)
    end
end

using OMEinsumContractionOrders
using Test
using Documenter
using Aqua

@testset "Aqua" begin
    # Supressor does not pass the stale_deps test
    Aqua.test_all(OMEinsumContractionOrders; stale_deps = false)
end

@testset "Core" begin
    include("Core.jl")
end

@testset "utils" begin
    include("utils.jl")
end

@testset "greedy" begin
    include("greedy.jl")
end

@testset "sabipartite" begin
    include("sabipartite.jl")
end

if isdefined(Base, :get_extension)
    @testset "kahypar" begin
        include("kahypar.jl")
    end
end

@testset "treesa" begin
    include("treesa.jl")
end

@testset "treesaslicer" begin
    include("treesaslicer.jl")
end

@testset "treewidth" begin
    include("treewidth.jl")
end

@testset "exhaustivesearch" begin
    include("exhaustivesearch.jl")
end

@testset "hypernd" begin
    include("hypernd.jl")
end

@testset "simplify" begin
    include("simplify.jl")
end

@testset "interfaces" begin
    include("interfaces.jl")
end

@testset "json" begin
    include("json.jl")
end

# testing the extension `LuxorTensorPlot` for visualization
if isdefined(Base, :get_extension)
    @testset "visualization" begin
        include("visualization.jl")
    end
end

DocMeta.setdocmeta!(OMEinsumContractionOrders, :DocTestSetup, :(using OMEinsumContractionOrders); recursive=true)
Documenter.doctest(OMEinsumContractionOrders; manual=false, fix=false)

"""
    HyperND(;
        dis = KaHyParND(),
        algs = (MF(), AMF(), MMD()),
        level = 6,
        width = 120,
        scale = 100,
        imbalances = 130:130,
        score = ScoreFunction(),
    )

Nested-dissection based optimizer. Recursively partitions a tensor network, then calls a
greedy algorithm on the leaves. The optimizer is run a number of times: once for each greedy
algorithm in `algs` and each imbalance value in `imbalances`. The recursion depth is controlled by
the parameters `level` and `width`. The parameter `scale` controls discretization of the index weights:

    weight(i) := scale * log2(dim(i))

where dim(i) is the dimension of the index i.

The line graph is partitioned using the algorithm `dis`. OMEinsumContractionOrders currently supports two partitioning
algorithms, both of which require importing an external library.

| type                                                                                             | package                                              |
|:-------------------------------------------------------------------------------------------------|:-----------------------------------------------------|
| [`METISND`](https://algebraicjulia.github.io/CliqueTrees.jl/stable/api/#CliqueTrees.METISND)     | [Metis.jl](https://github.com/JuliaSparse/Metis.jl)  |
| [`KaHyParND`](https://algebraicjulia.github.io/CliqueTrees.jl/stable/api/#CliqueTrees.KaHyParND) | [KayHyPar.jl](https://github.com/kahypar/KaHyPar.jl) |

The optimizer is implemented using the tree decomposition library
[CliqueTrees.jl](https://github.com/AlgebraicJulia/CliqueTrees.jl).

# Arguments

- `dis`: [graph partitioning algorithm](https://algebraicjulia.github.io/CliqueTrees.jl/stable/api/#CliqueTrees.DissectionAlgorithm)
- `algs`: tuple of [elimination algorithms](https://algebraicjulia.github.io/CliqueTrees.jl/stable/api/#Elimination-Algorithms).
- `level`: maximum level
- `width`: minimum width
- `imbalances`: imbalance parameters 
- `score`: a function to evaluate the quality of the contraction tree. Default is `ScoreFunction()`.
"""
@kwdef struct HyperND{D, A} <: CodeOptimizer
    dis::D = KaHyParND()
    algs::A = (MF(), AMF(), MMD())
    level::Int = 6
    width::Int = 50
    scale::Int = 100
    imbalances::StepRange{Int, Int} = 100:10:800
    score::ScoreFunction = ScoreFunction()
end

function optimize_hyper_nd(optimizer::HyperND, code::AbstractEinsum, size_dict::Dict; binary::Bool=true)
    optimize_hyper_nd(optimizer, getixsv(code), getiyv(code), size_dict; binary)
end

function optimize_hyper_nd(optimizer::HyperND, ixs::AbstractVector{<:AbstractVector}, iy::AbstractVector, size_dict::Dict; binary::Bool=true)
    dis = optimizer.dis
    algs = optimizer.algs
    level = optimizer.level
    width = optimizer.width
    scale = optimizer.scale
    imbalances = optimizer.imbalances
    score = optimizer.score

    minscore = typemax(Float64)
    local mincode

    for imbalance in imbalances
        curalg = SafeRules(ND(BestWidth(algs), dis; level, width, scale, imbalance))
        curopt = Treewidth(; alg=curalg)
        curcode = optimize_treewidth(curopt, ixs, iy, size_dict; binary=false)
        curtc, cursc, currw = __timespacereadwrite_complexity(curcode, size_dict)

        if score(curtc, cursc, currw) < minscore
            minscore, mincode = score(curtc, cursc, currw), curcode
        end
    end

    if binary
        mincode = _optimize_code(mincode, size_dict, GreedyMethod())
    end

    return mincode
end

function Base.show(io::IO, ::MIME"text/plain", optimizer::HyperND{D, A}) where {D, A}
    println(io, "HyperND{$D, $A}:")
    show(IOContext(io, :indent => 4), "text/plain", optimizer.dis)

    for alg in optimizer.algs
        show(IOContext(io, :indent => 4), "text/plain", alg)
    end

    println(io, "    level: $(optimizer.level)")
    println(io, "    width: $(optimizer.width)")
    println(io, "    scale: $(optimizer.scale)")
    println(io, "    imbalances: $(optimizer.imbalances)")
    println(io, "    score: $(optimizer.score)")
    return
end

################### expression tree ###################
# `ExprInfo` stores the node information.
# * `out_dims` is the output dimensions of this tree/subtree.
# * `tensorid` specifies the tensor index for leaf nodes. It is `-1` is for non-leaf node.
struct ExprInfo
    out_dims::Vector{Int}
    tensorid::Int
end
ExprInfo(out_dims::Vector{Int}) = ExprInfo(out_dims, -1)

# `ExprTree` is the expression tree for tensor contraction (or contraction tree), it is a binary tree (including leaf nodes without siblings).
# `left` and `right` are left and right branches, they are either both specified (non-leaf) or both unspecified (leaf), see [`isleaf`](@ref) function.
# `ExprTree()` for constructing a leaf node,
# `ExprTree(left, right, info)` for constructing a non-leaf node.
mutable struct ExprTree
    left::ExprTree
    right::ExprTree
    info::ExprInfo
    ExprTree(info) = (res = new(); res.info=info; res)
    ExprTree(left, right, info) = new(left, right, info)
end
function print_expr(io::IO, expr::ExprTree, level=0)
    isleaf(expr) && return print(io, " "^(2*level), labels(expr), " ($(expr.info.tensorid))")
    print(io, " "^(2*level), "(\n")
    print_expr(io, expr.left, level+1)
    print("\n")
    print_expr(io, expr.right, level+1)
    print("\n")
    print(io, " "^(2*level), ") := ", labels(expr))
end
# if `expr` is a leaf, it should have `left` and `right` fields both unspecified.
isleaf(expr::ExprTree) = !isdefined(expr, :left)
Base.show(io::IO, expr::ExprTree) = print_expr(io, expr, 0)
Base.show(io::IO, ::MIME"text/plain", expr::ExprTree) = show(io, expr)
siblings(t::ExprTree) = isleaf(t) ? ExprTree[] : ExprTree[t.left, t.right]
Base.copy(t::ExprTree) = isleaf(t) ? ExprTree(t.info) : ExprTree(copy(t.left), copy(t.right), copy(t.info))
Base.copy(info::ExprInfo) = ExprInfo(copy(info.out_dims), info.tensorid)
# output tensor labels
labels(t::ExprTree) = t.info.out_dims
# find the maximum label recursively, this is a helper function for converting an expression tree back to einsum.
maxlabel(t::ExprTree) = isleaf(t) ? maximum(isempty(labels(t)) ? 0 : labels(t)) : max(isempty(labels(t)) ? 0 : maximum(labels(t)), maxlabel(t.left), maxlabel(t.right))
# comparison between `ExprTree`s, mainly for testing
Base.:(==)(t1::ExprTree, t2::ExprTree) = _equal(t1, t2)
Base.:(==)(t1::ExprInfo, t2::ExprInfo) = _equal(t1.out_dims, t2.out_dims) && t1.tensorid == t2.tensorid
function _equal(t1::ExprTree, t2::ExprTree)
    isleaf(t1) != isleaf(t2) && return false
    isleaf(t1) ? t1.info == t2.info : _equal(t1.left, t2.left) && _equal(t1.right, t2.right) && t1.info == t2.info
end
_equal(t1::Vector, t2::Vector) = Set(t1) == Set(t2)


############# random expression tree ###############
function random_exprtree(code::EinCode, decomposition_type::AbstractDecompositionType)
    ixs, iy = getixsv(code), getiyv(code)
    labels = _label_dict(ixs, iy)
    return random_exprtree([Int[labels[l] for l in ix] for ix in ixs], Int[labels[l] for l in iy], length(labels), decomposition_type)
end

function random_exprtree(ixs::Vector{Vector{Int}}, iy::Vector{Int}, nedge::Int, decomposition_type::AbstractDecompositionType)
    outercount = zeros(Int, nedge)
    allcount = zeros(Int, nedge)
    for l in iy
        outercount[l] += 1
        allcount[l] += 1
    end
    for ix in ixs
        for l in ix
            allcount[l] += 1
        end
    end
    _random_exprtree(ixs, collect(1:length(ixs)), outercount, allcount, decomposition_type)
end
function _random_exprtree(ixs::Vector{Vector{Int}}, xindices, outercount::Vector{Int}, allcount::Vector{Int}, decomposition_type::AbstractDecompositionType)
    n = length(ixs)
    if n == 1
        return ExprTree(ExprInfo(ixs[1], xindices[1]))
    end
    if decomposition_type == TreeDecomp()
        mask = rand(Bool, n)
        if all(mask) || !any(mask)  # prevent invalid partition
            i = rand(1:n)
            mask[i] = ~(mask[i])
        end
    else
        mask = fill(true, n); mask[end] = false  # for path decomposition, the last nodes belongs to the right tree
    end
    info = ExprInfo(Int[i for i=1:length(outercount) if outercount[i]!=allcount[i] && outercount[i]!=0])
    outercount1, outercount2 = copy(outercount), copy(outercount)
    for i=1:n
        counter = mask[i] ? outercount2 : outercount1
        for l in ixs[i]
            counter[l] += 1
        end
    end
    return ExprTree(_random_exprtree(ixs[mask], xindices[mask], outercount1, allcount, decomposition_type), _random_exprtree(ixs[(!).(mask)], xindices[(!).(mask)], outercount2, allcount, decomposition_type), info)
end


##################### convert a contraction tree back to a nested einsum ####################
NestedEinsum(expr::ExprTree) = _nestedeinsum(expr, 1:maxlabel(expr))
NestedEinsum(expr::ExprTree, labelmap) = _nestedeinsum(expr, labelmap)
function _nestedeinsum(tree::ExprTree, lbs::Union{AbstractVector{LT}, Dict{Int,LT}}) where LT
    isleaf(tree) && return NestedEinsum{LT}(tree.info.tensorid)
    eins = EinCode([getindex.(Ref(lbs), labels(tree.left)), getindex.(Ref(lbs), labels(tree.right))], getindex.(Ref(lbs), labels(tree)))
    NestedEinsum([_nestedeinsum(tree.left, lbs), _nestedeinsum(tree.right, lbs)], eins)
end


##################### The main program ##############################
"""
    TreeSA{IT, DT} <: CodeOptimizer
    TreeSA(; βs=collect(0.01:0.05:15), ntrials=10, niters=50, initializer=:greedy, score=ScoreFunction(), decomposition_type=TreeDeomp())

Optimize the einsum contraction pattern using the simulated annealing on tensor expression tree.

# Fields
- `ntrials`, `βs` and `niters` are annealing parameters, doing `ntrials` indepedent annealings, each has inverse tempteratures specified by `βs`, in each temperature, do `niters` updates of the tree.
- `initializer` specifies how to determine the initial configuration, it can be `:greedy`, `:random` or `:specified`. If the initializer is `:specified`, the input `code` should be a `NestedEinsum` object.
- `score` specifies the score function to evaluate the quality of the contraction tree, it is a function of time complexity, space complexity and read-write complexity.
- `decomposition_type` specifies the type of decomposition to use, it can be `TreeDeomp` or `PathDecomp`.

# References
- [Recursive Multi-Tensor Contraction for XEB Verification of Quantum Circuits](https://arxiv.org/abs/2108.05665)

# Breaking changes:
- `nslices` is removed, since the slicing part is now separated from the optimization part, see `slice_code` function and `TreeSASlicer`.
- `greedy_method` is removed. If you want to have detailed control of the initializer, please pre-optimize the code with another method and then use `:specified` to initialize the tree.
"""
Base.@kwdef struct TreeSA{IT, DT <: AbstractDecompositionType} <: CodeOptimizer
    βs::IT = 0.01:0.05:15
    ntrials::Int = 10
    niters::Int = 50
    initializer::Symbol = :greedy
    score::ScoreFunction = ScoreFunction()
    decomposition_type::DT = TreeDecomp()
end

const PathSA = TreeSA{<:Any, PathDecomp}
"""
    PathSA(; βs=0.01:0.05:15, ntrials=10, niters=50, score=ScoreFunction())

Optimize the einsum contraction pattern using the simulated annealing on tensor expression tree, with path decomposition.

# Fields
- `βs`, `ntrials`, `niters` and `score` are the same as in [`TreeSA`](@ref).
"""
function PathSA(; βs=0.01:0.05:15, ntrials=10, niters=50, score=ScoreFunction())
    TreeSA(; βs, ntrials, niters, score, initializer=:random, decomposition_type=PathDecomp())
end

# this is the main function
"""
    optimize_tree(code, size_dict; βs, ntrials, niters, initializer, score)

Optimize the einsum contraction pattern specified by `code`, and edge sizes specified by `size_dict`.
Check the docstring of [`TreeSA`](@ref) for detailed explaination of other input arguments.
"""
function optimize_tree(code::AbstractEinsum, size_dict::Dict{LT,Int}; βs, ntrials, niters, initializer, score, decomposition_type) where LT
    # get input labels (`getixsv`) and output labels (`getiyv`) in the einsum code.
    ixs, iy = getixsv(code), getiyv(code)
    ninputs = length(ixs)  # number of input tensors
    if ninputs <= 2  # number of input tensors ≤ 2, can not be optimized
        return NestedEinsum(NestedEinsum{LT}.(1:ninputs), EinCode(ixs, iy))
    end

    ###### Stage 1: preprocessing ######
    labels = _label_dict(ixs, iy)  # map labels to integers
    inverse_map = Dict([v=>k for (k,v) in labels])  # the inverse transformation, map integers to labels
    log2_sizes = [log2.(size_dict[inverse_map[i]]) for i=1:length(labels)]   # use `log2` sizes in computing time

    if ntrials <= 0  # no optimization at all, then 1). initialize an expression tree and 2). convert back to nested einsum.
        best_tree = _initializetree(code, size_dict, initializer, decomposition_type)
        return NestedEinsum(best_tree, inverse_map)
    end

    ###### Stage 2: computing ######
    # create vectors to store optimized 1). expression tree, 2). time complexities, 3). space complexities, 4). read-write complexities.

    trees = Vector{ExprTree}(undef, ntrials)
    tcs = Vector{Float64}(undef, ntrials)
    scs = Vector{Float64}(undef, ntrials)
    rws = Vector{Float64}(undef, ntrials)

    @threads for t = 1:ntrials  # multi-threading on different trials, use `JULIA_NUM_THREADS=5 julia xxx.jl` for setting number of threads.

        # 1). random/greedy initialize a contraction tree.
        tree = _initializetree(code, size_dict, initializer, decomposition_type)

        # 2). optimize the `tree` in a inplace manner.
        optimize_tree_sa!(tree, log2_sizes; βs, niters, score, decomposition_type)

        # 3). evaluate time-space-readwrite complexities.
        tc, sc, rw = tree_timespace_complexity(tree, log2_sizes)
        @debug "trial $t, time complexity = $tc, space complexity = $sc, read-write complexity = $rw."
        trees[t] = tree
        tcs[t] = tc
        scs[t] = sc
        rws[t] = rw
    end

    local best_tree, best_tc, best_sc, best_rw
    for t = 1:ntrials
        if t == 1 || score(tcs[t], scs[t], rws[t]) < score(best_tc, best_sc, best_rw)
            best_tree, best_tc, best_sc, best_rw = trees[t], tcs[t], scs[t], rws[t]
        end
    end

    ###### Stage 3: postprocessing ######
    @debug "best space complexities = $best_tc, time complexity = $best_sc, read-write complexity $best_rw."
    return NestedEinsum(best_tree, inverse_map)
end

# initialize a contraction tree
function _initializetree(code, size_dict, method, decomposition_type)
    # for path decomposition, only random initialization is supported
    if decomposition_type == PathDecomp()
        method != :random && warn("only random initialization is supported for path decomposition, got: $method")  # only random initialization is supported for path decomposition
        return random_exprtree(code, decomposition_type)
    end
    if method == :greedy
        labels = _label_dict(code)  # label to int
        return _exprtree(optimize_greedy(code, size_dict; α = 0.0, temperature = 0.0), labels)
    elseif method == :random
        return random_exprtree(code, decomposition_type)
    elseif method == :specified
        labels = _label_dict(code)  # label to int
        return _exprtree(code, labels)
    else
        throw(ArgumentError("intializier `$method` is not defined!"))
    end
end

# use simulated annealing to optimize a contraction tree
function optimize_tree_sa!(tree::ExprTree, log2_sizes; βs, niters, score, decomposition_type)
    log2rw_weight = log2(score.rw_weight)

    tc, sc, rw = tree_timespace_complexity(tree, log2_sizes)
    @debug "Initial tc = $tc, sc = $sc, rw = $rw"
    
    for β in βs
        for _ = 1:niters
            optimize_subtree!(tree, β, log2_sizes, score.sc_target, score.sc_weight, log2rw_weight, decomposition_type)  # single sweep
        end
    end

    tc, sc, rw = tree_timespace_complexity(tree, log2_sizes)
    @debug "After optimization: tc = $tc, sc = $sc, rw = $rw"

    return tree
end

# the time-space-readwrite complexity of a contraction tree
function tree_timespace_complexity(tree::ExprTree, log2_sizes)
    isleaf(tree) && return (-Inf, isempty(labels(tree)) ? 0.0 : sum(i->log2_sizes[i], labels(tree)), -Inf)
    tcl, scl, rwl = tree_timespace_complexity(tree.left, log2_sizes)
    tcr, scr, rwr = tree_timespace_complexity(tree.right, log2_sizes)
    tc, sc, rw = tcscrw(labels(tree.left), labels(tree.right), labels(tree), log2_sizes, true)
    return (fast_log2sumexp2(tc, tcl, tcr), max(sc, scl, scr), fast_log2sumexp2(rw, rwl, rwr))
end

# returns time complexity, space complexity and read-write complexity (0 if `compute_rw` is false)
# `ix1` and `ix2` are vectors of labels for the first and second input tensors.
# `iy` is a vector of labels for the output tensors.
# `log2_sizes` is the log2 size of labels (note labels are integers, we do not need dict to index label sizes).\
@inline function tcscrw(ix1, ix2, iy, log2_sizes::Vector{T}, compute_rw) where T
    l1, l2, l3 = ix1, ix2, iy
    sc1 = (!compute_rw || isempty(l1)) ? zero(T) : sum(i->(@inbounds log2_sizes[i]), l1)
    sc2 = (!compute_rw || isempty(l2)) ? zero(T) : sum(i->(@inbounds log2_sizes[i]), l2)
    sc = isempty(l3) ? zero(T) : sum(i->(@inbounds log2_sizes[i]), l3)
    tc = sc
    # Note: assuming labels in `l1` being unique
    @inbounds for l in l1
        if l ∈ l2 && l ∉ l3
            tc += log2_sizes[l]
        end
    end
    rw = compute_rw ? fast_log2sumexp2(sc, sc1, sc2) : 0.0
    return tc, sc, rw
end

# optimize a contraction tree recursively
function optimize_subtree!(tree, β, log2_sizes, sc_target, sc_weight, log2rw_weight, decomposition_type)
    # find appliable local rules, at most 4 rules can be applied.
    # Sometimes, not all rules are applicable because either left or right sibling do not have siblings.
    rst = ruleset(decomposition_type, tree)
    if !isempty(rst)
        # propose a random update rule, TODO: can we have a better selector?
        rule = rand(rst)
        optimize_rw = log2rw_weight != -Inf
        # difference in time, space and read-write complexity if the selected rule is applied
        tc0, tc1, dsc, rw0, rw1, subout = tcsc_diff(tree, rule, log2_sizes, optimize_rw)
        dtc = optimize_rw ? fast_log2sumexp2(tc1, log2rw_weight + rw1) - fast_log2sumexp2(tc0, log2rw_weight + rw0) : tc1 - tc0
        sc = _sc(tree, rule, log2_sizes)  # current space complexity

        # update the loss function
        dE = (max(sc, sc+dsc) > sc_target ? sc_weight : 0) * dsc + dtc
        if rand() < exp(-β*dE)  # ACCEPT
            update_tree!(tree, rule, subout)
        end
        for subtree in siblings(tree)  # RECURSE
            optimize_subtree!(subtree, β, log2_sizes, sc_target, sc_weight, log2rw_weight, decomposition_type)
        end
    end
end
# if rule ∈ [1, 2], left sibling will be updated, otherwise, right sibling will be updated.
# we need to compute space complexity for current node and the updated sibling, and return the larger one.
_sc(tree, rule, log2_sizes) = max(__sc(tree, log2_sizes), __sc((rule == 1 || rule == 2) ? tree.left : tree.right, log2_sizes))
__sc(tree, log2_sizes) = length(labels(tree))==0 ? 0.0 : sum(l->log2_sizes[l], labels(tree)) # space complexity of current node

@inline function ruleset(::TreeDecomp, tree::ExprTree)
    if isleaf(tree) || (isleaf(tree.left) && isleaf(tree.right))
        return 1:0
    elseif isleaf(tree.right)
        return 1:2
    elseif isleaf(tree.left)
        return 3:4
    else
        return 1:4
    end
end

@inline function ruleset(::PathDecomp, tree::ExprTree)
    @assert isleaf(tree) || isleaf(tree.right)  # for path decomposition, the right tree must be a leaf
    if isleaf(tree)
        return 1:0
    elseif isleaf(tree.left)  # SWAP on leaves
        return 5:5
    else
        return 1:1
    end
end

function tcsc_diff(tree::ExprTree, rule, log2_sizes, optimize_rw)
    if rule == 1 # (a,b), c -> (a,c),b
        return abcacb(labels(tree.left.left), labels(tree.left.right), labels(tree.left), labels(tree.right), labels(tree), log2_sizes, optimize_rw)
    elseif rule == 2 # (a,b), c -> (c,b),a
        return abcacb(labels(tree.left.right), labels(tree.left.left), labels(tree.left), labels(tree.right), labels(tree), log2_sizes, optimize_rw)
    elseif rule == 3 # a,(b,c) -> b,(a,c)
        return abcacb(labels(tree.right.right), labels(tree.right.left), labels(tree.right), labels(tree.left), labels(tree), log2_sizes, optimize_rw)
    elseif rule == 4 # a,(b,c) -> c,(b,a)
        return abcacb(labels(tree.right.left), labels(tree.right.right), labels(tree.right), labels(tree.left), labels(tree), log2_sizes, optimize_rw)
    elseif rule == 5 # a,b -> b,a
        tc0, sc0, rw0 = tcscrw(labels(tree.left), labels(tree.right), labels(tree), log2_sizes, optimize_rw)
        return tc0, tc0, zero(sc0), rw0, rw0, labels(tree)
    else
        error("Rule $rule is not defined!")
    end
end

# compute the time complexity, space complexity and read-write complexity information for the contraction update rule "((a,b),c) -> ((a,c),b)"
function abcacb(a, b, ab, c, d, log2_sizes, optimize_rw)
    tc0, sc0, rw0 = _tcsc_merge(a, b, ab, c, d, log2_sizes, optimize_rw)
    ac = Int[]  # labels for contraction result of (a, c)
    for l in a
        if l ∈ b || l ∈ d  # suppose no repeated indices
            push!(ac, l)
        end
    end
    for l in c
        if l ∉ a && (l ∈ b || l ∈ d)  # suppose no repeated indices
            push!(ac, l)
        end
    end
    tc1, sc1, rw1 = _tcsc_merge(a, c, ac, b, d, log2_sizes, optimize_rw)
    return tc0, tc1, sc1-sc0, rw0, rw1, ac
end

# compute complexity for a two-step contraction: (a, b) -> ab, (ab, c) -> d
function _tcsc_merge(a, b, ab, c, d, log2_sizes, optimize_rw)
    tcl, scl, rwl = tcscrw(a, b, ab, log2_sizes, optimize_rw)  # this is correct
    tcr, scr, rwr = tcscrw(ab, c, d, log2_sizes, optimize_rw)
    fast_log2sumexp2(tcl, tcr), max(scl, scr), (optimize_rw ? fast_log2sumexp2(rwl, rwr) : 0.0)
end

# apply the update rule
function update_tree!(tree::ExprTree, rule::Int, subout)
    if rule == 1 # (a,b), c -> (a,c),b
        b, c = tree.left.right, tree.right
        tree.left.right = c
        tree.right = b
        tree.left.info = ExprInfo(subout)
    elseif rule == 2 # (a,b), c -> (c,b),a
        a, c = tree.left.left, tree.right
        tree.left.left = c
        tree.right = a
        tree.left.info = ExprInfo(subout)
    elseif rule == 3 # a,(b,c) -> b,(a,c)
        a, b = tree.left, tree.right.left
        tree.left = b
        tree.right.left = a
        tree.right.info = ExprInfo(subout)
    elseif rule == 4 # a,(b,c) -> c,(b,a)
        a, c = tree.left, tree.right.right
        tree.left = c
        tree.right.right = a
        tree.right.info = ExprInfo(subout)
    elseif rule == 5 # a,b -> b,a
        a, b = tree.left, tree.right
        tree.left = b
        tree.right = a
    else
        error("Rule $rule is not defined!")
    end
    return tree
end

# map labels to integers.
_label_dict(code) = _label_dict(getixsv(code), getiyv(code))
function _label_dict(ixsv::AbstractVector{<:AbstractVector{LT}}, iyv::AbstractVector{LT}) where LT
    v = unique(vcat(ixsv..., iyv))
    labels = Dict{LT,Int}(zip(v, 1:length(v)))
    return labels
end

# construct the contraction tree recursively from a nested einsum.
function ExprTree(code::NestedEinsum)
    _exprtree(code, _label_dict(code))
end
function _exprtree(code::NestedEinsum, labels)
    @assert length(code.args) == 2 "einsum contraction not in the binary form, got number of arguments: $(length(code.args))"
    ExprTree(map(enumerate(code.args)) do (i,arg)
        if isleaf(arg)  # leaf nodes
            ExprTree(ExprInfo(getindex.(Ref(labels), getixsv(code.eins)[i]), arg.tensorindex))
        else
            res = _exprtree(arg, labels)
        end
    end..., ExprInfo(Int[labels[i] for i=getiyv(code.eins)]))
end

@inline function fast_log2sumexp2(a, b)
    mm, ms = minmax(a, b)
    return log2(exp2(mm - ms) + 1) + ms
end

@inline function fast_log2sumexp2(a, b, c)
    if a > b
        if a > c
            m1, m2, ms = b, c, a
        else
            m1, m2, ms = a, b, c
        end
    else
        if b > c
            m1, m2, ms = c, a, b
        else
            m1, m2, ms = b, a, c
        end
    end
    return Base.FastMath.log2(Base.FastMath.exp2(m1 - ms) + Base.FastMath.exp2(m2 - ms) + 1) + ms
end

using GenericTensorNetworks, GenericTensorNetworks.Graphs, OMEinsumContractionOrders

function main(optimizer)
    @info "Running independent set with optimizer: $(optimizer)"
    return [single_run(optimizer, case) for case in [:rg3, :ksg]]
end

function single_run(optimizer, case)
    if case == :rg3
        @info "Random 3-regular graph of size 200"
        graph = Graphs.random_regular_graph(200, 3; seed=42)
    elseif case == :ksg
        @info "Random diagonal coupled graph (King's subgraph, or KSG) of size 40"
        graph = GenericTensorNetworks.random_diagonal_coupled_graph(40, 40, 0.8)
    else
        error("Invalid case: $case")
    end
    time_elapsed = @elapsed net = GenericTensorNetwork(IndependentSet(graph); optimizer)
    @info "Contraction complexity: $(contraction_complexity(net)), time cost: $(time_elapsed)s"
    return contraction_complexity(net)
end

using OMEinsumContractionOrders
using OMEinsumContractionOrders: log2sumexp2, _log2_size_dict, convert_label
using Test

@testset "log2sumexp2" begin
    @test log2sumexp2([1.0, 2.0, 3.0]) ≈ log2(exp2(1.0) + exp2(2.0) + exp2(3.0))
    @test log2sumexp2([10.0, 10.0]) ≈ 11.0
    @test log2sumexp2([0.0]) ≈ 0.0
end

@testset "_log2_size_dict" begin
    size_dict = Dict('a' => 2, 'b' => 4, 'c' => 8)
    log2_dict = _log2_size_dict(size_dict)
    @test log2_dict['a'] ≈ 1.0
    @test log2_dict['b'] ≈ 2.0
    @test log2_dict['c'] ≈ 3.0
end

@testset "convert_label" begin
    # Single leaf
    ne = OMEinsumContractionOrders.NestedEinsum{Char}(1)
    labelmap = Dict{Char, Int}()
    result = convert_label(ne, labelmap)
    @test result.tensorindex == 1
    
    # Simple contraction
    ne = OMEinsumContractionOrders.NestedEinsum([OMEinsumContractionOrders.NestedEinsum{Char}(1), OMEinsumContractionOrders.NestedEinsum{Char}(2)], 
                      OMEinsumContractionOrders.EinCode([['a','b'], ['b','c']], ['a','c']))
    labelmap = Dict('a' => 1, 'b' => 2, 'c' => 3)
    result = convert_label(ne, labelmap)
    @test result.eins.ixs == [[1,2], [2,3]]
    @test result.eins.iy == [1,3]
end

using OMEinsumContractionOrders
using Documenter
using DocThemeIndigo

DocMeta.setdocmeta!(OMEinsumContractionOrders, :DocTestSetup, :(using OMEinsumContractionOrders); recursive=true)
indigo = DocThemeIndigo.install(OMEinsumContractionOrders)

makedocs(;
    modules=[OMEinsumContractionOrders],
    authors="GiggleLiu <cacate0129@gmail.com> and contributors",
    sitename="OMEinsumContractionOrders.jl",
    format=Documenter.HTML(;
        canonical="https://GiggleLiu.github.io/OMEinsumContractionOrders.jl",
        edit_link="master",
        assets=String[indigo],
    ),
    doctest = ("doctest=true" in ARGS),
    pages=[
        "Home" => "index.md",
        "Background Knowledge" => "background.md",
        "Tutorial" => "tutorial.md",
        "Choosing Optimizers" => "optimizers.md",
        "Reference" => "ref.md",
    ],
)

deploydocs(;
    repo="github.com/TensorBFS/OMEinsumContractionOrders.jl",
    devbranch="master",
)

using GenericTensorNetworks, Graphs, Metis, OMEinsumContractionOrders

@info "Random 3-regular graph of size 200"
rg3 = Graphs.random_regular_graph(200, 3; seed=42)

problem = IndependentSet(rg3)
optimizer = Treewidth(; alg=ND(MF(), METISND(; ufactor=150); limit=200, level=6))

@info "Using optimizer: $(optimizer)"
net = GenericTensorNetwork(problem; optimizer)
@info "The generated tensor network is: $(net)"

@info "Random diagonal coupled graph (King's subgraph, or KSG) of size 40"
ksg = GenericTensorNetworks.random_diagonal_coupled_graph(40, 40, 0.8)

problem = IndependentSet(ksg)
net = GenericTensorNetwork(problem; optimizer)
@info "The generated tensor network is: $(net)"

# Exact ("netcon") contraction-order optimizer.
#
# This is a port of the `optimaltree` routine from TensorOperations.jl
# (https://github.com/Jutho/TensorOperations.jl, MIT licensed), which implements
# the cost-capped breadth-first dynamic program of
#
#   Pfeifer, R.N.C., Haegeman, J., Verstraete, F., 2014.
#   Faster identification of optimal contraction sequences for tensor networks.
#   Phys. Rev. E 90, 033315. https://doi.org/10.1103/PhysRevE.90.033315
#
# The algorithm finds the binary contraction tree that minimizes the *total*
# contraction cost within each connected component. Disconnected components are
# combined cheapest-first via outer products. Costs are accumulated in `Float64`
# to avoid integer overflow on large networks.
#
# Compared with the original, this version is adapted to OMEinsum's
# representation: it tracks each label's occurrence set explicitly (so it
# supports hyperedges and batch/diagonal output indices), seeds the cost cap
# per connected component from a greedy contraction, and builds the output
# `NestedEinsum` directly from the search state.

"""
    ExhaustiveSearch <: CodeOptimizer
    ExhaustiveSearch(; verbose = false)

Exact contraction-order optimizer based on the cost-capped breadth-first dynamic
program of Pfeifer, Haegeman and Verstraete (2014) (the "netcon" algorithm),
ported from [TensorOperations.jl](https://github.com/Jutho/TensorOperations.jl).

It returns a contraction tree that minimizes the total contraction cost within
each connected component (the sum of FLOPs over all pairwise contractions, i.e.
the time complexity `tc`). Disconnected components are combined cheapest-first
via outer products. This is complementary to [`ExactTreewidth`](@ref), which
instead minimizes the treewidth (the size of the largest intermediate tensor,
i.e. the space complexity `sc`).

The search is exponential in the number of tensors; it is intended for small to
moderate networks (a few tens of tensors). The cost cap of each connected
component is seeded with a greedy contraction, so the search typically finds the
optimum in a single cost-capped pass.

# Scope
Hyperedges (a label shared by more than two tensors) and batch/diagonal output
indices are supported. Nontrivial inputs handled by the dynamic program reject
two cases with an `ArgumentError`: a label that appears more than once within a
single tensor (a partial trace), and a label that appears once but is not an
output (a dangling summed index). Trivial one- and two-tensor inputs are returned
directly. Simplify unsupported nontrivial cases first (e.g. with a simplifier) or
use another optimizer.

# Fields
- `verbose::Bool`: print progress of the search. Default `false`.
"""
Base.@kwdef struct ExhaustiveSearch <: CodeOptimizer
    verbose::Bool = false
end

############################ set representations ############################
# Subsets of tensors (DP keys), subsets of labels (open-index sets) and the
# per-label occurrence sets are all stored as bit sets, using the narrowest
# unsigned integer that fits, falling back to `BitVector`.
function _storeset(::Type{BitVector}, ints, maxint)
    set = falses(maxint)
    for i in ints
        set[i] = true
    end
    return set
end
function _storeset(::Type{T}, ints, maxint) where {T <: Unsigned}
    set = zero(T)
    u = one(T)
    for i in ints
        set |= (u << (i - 1))
    end
    return set
end

_intersect(s1::T, s2::T) where {T <: Unsigned} = s1 & s2
_intersect(s1::BitVector, s2::BitVector) = s1 .& s2
_union(s1::T, s2::T) where {T <: Unsigned} = s1 | s2
_union(s1::BitVector, s2::BitVector) = s1 .| s2
_setdiff(s1::T, s2::T) where {T <: Unsigned} = s1 & (~s2)
_setdiff(s1::BitVector, s2::BitVector) = s1 .& (.~s2)
_isemptyset(s::Unsigned) = iszero(s)
_isemptyset(s::BitVector) = !any(s)
_issubset(s1, s2) = _isemptyset(_setdiff(s1, s2))  # s1 ⊆ s2
_hasbit(s::Unsigned, i) = !iszero(s & (one(s) << (i - 1)))
_hasbit(s::BitVector, i) = s[i]

############################ cost model (Float64) ############################
# Product of the dimensions of every label in a set.
function _setcost(allcosts::Vector{Float64}, set::T) where {T <: Unsigned}
    cost = 1.0
    ind = set
    n = 1
    @inbounds while !iszero(ind)
        if isodd(ind)
            cost *= allcosts[n]
        end
        ind >>= 1
        n += 1
    end
    return cost
end
function _setcost(allcosts::Vector{Float64}, set::BitVector)
    cost = 1.0
    @inbounds for n in findall(set)
        cost *= allcosts[n]
    end
    return cost
end

# A loose upper bound on the cost of contracting a component, used only as a
# safe ceiling for the cost-cap loop (the real cap is seeded from greedy). The
# cost of contracting two tensors is the product of the dimensions of every
# label on either tensor, i.e. the FLOP count of that pairwise contraction.
function _maxcost(allcosts::Vector{Float64}, indexsets)
    length(indexsets) <= 1 && return 1.0
    maxcost = 0.0
    s1 = indexsets[1]
    for n in 2:length(indexsets)
        s2 = indexsets[n]
        maxcost += _setcost(allcosts, _union(s1, s2))
        s1 = _setdiff(_union(s1, s2), _intersect(s1, s2))
    end
    return maxcost
end

# Labels of `allopen` that become fully contracted when the tensor-subset `s` is
# formed: those not in the output whose every occurrence lies inside `s`.
function _closedmask(allopen::T, s::T, tensormask::Vector{T}, iymask::T) where {T <: Unsigned}
    closed = zero(T)
    ind = allopen
    n = 1
    u = one(T)
    @inbounds while !iszero(ind)
        if isodd(ind) && iszero(iymask & (u << (n - 1))) && _issubset(tensormask[n], s)
            closed |= (u << (n - 1))
        end
        ind >>= 1
        n += 1
    end
    return closed
end
function _closedmask(allopen::BitVector, s::BitVector, tensormask::Vector{BitVector}, iymask::BitVector)
    closed = falses(length(allopen))
    @inbounds for n in findall(allopen)
        if !iymask[n] && _issubset(tensormask[n], s)
            closed[n] = true
        end
    end
    return closed
end

############################ core dynamic program ############################
# Find the optimal contraction tree of one connected component, returning the
# tree as a nested `Any[left, right]` of integer tensor positions, the open
# (uncontracted) label set of the whole component, and the optimal total cost.
function _solve_component(
        ::Type{T}, component, singleopen::Vector{T}, tensormask::Vector{T}, iymask::T,
        numtensors::Int, allcosts::Vector{Float64}, initialcost::Float64; verbose::Bool = false
    ) where {T}
    componentsize = length(component)
    if componentsize == 1
        i = component[1]
        return (i, singleopen[i], 0.0)
    end

    costdict = [Dict{T, Float64}() for _ in 1:componentsize]
    # treedict stores only the bipartition (the left-child subset key); the tree
    # is reconstructed once at the end, avoiding a nested `Any[]` alloc per merge.
    treedict = [Dict{T, T}() for _ in 1:componentsize]
    indexdict = [Dict{T, T}() for _ in 1:componentsize]
    for i in component
        s = _storeset(T, [i], numtensors)
        costdict[1][s] = 0.0
        indexdict[1][s] = singleopen[i]
    end

    costfac = maximum(allcosts)
    maxcost = max(_maxcost(allcosts, @view(singleopen[component])), initialcost)
    currentcost = min(initialcost, maxcost)
    previouscost = 0.0
    while currentcost <= maxcost
        nextcost = maxcost
        for n in 2:componentsize
            verbose && println("Component $(component): subsets of size $n with cost cap $currentcost")
            for k in 1:div(n - 1, 2)
                for s1 in keys(costdict[k]), s2 in keys(costdict[n - k])
                    nextcost = _trymerge!(costdict, treedict, indexdict, n, k, s1, s2,
                        tensormask, iymask, allcosts, currentcost, previouscost, nextcost)
                end
            end
            if iseven(n) # k = n/2: pair distinct subsets of the same dict once
                k = div(n, 2)
                it = keys(costdict[k])
                st1 = iterate(it)
                while st1 !== nothing
                    s1, ns1 = st1
                    st2 = iterate(it, ns1)
                    while st2 !== nothing
                        s2, ns2 = st2
                        nextcost = _trymerge!(costdict, treedict, indexdict, n, k, s1, s2,
                            tensormask, iymask, allcosts, currentcost, previouscost, nextcost)
                        st2 = iterate(it, ns2)
                    end
                    st1 = iterate(it, ns1)
                end
            end
        end
        !isempty(costdict[componentsize]) && break
        previouscost = currentcost
        # grow the cap; guarantee progress even when costfac == 1 (all dims 1)
        currentcost = min(maxcost, max(nextcost * costfac, nextcost))
        currentcost <= previouscost && break
    end
    if isempty(costdict[componentsize])
        error("ExhaustiveSearch: cost cap $maxcost reached without a solution") # should be impossible
    end
    s = _storeset(T, component, numtensors)
    return (_reconstruct_tree(s, treedict), indexdict[componentsize][s], costdict[componentsize][s])
end

# Rebuild the nested `Any[left, right]`/Int tree from the stored bipartitions.
function _reconstruct_tree(s::T, treedict::Vector{Dict{T, T}}) where {T}
    sz = _setsize(s)
    sz == 1 && return _singleton_index(s)
    s1 = treedict[sz][s]
    s2 = _setdiff(s, s1)
    return Any[_reconstruct_tree(s1, treedict), _reconstruct_tree(s2, treedict)]
end

# Try to record the contraction of subsets `s1` (size k) and `s2` (size n-k).
# Returns the updated `nextcost` (the smallest over-cap cost seen this pass).
@inline function _trymerge!(costdict, treedict, indexdict, n, k, s1::T, s2::T,
        tensormask::Vector{T}, iymask::T, allcosts, currentcost, previouscost, nextcost) where {T}
    _isemptyset(_intersect(s1, s2)) || return nextcost  # subsets must be disjoint
    s = _union(s1, s2)
    existing = get(costdict[n], s, currentcost)
    existing > previouscost || return nextcost
    ind1 = indexdict[k][s1]
    ind2 = indexdict[n - k][s2]
    _isemptyset(_intersect(ind1, ind2)) && return nextcost  # skip outer products within a component
    allopen = _union(ind1, ind2)
    cost = costdict[k][s1] + costdict[n - k][s2] + _setcost(allcosts, allopen)
    if cost <= existing
        costdict[n][s] = cost
        indexdict[n][s] = _setdiff(allopen, _closedmask(allopen, s, tensormask, iymask))
        treedict[n][s] = s1  # store the bipartition; partner is s ∖ s1
    elseif currentcost < cost < nextcost
        nextcost = cost
    end
    return nextcost
end

############################ output construction ############################
# The labels left uncontracted after forming tensor-subset `S`: those touching
# `S` that are outputs or still appear on a tensor outside `S`.
function _open_labels(S::T, tensormask::Vector{T}, iymask::T, idlabels::Vector{L}) where {T, L}
    res = L[]
    @inbounds for l in 1:length(tensormask)
        if !_isemptyset(_intersect(tensormask[l], S)) && (_hasbit(iymask, l) || !_issubset(tensormask[l], S))
            push!(res, idlabels[l])
        end
    end
    return res
end

############################ scope validation ############################
function _check_exhaustive_scope(ixs::AbstractVector{<:AbstractVector}, iy)
    iyset = Set(iy)
    counts = Dict{eltype(iy), Int}()
    for ix in ixs
        seen = Set{eltype(iy)}()
        for l in ix
            if l in seen
                throw(ArgumentError("ExhaustiveSearch does not support partial traces: index $l appears more than once within a single tensor. Simplify it away or use another optimizer."))
            end
            push!(seen, l)
            counts[l] = get(counts, l, 0) + 1
        end
    end
    for (l, c) in counts
        if c == 1 && !(l in iyset)
            throw(ArgumentError("ExhaustiveSearch does not support a dangling index that is summed over: index $l appears once but is not an output. Simplify the network first or use another optimizer."))
        end
    end
    return nothing
end

############################ driver ############################
"""
    optimize_exhaustive(code::EinCode, size_dict; verbose=false) -> NestedEinsum

Optimize the contraction order of `code` exactly, minimizing the total
contraction cost (time complexity). See [`ExhaustiveSearch`](@ref).
"""
function optimize_exhaustive(code::EinCode{L}, size_dict::Dict{L}; verbose::Bool = false) where {L}
    ixs, iy = getixsv(code), getiyv(code)
    numtensors = length(ixs)
    numtensors <= 2 && return NestedEinsum(NestedEinsum{L}.(1:numtensors), EinCode(ixs, iy))
    _check_exhaustive_scope(ixs, iy)

    # intern labels to 1..numlabels and pick a bit type covering both the tensor
    # and label universes, then dispatch into a type-stable barrier on that type.
    idlabels = unique!(reduce(vcat, ixs))
    T = _choose_settype(max(numtensors, length(idlabels)))
    return _optimize_exhaustive(T, ixs, iy, idlabels, size_dict, verbose)
end

function _optimize_exhaustive(::Type{T}, ixs::Vector{Vector{L}}, iy::Vector{L}, idlabels::Vector{L}, size_dict, verbose::Bool) where {T, L}
    numtensors = length(ixs)
    numlabels = length(idlabels)
    lab2id = Dict(idlabels[i] => i for i in 1:numlabels)
    allcosts = Float64[Float64(get(size_dict, l, 1)) for l in idlabels]

    # per-tensor open-label set (= its full leg set; scope guarantees no dangling
    # or repeated legs), per-label occurrence set over tensors, and the
    # tensor-label incidence matrix used to find connected components
    singleopen = Vector{T}(undef, numtensors)
    tensormask = T[_zero_set(T, numtensors) for _ in 1:numlabels]
    incidence = falses(numtensors, numlabels)
    for i in 1:numtensors
        ids = [lab2id[l] for l in ixs[i]]
        singleopen[i] = _storeset(T, ids, numlabels)
        for id in ids
            tensormask[id] = _addbit!(tensormask[id], i)
            incidence[i, id] = true
        end
    end
    iymask = _storeset(T, [lab2id[l] for l in iy if haskey(lab2id, l)], numlabels)

    # connected components (tensors adjacent iff they share a label)
    componentlist = _connected_components(incidence, collect(1:numtensors))

    # solve each component, seeding its cost cap with a per-component greedy run
    ntrees = Vector{Any}(undef, length(componentlist))
    opens = Vector{T}(undef, length(componentlist))
    costs = Vector{Float64}(undef, length(componentlist))
    for (c, component) in enumerate(componentlist)
        initialcost = if length(component) == 1
            0.0
        else
            sub_ixs = [ixs[i] for i in component]
            complabels = Set(l for ix in sub_ixs for l in ix)
            sub_iy = L[l for l in iy if l in complabels]
            greedy = optimize_greedy(EinCode(sub_ixs, sub_iy), size_dict; α = 0.0, temperature = 0.0)
            Float64(flop(greedy, size_dict))
        end
        ntrees[c], opens[c], costs[c] = _solve_component(
            T, component, singleopen, tensormask, iymask, numtensors, allcosts, initialcost; verbose
        )
    end

    # combine disconnected components cheapest-first via outer products
    p = sortperm(costs)
    tree = ntrees[p[1]]
    open = opens[p[1]]
    for c in 2:length(componentlist)
        tree = Any[tree, ntrees[p[c]]]
        open = _union(open, opens[p[c]])
    end

    # build the NestedEinsum directly from the search state
    fullset = _storeset(T, 1:numtensors, numtensors)
    _, ne, _ = _build_nested(tree, ixs, iy, fullset, tensormask, iymask, idlabels, numtensors, T)
    return ne
end

function optimize_exhaustive(::NestedEinsum, size_dict; verbose::Bool = false)
    throw(ArgumentError("ExhaustiveSearch currently supports flat `EinCode` input only. Flatten the `NestedEinsum` (e.g. with `flatten`) before optimizing, or use another optimizer."))
end

# recursively turn the nested `Any[left,right]`/Int tree into a `NestedEinsum`
function _build_nested(node, ixs, iy, fullset::T, tensormask, iymask, idlabels::Vector{L}, numtensors, ::Type{T}) where {T, L}
    if node isa Integer
        i = Int(node)
        return (_storeset(T, [i], numtensors), NestedEinsum{L}(i), ixs[i])
    end
    s1, ne1, legs1 = _build_nested(node[1], ixs, iy, fullset, tensormask, iymask, idlabels, numtensors, T)
    s2, ne2, legs2 = _build_nested(node[2], ixs, iy, fullset, tensormask, iymask, idlabels, numtensors, T)
    S = _union(s1, s2)
    out = (S == fullset) ? iy : _open_labels(S, tensormask, iymask, idlabels)
    ne = NestedEinsum([ne1, ne2], EinCode([legs1, legs2], out))
    return (S, ne, out)
end

############################ small set utilities ############################
function _choose_settype(nbits::Int)
    nbits <= 32 && return UInt32
    nbits <= 64 && return UInt64
    (nbits <= 128 && !(Int === Int32 && Sys.iswindows())) && return UInt128
    return BitVector
end
_zero_set(::Type{T}, _maxint) where {T <: Unsigned} = zero(T)
_zero_set(::Type{BitVector}, maxint) = falses(maxint)
_addbit!(s::T, i) where {T <: Unsigned} = s | (one(T) << (i - 1))
function _addbit!(s::BitVector, i)
    s[i] = true
    return s
end
_setsize(s::Unsigned) = count_ones(s)
_setsize(s::BitVector) = count(s)
_singleton_index(s::Unsigned) = trailing_zeros(s) + 1
_singleton_index(s::BitVector) = findfirst(s)::Int

using Test, OMEinsumContractionOrders
using Graphs, Random
using SparseArrays
using OMEinsumContractionOrders: bipartite_sc, adjacency_matrix, SABipartite, group_sc, bipartite_sc, optimize_sa, optimize_greedy
using OMEinsum: decorate

@testset "sa bipartition" begin
    Random.seed!(3)
    g = random_regular_graph(120, 3)
    adj, = adjacency_matrix([(e.src,e.dst) for e in edges(g)])
    ws = fill(log2(2), ne(g))
    vertices = 1:110
    b = SABipartite(βs=0.1:0.2:20.0, niters=1000, ntrials=100, sc_target=40, initializer=:random)
    res = bipartite_sc(b, adj, vertices, ws)
    @test length(res.part1) + length(res.part2) == 110
end

@testset "sa" begin
    Random.seed!(2)
    function random_regular_eincode(n, k)
        g = Graphs.random_regular_graph(n, k)
        ixs = [[minmax(e.src,e.dst)...] for e in Graphs.edges(g)]
        return OMEinsumContractionOrders.EinCode([ixs..., [[i] for i in Graphs.vertices(g)]...], Int[])
    end

    g = random_regular_graph(220, 3)
    rows = Int[]
    cols = Int[]
    for (i,edge) in enumerate(edges(g))
        push!(rows, edge.src, edge.dst)
        push!(cols, i, i)
    end
    graph = sparse(rows, cols, ones(Int, length(rows)))
    sc_target = 28.0
    log2_sizes = fill(1, size(graph, 2))
    βs = 0.01:0.05:10.0
    b = SABipartite(βs=βs, niters=1000, ntrials=100, sc_target=28)
    res = bipartite_sc(b, graph, collect(1:size(graph, 1)), log2_sizes)
    @test group_sc(graph, res.part1, log2_sizes) <= sc_target+2
    @test group_sc(graph, res.part2, log2_sizes) <= sc_target+2
    sc_target = 27.0
    res = bipartite_sc(b, graph, res.part1, log2_sizes)
    @test group_sc(graph, res.part1, log2_sizes) <= sc_target+2
    @test group_sc(graph, res.part2, log2_sizes) <= sc_target+2

    code = random_regular_eincode(220, 3)
    res = optimize_sa(code,uniformsize(code, 2); sc_target=30, βs=βs)
    cc = contraction_complexity(res, uniformsize(code, 2))
    @test cc.sc <= 32

    tc1, sc1, rw1 = timespacereadwrite_complexity(res, uniformsize(code, 2))
    cc = contraction_complexity(res, uniformsize(code, 2))
    @test (tc1, sc1, rw1) == (cc...,)
    println(cc)

    # contraction test
    code = random_regular_eincode(50, 3)
    codeg = optimize_sa(code, uniformsize(code, 2); sc_target=12, βs=βs, ntrials=1, initializer=:greedy)
    codek = optimize_greedy(code, uniformsize(code, 2); α=0.0, temperature=0.0)
    cc = contraction_complexity(codek, uniformsize(code, 2))
    @test cc.sc <= 12
    xs = [[2*randn(2, 2) for i=1:75]..., [randn(2) for i=1:50]...]
    resg = decorate(codeg)(xs...)
    resk = decorate(codek)(xs...)
    @test resg ≈ resk
end

struct IncidenceList{VT,ET}
    v2e::Dict{VT,Vector{ET}}
    e2v::Dict{ET,Vector{VT}}
    openedges::Vector{ET}
end

function IncidenceList(v2e::Dict{VT,Vector{ET}}; openedges=ET[]) where {VT,ET}
    e2v = Dict{ET,Vector{VT}}()
    for (v, es) in v2e
        for e in es
            if haskey(e2v, e)
                push!(e2v[e], v)
            else
                e2v[e] = [v]
            end
        end
    end
    IncidenceList(v2e, e2v, openedges)
end

Base.copy(il::IncidenceList) = IncidenceList(Dict([k=>copy(v) for (k,v) in il.v2e]), Dict([k=>copy(v) for (k,v) in il.e2v]), copy(il.openedges))

function neighbors(il::IncidenceList{VT}, v) where VT
    res = VT[]
    for e in il.v2e[v]
        for vj in il.e2v[e]
            v != vj && push!(res, vj)
        end
    end
    return unique!(res)
end
vertices(il::IncidenceList) = keys(il.v2e)
vertices(il::IncidenceList, e) = il.e2v[e]
vertex_degree(il::IncidenceList, v) = length(il.v2e[v])
edge_degree(il::IncidenceList, e) = length(il.e2v[v])
edges(il::IncidenceList, v) = il.v2e[v]
nv(il::IncidenceList) = length(il.v2e)
ne(il::IncidenceList) = length(il.e2v)

# delete vertex, and remove it from the edges connected to it
function delete_vertex!(incidence_list::IncidenceList{VT,ET}, vj::VT) where {VT,ET}
    edges = pop!(incidence_list.v2e, vj)
    for e in edges
        vs = vertices(incidence_list, e)
        for iv in length(vs):-1:1
            vs[iv] == vj && deleteat!(vs, iv)
        end
    end
    return incidence_list
end

function change_edges!(incidence_list, vi, es)
    incidence_list.v2e[vi] = es
    return incidence_list
end

function remove_edges!(incidence_list, es)
    for e in es
        delete!(incidence_list.e2v, e)
    end
    return incidence_list
end

function replace_vertex!(incidence_list, e, pair)
    el = incidence_list.e2v[e]
    if pair.first ∈ el
        if pair.second ∈ el
            deleteat!(el, findfirst(==(pair.first), el))
        else
            replace!(el, pair)
        end
    else
        if pair.second ∉ el
            push!(el, pair.second)
        end
    end
    return incidence_list
end

using OMEinsumContractionOrders, OMEinsum
using OMEinsumContractionOrders: pivot_tree, path_to_tensor

using Test

@testset "tree reformulate" begin
    eincode = ein"((ik, jkl), ij), (lm, m) -> "
    code = OMEinsum.rawcode(eincode)

    size_dict = Dict([c=>(1<<i) for (i,c) in enumerate(['i', 'j', 'k', 'l', 'm'])]...)
    tensor_labels = [['i', 'k'], ['j', 'k', 'l'], ['i', 'j'], ['l', 'm'], ['m']]
    size_tensors = [log2(prod(size_dict[l] for l in tensor)) for tensor in tensor_labels]
    tensors = [rand([size_dict[j] for j in tensor_labels[i]]...) for i in 1:5]
    for tensor_index in 1:5

        path = path_to_tensor(code, tensor_index)
        tensor = reduce((x, y) -> x.args[y], path, init = code)
        @test tensor.tensorindex == tensor_index

        new_code = pivot_tree(code, tensor_index)
        @test contraction_complexity(new_code, size_dict).sc == max(contraction_complexity(code, size_dict).sc, size_tensors[tensor_index])

        closed_code = OMEinsumContractionOrders.NestedEinsum([new_code, tensor], OMEinsumContractionOrders.EinCode([OMEinsumContractionOrders.getiyv(new_code), tensor_labels[tensor_index]], Char[]))
        new_eincode = OMEinsum.decorate(closed_code)
        @test eincode(tensors...) ≈ new_eincode(tensors...)
    end
end

@testset "contraction complexity for empty tensor network" begin
    code = OMEinsumContractionOrders.EinCode(Vector{Char}[], Char[])
    @test contraction_complexity(code, Dict{Char, Int}()).sc == 0

    code = OMEinsumContractionOrders.NestedEinsum(OMEinsumContractionOrders.NestedEinsum{Char}[], OMEinsumContractionOrders.EinCode(Vector{Char}[], Char[]))
    @test contraction_complexity(code, Dict{Char, Int}()).sc == 0
end

@testset "score" begin
    score = ScoreFunction(tc_weight=1.0, sc_weight=1.0, rw_weight=0.1, sc_target=20.0)
    @test score(10, 10, 10) ≈ 1024.0 + 102.4
    @test score(10, 30, 10) ≈ 1024.0 + exp2(30) - exp2(20) + 102.4
end

@testset "fix_binary_tree" begin
    # case 1: leaf and unary
    leaf1 = OMEinsumContractionOrders.NestedEinsum{Int}(2)
    leaf2 = OMEinsumContractionOrders.NestedEinsum{Int}(2)
    unary1 = OMEinsumContractionOrders.NestedEinsum([leaf1], OMEinsumContractionOrders.EinCode([[1, 2]], [2, 1]))
    unary2 = OMEinsumContractionOrders.NestedEinsum([leaf2], OMEinsumContractionOrders.EinCode([[1, 2]], [2, 1]))
    nested_unary = OMEinsumContractionOrders.NestedEinsum([unary1], OMEinsumContractionOrders.EinCode([[1, 2]], [1]))
    @test OMEinsumContractionOrders.fix_binary_tree(leaf1) == leaf1
    @test OMEinsumContractionOrders.fix_binary_tree(unary1) == unary1
    expected_fix1 = OMEinsumContractionOrders.NestedEinsum([leaf1], OMEinsumContractionOrders.EinCode([[1, 2]], [1]))
    @test OMEinsumContractionOrders.fix_binary_tree(nested_unary) == expected_fix1

    # case 2: binary tree
    binary1 = OMEinsumContractionOrders.NestedEinsum(
        [leaf1, leaf2],
        OMEinsumContractionOrders.EinCode([[1, 2], [1, 2]], [1])
    )
    @test OMEinsumContractionOrders.fix_binary_tree(binary1) == binary1
    @test OMEinsumContractionOrders.is_binary(binary1)

    binary2 = OMEinsumContractionOrders.NestedEinsum(
        [unary1, nested_unary],
        OMEinsumContractionOrders.EinCode([[1, 2], [1, 2]], [1])
    )
    expected_fix2 = OMEinsumContractionOrders.NestedEinsum([leaf1, leaf1], OMEinsumContractionOrders.EinCode([[1, 2], [1, 2]], [1]))
    @test OMEinsumContractionOrders.fix_binary_tree(binary2) == expected_fix2
    @test !OMEinsumContractionOrders.is_binary(binary2)
    @test OMEinsumContractionOrders.is_binary(expected_fix2)
    
    # case 3: unary with binary
    unary3 = OMEinsumContractionOrders.NestedEinsum([binary1], OMEinsumContractionOrders.EinCode([[1]], Int[]))
    expected_fix3 = OMEinsumContractionOrders.NestedEinsum(binary1.args, OMEinsumContractionOrders.EinCode([[1, 2], [1, 2]], Int[]))
    @test OMEinsumContractionOrders.fix_binary_tree(unary3) == expected_fix3
    @test !OMEinsumContractionOrders.is_binary(unary3)
    @test OMEinsumContractionOrders.is_binary(expected_fix3)

    unary4 = OMEinsumContractionOrders.NestedEinsum([binary2], OMEinsumContractionOrders.EinCode([[1]], Int[]))
    expected_fix4 = OMEinsumContractionOrders.NestedEinsum(expected_fix2.args, OMEinsumContractionOrders.EinCode([[1, 2], [1, 2]], Int[]))
    @test OMEinsumContractionOrders.fix_binary_tree(unary4) == expected_fix4
    @test !OMEinsumContractionOrders.is_binary(unary4)
    @test OMEinsumContractionOrders.is_binary(expected_fix4)
end

############# Slicer ######################
struct Slicer
    log2_sizes::Vector{Float64}   # the size dict after slicing
    legs::Dict{Int,Float64}   # sliced leg and its original size
    fixed_slices::Vector{Int}     # number of fixed legs
end
function Slicer(log2_sizes::AbstractVector{Float64}, fixed_slices::AbstractVector)
    slicer = Slicer(collect(log2_sizes), Dict{Int,Float64}(), collect(Int,fixed_slices))
    for l in fixed_slices
        push!(slicer, l)
    end
    return slicer
end
Base.length(s::Slicer) = length(s.legs)
function Base.replace!(slicer::Slicer, pair::Pair)
    worst, best = pair
    @assert worst ∉ slicer.fixed_slices
    @assert haskey(slicer.legs, worst)
    @assert !haskey(slicer.legs, best)
    slicer.log2_sizes[worst] = slicer.legs[worst]       # restore worst size
    slicer.legs[best] = slicer.log2_sizes[best]  # add best to legs
    slicer.log2_sizes[best] = 0.0
    delete!(slicer.legs, worst)                  # remove worst from legs
    return slicer
end

function Base.push!(slicer::Slicer, best)
    @assert !haskey(slicer.legs, best)
    slicer.legs[best] = slicer.log2_sizes[best]  # add best to legs
    slicer.log2_sizes[best] = 0.0
    return slicer
end

function Base.delete!(slicer::Slicer, worst)
    @assert haskey(slicer.legs, worst)
    slicer.log2_sizes[worst] = slicer.legs[worst]
    delete!(slicer.legs, worst)
    return slicer
end

# convert the slicer to a vector of sliced labels
function get_slices(s::Slicer, inverse_map::Dict{Int,LT}) where LT
    # we want to keep the order of input fixed slices!
    LT[[inverse_map[l] for l in s.fixed_slices]..., [inverse_map[l] for (l, sz) in s.legs if l ∉ s.fixed_slices]...]
end

"""
    TreeSASlicer{IT, LT} <: CodeSlicer

A structure for configuring the Tree Simulated Annealing (TreeSA) slicing algorithm.
The goal of slicing is to reach the target space complexity specified by `score.sc_target`.

# Fields
- `ntrials`, `βs` and `niters` are annealing parameters, doing `ntrials` indepedent annealings, each has inverse tempteratures specified by `βs`, in each temperature, do `niters` updates of the tree.
- `fixed_slices::Vector{LT}`: A vector of fixed slices that should not be altered. Default is an empty vector.
- `optimization_ratio::Float64`: A constant used for determining the number of iterations for slicing. Default is 2.0. i.e. if the current space complexity is 30, and the target space complexity is 20, then the number of iterations for slicing is (30 - 20) x `optimization_ratio`.
- `score::ScoreFunction`: A function to evaluate the quality of the contraction tree. Default is `ScoreFunction(sc_target=30.0)`.
- `decomposition_type::AbstractDecompositionType`: The type of decomposition to use. Default is `TreeDecomp()`.

# References
- [Recursive Multi-Tensor Contraction for XEB Verification of Quantum Circuits](https://arxiv.org/abs/2108.05665)
"""
Base.@kwdef struct TreeSASlicer{IT,LT} <: CodeSlicer
    βs::IT = 14:0.05:15
    ntrials::Int = 10
    niters::Int = 10
    fixed_slices::Vector{LT} = []
    optimization_ratio::Float64 = 2.0
    score::ScoreFunction = ScoreFunction(sc_target=30.0)
    decomposition_type::AbstractDecompositionType = TreeDecomp()
end

function slice_tree(code::NestedEinsum, size_dict::Dict{LT,Int}; βs=14:0.05:15, ntrials=10, niters=10, fixed_slices=LT[], optimization_ratio=2.0, score=ScoreFunction(sc_target=30.0), decomposition_type=TreeDecomp()) where LT
    ixs, iy = getixsv(code), getiyv(code)
    ninputs = length(ixs)
    if ninputs <= 1
        return SlicedEinsum(LT[], code)
    end

    ###### Stage 1: preprocessing ######
    labels = _label_dict(ixs, iy)  # map labels to integers
    inverse_map = Dict([v=>k for (k,v) in labels])  # the inverse transformation, map integers to labels
    log2_sizes = [log2.(size_dict[inverse_map[i]]) for i=1:length(labels)]   # use `log2` sizes in computing time

    if ntrials <= 0
        return SlicedEinsum(fixed_slices, code)
    end

    ###### Stage 2: computing ######

    trees = Vector{ExprTree}(undef, ntrials)
    tcs = Vector{Float64}(undef, ntrials)
    scs = Vector{Float64}(undef, ntrials)
    rws = Vector{Float64}(undef, ntrials)
    slicers = Vector{Slicer}(undef, ntrials)

    local best_tree, best_tc, best_sc, best_rw, best_slicer
    @threads for t = 1:ntrials  # multi-threading on different trials, use `julia -t 5 xxx.jl` for setting number of threads.
        tree = _exprtree(code, labels)
        slicer = Slicer(log2_sizes, Int[labels[l] for l in fixed_slices])
        
        treesa_slice!(tree, log2_sizes, slicer; βs, niters, score, optimization_ratio, decomposition_type)
        tc, sc, rw = tree_timespace_complexity(tree, log2_sizes)
        @debug "trial $t, time complexity = $tc, space complexity = $sc, read-write complexity = $rw."
        trees[t] = tree
        tcs[t] = tc
        scs[t] = sc
        rws[t] = rw
        slicers[t] = slicer
    end

    local best_tree, best_tc, best_sc, best_rw, best_slicer
    for t = 1:ntrials
        if t == 1 || score(tcs[t], scs[t], rws[t]) < score(best_tc, best_sc, best_rw)
            best_tree, best_tc, best_sc, best_rw, best_slicer = trees[t], tcs[t], scs[t], rws[t], slicers[t]
        end
    end

    ###### Stage 3: postprocessing ######
    @debug "best space complexities = $best_tc, time complexity = $best_sc, read-write complexity $best_rw."
    return SlicedEinsum(get_slices(best_slicer, inverse_map), NestedEinsum(best_tree, inverse_map))
end

function treesa_slice!(tree::ExprTree, log2_sizes, slicer::Slicer; βs, niters, score, optimization_ratio, decomposition_type)
    log2rw_weight = log2(score.rw_weight)
    tc, sc, rw = tree_timespace_complexity(tree, slicer.log2_sizes)
    @debug "Initial tc = $tc, sc = $sc, rw = $rw"

    # determine the number of iterations for slicing
    optimization_length = Int(ceil(optimization_ratio * (sc - score.sc_target)))
    slicing_loop = 0

    while slicing_loop < optimization_length || sc > score.sc_target

        ###### Stage 1: add one slice at each loop  ######
        # 1). find legs that reduce the dimension the most
        scs, lbs = Float64[], Vector{Int}[]
        # space complexities and labels of all intermediate tensors
        tensor_sizes!(tree, slicer.log2_sizes, scs, lbs)
        # the set of (intermediate) tensor labels that producing maximum space complexity
        best_labels = _best_labels(scs, lbs)

        # 2). slice the best not sliced label (it must appear in largest tensors)
        best_not_sliced_labels = filter(x->!haskey(slicer.legs, x), best_labels)
        if !isempty(best_not_sliced_labels)
            #best_not_sliced_label = rand(best_not_sliced_labels)  # random or best
            best_not_sliced_label = best_not_sliced_labels[findmax(l->count(==(l), best_not_sliced_labels), best_not_sliced_labels)[2]]
            if sc > score.sc_target  # if has not reached maximum number of slices, add one slice
                push!(slicer, best_not_sliced_label)
            elseif length(slicer.legs) > 0                                 # otherwise replace one slice
                legs = [l for l in keys(slicer.legs) if l ∉ slicer.fixed_slices]  # only slice over not fixed legs
                if !isempty(legs)
                    scores = [count(==(l), best_labels) for l in legs]
                    # replace!(slicer, legs[argmin(score)]=>best_not_sliced_label)
                    delete!(slicer, legs[argmin(scores)])
                end
            end
        end

        ###### Stage 2: refine the tree with the revised slices  ######
        for β in βs
            for _ = 1:niters
                optimize_subtree!(tree, β, slicer.log2_sizes, score.sc_target, score.sc_weight, log2rw_weight, decomposition_type)  # single sweep
            end
        end
        tc, sc, rw = tree_timespace_complexity(tree, slicer.log2_sizes)
        @debug "After optimization: tc = $tc, sc = $sc, rw = $rw, slicing_loop = $slicing_loop, number of slices = $(length(slicer.legs))"
        slicing_loop += 1
    end
    return tree, slicer
end


# here "best" means giving maximum space complexity
function _best_labels(scs, lbs)
    max_sc = maximum(scs)
    return vcat(lbs[scs .> max_sc-0.99]...)
end

# find tensor sizes and their corresponding labels of all intermediate tensors
function tensor_sizes!(tree::ExprTree, log2_sizes, scs, lbs)
    sc = isempty(labels(tree)) ? 0.0 : sum(i->log2_sizes[i], labels(tree))
    push!(scs, sc)
    push!(lbs, labels(tree))
    isleaf(tree) && return
    tensor_sizes!(tree.left, log2_sizes, scs, lbs)
    tensor_sizes!(tree.right, log2_sizes, scs, lbs)
end

using Test, OMEinsumContractionOrders

@testset "save load" begin
    for code in [
        OMEinsumContractionOrders.EinCode([[1,2], [2,3], [3,4]], [1,4]),
        OMEinsumContractionOrders.EinCode([['a','b'], ['b','c'], ['c','d']], ['a','d'])
    ]
        code0 = optimize_code(code, uniformsize(code, 2), GreedyMethod())
        code1 = slice_code(code0, uniformsize(code, 2), TreeSASlicer(score=ScoreFunction(sc_target=2)))
        for optcode in [code0, code1]
            filename = tempname()
            OMEinsumContractionOrders.writejson(filename, optcode)
            code2 = OMEinsumContractionOrders.readjson(filename)
            @test optcode == code2
        end
    end
end

struct LabeledHyperGraph{TS, TV, TE}
    adjacency_matrix::SparseMatrixCSC{TS}
    vertex_labels::Vector{TV}
    edge_labels::Vector{TE}
    open_edges::Vector{TE}

    function LabeledHyperGraph(adjacency_matrix::SparseMatrixCSC{TS}; vl::Vector{TV} = [1:size(adjacency_matrix, 1)...], el::Vector{TE} = [1:size(adjacency_matrix, 2)...], oe::Vector = []) where{TS, TV, TE}
        if size(adjacency_matrix, 1) != length(vl)
            throw(ArgumentError("Number of vertices does not match number of vertex labels"))
        end
        if size(adjacency_matrix, 2) != length(el)
            throw(ArgumentError("Number of edges does not match number of edge labels"))
        end
        if !all(oei in el for oei in oe)
            throw(ArgumentError("Open edges must be in edge labels"))
        end
        if isempty(oe)
            oe = Vector{TE}()
        end
        new{TS, TV, TE}(adjacency_matrix, vl, el, oe)
    end
end

Base.show(io::IO, g::LabeledHyperGraph{TS, TV, TE}) where{TS,TV,TE} = print(io, "LabeledHyperGraph{$TS, $TV, $TE} \n adjacency_mat: $(g.adjacency_matrix) \n vertex: $(g.vertex_labels) \n edges: $(g.edge_labels)) \n open_edges: $(g.open_edges)")

Base.:(==)(a::LabeledHyperGraph, b::LabeledHyperGraph) = a.adjacency_matrix == b.adjacency_matrix && a.vertex_labels == b.vertex_labels && a.edge_labels == b.edge_labels && a.open_edges == b.open_edges

struct TensorNetworkGraph{TT, TI}
    graph::SimpleGraph
    tensors_labels::Dict{Int, TT}
    indices_labels::Dict{Int, TI}
    open_indices::Vector{TI}

    function TensorNetworkGraph(graph::SimpleGraph; tl::Dict{Int, TT} = Dict{Int, Int}(), il::Dict{Int, TI} = Dict{Int, Int}(), oi::Vector = []) where{TT, TI}
        if length(tl) + length(il) != nv(graph)
            throw(ArgumentError("Number of tensors + indices does not match number of vertices"))
        end
        if !all(oii in values(il) for oii in oi)
            throw(ArgumentError("Open indices must be in indices"))
        end
        if isempty(oi)
            oi = Vector{TI}()
        end
        new{TT, TI}(graph, tl, il, oi)
    end
end

Base.show(io::IO, g::TensorNetworkGraph{TT, TI}) where{TT, TI} = print(io, "TensorNetworkGraph{$TT, $TI} \n graph: {$(nv(g.graph)), $(ne(g.graph))} \n tensors: $(g.tensors_labels) \n indices: $(g.indices_labels)) \n open_indices: $(g.open_indices)")

# convert the labeled hypergraph to a tensor network graph, where vertices and edges of the hypergraph are mapped as the vertices of the tensor network graph, and the open edges are recorded.
function TensorNetworkGraph(lhg::LabeledHyperGraph{TS, TV, TE}) where{TS, TV, TE}
    graph = SimpleGraph(length(lhg.vertex_labels) + length(lhg.edge_labels))
    tensors_labels = Dict{Int, TV}()
    indices_labels = Dict{Int, TE}()

    lv = length(lhg.vertex_labels)
    for i in 1:length(lhg.vertex_labels)
        tensors_labels[i] = lhg.vertex_labels[i]
    end
    for i in 1:length(lhg.edge_labels)
        indices_labels[i + lv] = lhg.edge_labels[i]
    end

    for i in 1:size(lhg.adjacency_matrix, 1)
        for j in findall(!iszero, lhg.adjacency_matrix[i, :])
            add_edge!(graph, i, j + lv)
        end
    end
    
    TensorNetworkGraph(graph, tl=tensors_labels, il=indices_labels, oi=lhg.open_edges)
end

############### Simplifier and optimizer types #################
"""
    CodeSimplifier

Abstract type for code simplifiers.
"""
abstract type CodeSimplifier end

"""
    MergeGreedy <: CodeSimplifier
    MergeGreedy(; threshhold=-1e-12)

Contraction code simplifier (in order to reduce the time of calling optimizers) that
merges tensors greedily if the space complexity of merged tensors is reduced (difference smaller than the `threshhold`).
"""
Base.@kwdef struct MergeGreedy <: CodeSimplifier
    threshhold::Float64=-1e-12
end

"""
    MergeVectors <: CodeSimplifier
    MergeVectors()

Contraction code simplifier (in order to reduce the time of calling optimizers) that merges vectors to closest tensors.
"""
struct MergeVectors <: CodeSimplifier end

"""
    NetworkSimplifier{LT}

A network simplifier that contains a list of operations that can be applied to a tensor network to reduce the number of tensors.
It is generated from a proprocessor, such as [`MergeVectors`](@ref) or [`MergeGreedy`](@ref).

# Fields
- `operations`: a list of `NestedEinsum` objects.
"""
struct NetworkSimplifier{LT}
    operations::Vector{NestedEinsum{LT}}
end

"""
    simplify_code(code::Union{EinCode, NestedEinsum}, size_dict, method::CodeSimplifier)

Simplify the contraction code by preprocessing the code with a simplifier.

# Arguments
- `code`: the contraction code to simplify.
- `size_dict`: the size dictionary of the contraction code.
- `method`: the simplifier to use, which can be [`MergeVectors`](@ref) or [`MergeGreedy`](@ref).

# Returns
- A tuple of `(NetworkSimplifier, newcode)`, where `newcode` is a new `EinCode` object.
"""
simplify_code(code::Union{EinCode, NestedEinsum}, size_dict, ::MergeVectors) = merge_vectors(code)
simplify_code(code::Union{EinCode, NestedEinsum}, size_dict, method::MergeGreedy) = merge_greedy(code, size_dict; threshhold=method.threshhold)

function merge_vectors(code::EinCode{LT}) where LT
    ixs = getixsv(code)
    mask = trues(length(ixs))
    ops = [NestedEinsum{LT}(i) for i=1:length(ixs)]
    for i in 1:length(ixs)
        if length(ixs[i]) == 1
            for j in 1:length(ixs)
                if i!=j && mask[j] && ixs[i][1] ∈ ixs[j]  # merge i to j
                    mask[i] = false
                    ops[j] = NestedEinsum([ops[i], ops[j]],
                        EinCode([ixs[i], ixs[j]], ixs[j]))
                    break
                end
            end
        end
    end
    newcode = EinCode(ixs[mask], getiyv(code))
    return NetworkSimplifier(ops[mask]), newcode
end

function merge_greedy(code::EinCode{LT}, size_dict; threshhold=-1e-12) where LT
    ixs, iy = getixsv(code), getiyv(code)
    log2_edge_sizes = Dict{LT,Float64}()
    for (k, v) in size_dict
        log2_edge_sizes[k] = log2(v)
    end
    incidence_list = IncidenceList(Dict([i=>ixs[i] for i=1:length(ixs)]); openedges=iy)
    n = nv(incidence_list)
    if n == 0
        return nothing
    elseif n == 1
        return collect(vertices(incidence_list))[1]
    end
    tree = Dict{Int,NestedEinsum}([v=>NestedEinsum{LT}(v) for v in vertices(incidence_list)])
    cost_values, cost_graph = evaluate_costs(1.0, incidence_list, log2_edge_sizes)
    while true
        if isempty(cost_values)
            return _buildsimplifier(tree, incidence_list)
        end
        pair, v = first(cost_values)
        if v <= threshhold
            _, _, c = contract_pair!(incidence_list, pair..., log2_edge_sizes)
            tree[pair[1]] = NestedEinsum([tree[pair[1]], tree[pair[2]]], EinCode([c.first...], c.second))
            if nv(incidence_list) <= 1
                return _buildsimplifier(tree, incidence_list)
            end
            update_costs!(cost_values, cost_graph, pair..., 1.0, incidence_list, log2_edge_sizes)
        else
            return _buildsimplifier(tree, incidence_list)
        end
    end
end
function _buildsimplifier(tree, incidence_list)
    vertices = sort!(collect(keys(incidence_list.v2e)))
    ixs = [incidence_list.v2e[v] for v in vertices]
    iy = incidence_list.openedges
    NetworkSimplifier([tree[v] for v in vertices]), EinCode(ixs, iy)
end

"""
    embed_simplifier(code::NestedEinsum, simplifier::NetworkSimplifier)

Embed the simplifier into the contraction code. A typical workflow is:
(i) generate a simplifier with [`simplify_code`](@ref), (ii) then optimize the simplified code with [`optimize_code`](@ref)
and (iii) post-process the optimized code with [`embed_simplifier`](@ref) to produce correct contraction order for the original code.
This is automatically done in [`optimize_code`](@ref) given the `simplifier` argument is not `nothing`.

# Arguments
- `code`: the contraction code to embed the simplifier into.
- `simplifier`: the simplifier to embed, which is a [`NetworkSimplifier`](@ref) object.

# Returns
- A new `NestedEinsum` object.
"""
function embed_simplifier(code::NestedEinsum, simplifier::NetworkSimplifier)
    if isleaf(code)
        op = simplifier.operations[code.tensorindex]
        return op
    else
        return NestedEinsum(map(code.args) do arg
            embed_simplifier(arg, simplifier)
        end, code.eins)
    end
end
embed_simplifier(code::SlicedEinsum, simplifier::NetworkSimplifier) = SlicedEinsum(code.slicing, embed_simplifier(code.eins, simplifier))

optimize_permute(se::SlicedEinsum, level=0) = SlicedEinsum(se.slicing, se.eins isa EinCode ? se.eins : optimize_permute(se.eins, level))
function optimize_permute(ne::NestedEinsum{LT}, level=0) where LT
    if isleaf(ne)
        return ne
    else
        args = NestedEinsum{LT}[optimize_permute(arg, level+1) for arg in ne.args]
        ixs0 = getixsv(ne.eins)
        ixs = Vector{LT}[isleaf(x) ? ixs0[i] : getiyv(x.eins) for (i, x) in enumerate(args)]
        iy = level == 0 ? getiyv(ne.eins) : optimize_output_permute(ixs, getiyv(ne.eins))
        return NestedEinsum(args, EinCode(ixs, iy))
    end
end

function optimize_output_permute(ixs::AbstractVector{<:AbstractVector{LT}}, iy::AbstractVector{LT}) where LT
    if length(ixs) != 2
        return iy
    else
        iA, iB = ixs
        batchdim = LT[]
        outerA = LT[]
        outerB = LT[]
        bcastdim = LT[]
        for l in iy
            if l ∈ iA
                if l ∈ iB
                    push!(batchdim, l)
                else
                    push!(outerA, l)
                end
            else
                if l ∈ iB
                    push!(outerB, l)
                else
                    push!(bcastdim, l)
                end
            end
        end
        return vcat(
            sort!(outerA, by=l->findfirst(==(l), iA)),
            sort!(outerB, by=l->findfirst(==(l), iB)),
            sort!(batchdim, by=l->findfirst(==(l), iA)),
            bcastdim)
    end
end

using OMEinsumContractionOrders, Test, Random
using OMEinsumContractionOrders: random_exprtree, ExprTree, ExprInfo,
    ruleset, update_tree!, tcscrw, optimize_subtree!, optimize_tree_sa!, labels, tree_timespace_complexity, fast_log2sumexp2,
    ExprTree, optimize_greedy, _label_dict, Slicer, optimize_tree
using Graphs
using OMEinsum: decorate

@testset "slicer" begin
    log2_sizes = [1, 2,3 ,4.0]
    s = Slicer(log2_sizes, [])
    push!(s, 1)
    @test_throws AssertionError push!(s, 1)
    push!(s, 2)
    push!(s, 3)
    
    replace!(s, 1=>4)
    @test s.log2_sizes == [1, 0.0, 0.0, 0.0]
    @test s.legs == Dict(2=>2.0, 3=>3.0, 4=>4.0)
    @test_throws AssertionError replace!(s, 1=>4)
end

@testset "random expr tree" begin
    function random_regular_eincode(n, k)
        g = Graphs.random_regular_graph(n, k)
        ixs = [[minmax(e.src,e.dst)...] for e in Graphs.edges(g)]
        return OMEinsumContractionOrders.EinCode([ixs..., [[i] for i in Graphs.vertices(g)]...], Int[])
    end
    Random.seed!(2)
    tree = random_exprtree([[1,2,5], [2,3], [2,4]], [5], 5, TreeDecomp())
    @test tree isa ExprTree
    tree2 = random_exprtree(OMEinsumContractionOrders.EinCode([[1,2,5], [2,3], [2,4]], [5]), TreeDecomp())
    @test tree isa ExprTree
    code = random_regular_eincode(20, 3)
    optcode = optimize_greedy(code, uniformsize(code, 2); α=0.0, temperature=0.0)
    tree3 = ExprTree(optcode)
    @test tree isa ExprTree
    println(tree)
    labelmap = Dict([v=>k for (k,v) in _label_dict(code)])
    optcode_reconstruct = OMEinsumContractionOrders.NestedEinsum(tree3, labelmap)
    @test optcode == optcode_reconstruct
end

@testset "rules" begin
    LeafNode(id, labels) = ExprTree(ExprInfo(labels, id))
    t1 = ExprTree(LeafNode(3, [1,2]), ExprTree(LeafNode(1,[2,3]), LeafNode(2,[1,4]), ExprInfo([1,2])), ExprInfo([2]))
    t2 = ExprTree(ExprTree(LeafNode(1, [2,3]), LeafNode(2, [1,4]), ExprInfo([1,2,3])), LeafNode(3,[1,2]), ExprInfo([2]))
    t3 = ExprTree(LeafNode(1,[2,3]), LeafNode(2, [1,2]), ExprInfo([2]))
    t4 = ExprTree(ExprTree(LeafNode(1, [2,3]), LeafNode(2, [1,4]), ExprInfo([1,2])), ExprTree(LeafNode(4,[5,1]), LeafNode(3,[1]), ExprInfo([1])), ExprInfo([2]))
    @test ruleset(TreeDecomp(), t1) == 3:4
    @test ruleset(TreeDecomp(), t2) == 1:2
    @test ruleset(TreeDecomp(), t3) == 1:0
    @test ruleset(TreeDecomp(), t4) == 1:4
    @test_throws AssertionError ruleset(PathDecomp(), t1)
    @test ruleset(PathDecomp(), t2) == 1:1
    @test ruleset(PathDecomp(), t3) == 5:5
    @test_throws AssertionError ruleset(PathDecomp(), t4)
    log2_sizes = ones(5)
    _tcsc(t, l) = tcscrw(labels(t.left), labels(t.right), labels(t), l, true)
    @test all(_tcsc(t1, log2_sizes) .≈ (2.0, 1.0, log2(10)))
    @test all(_tcsc(t2, log2_sizes) .≈ (2.0, 1.0, log2(14)))
    @test all(_tcsc(t3, log2_sizes) .≈ (1.0, 1.0, log2(10)))
    @test all(_tcsc(t4, log2_sizes) .≈ (2.0, 1.0, log2(8)))
    t11 = update_tree!(copy(t1), 3, [2])
    @test t11 == ExprTree(LeafNode(1,[2,3]), ExprTree(LeafNode(3,[1,2]), LeafNode(2,[1,4]), ExprInfo([2])), ExprInfo([2]))
    t11_ = update_tree!(copy(t1), 4, [1,2])
    @test t11_ == ExprTree(LeafNode(2,[1,4]), ExprTree(LeafNode(1,[2,3]), LeafNode(3,[1,2]), ExprInfo([1,2])), ExprInfo([2]))
    t22 = update_tree!(copy(t2), 1, [1,2])
    @test t22 == ExprTree(ExprTree(LeafNode(1,[2,3]), LeafNode(3,[1,2]), ExprInfo([1,2])), LeafNode(2,[1,4]), ExprInfo([2]))
    t22_ = update_tree!(copy(t2), 2, [2])
    @test t22_ == ExprTree(ExprTree(LeafNode(3, [1,2]), LeafNode(2,[1,4]), ExprInfo([2])), LeafNode(1,[2,3]), ExprInfo([2]))
    t44 = update_tree!(copy(t4), 1, [1,2])
    @test t44 == ExprTree(ExprTree(LeafNode(1,[2,3]), ExprTree(LeafNode(4,[5,1]), LeafNode(3,[1]), ExprInfo([1])), ExprInfo([1,2])), LeafNode(2,[1,4]), ExprInfo([2]))
end

@testset "optimization" begin
    function random_regular_eincode(n, k)
        g = Graphs.random_regular_graph(n, k)
        ixs = [[minmax(e.src,e.dst)...] for e in Graphs.edges(g)]
        return OMEinsumContractionOrders.EinCode([ixs..., [[i] for i in Graphs.vertices(g)]...], Int[])
    end
    Random.seed!(2)
    n = 40
    log2_sizes = rand(n+n÷2) * 2
    code = random_regular_eincode(n, 3)
    optcode = optimize_greedy(code, uniformsize(code, 2); α=0.0, temperature=0.0)
    println(code)
    println(optcode)
    tree = ExprTree(optcode)
    tc0, sc0, rw0 = tree_timespace_complexity(tree, log2_sizes)
    size_dict = Dict([j=>exp2(log2_sizes[j]) for j=1:length(log2_sizes)])
    cc0 = contraction_complexity(OMEinsumContractionOrders.NestedEinsum(tree), size_dict)
    tc0_, sc0_ = cc0.tc, cc0.sc
    @test tc0 ≈ tc0_ && sc0 ≈ sc0_
    opt_tree = copy(tree)
    optimize_subtree!(opt_tree, 100.0, log2_sizes, 5, 2.0, 1.0, TreeDecomp())
    tc1, sc1, rw0 = tree_timespace_complexity(opt_tree, log2_sizes)
    @test sc1 < sc0 || (sc1 == sc0 && tc1 < tc0)
end

@testset "optimize tree sa" begin
    function random_regular_eincode(n, k)
        g = Graphs.random_regular_graph(n, k)
        ixs = [[minmax(e.src,e.dst)...] for e in Graphs.edges(g)]
        return OMEinsumContractionOrders.EinCode([ixs..., [[i] for i in Graphs.vertices(g)]...], Int[])
    end
    Random.seed!(3)
    n = 60
    ne = n + n÷2
    log2_sizes = ones(ne)
    code = random_regular_eincode(n, 3)
    optcode = optimize_greedy(code, uniformsize(code, 2); α=0.0, temperature=0.0)
    tree = ExprTree(optcode)
    tc0, sc0, rw0 = tree_timespace_complexity(tree, log2_sizes)
    opttree = copy(tree)
    optimize_tree_sa!(opttree, log2_sizes; βs=0.1:0.1:10.0, niters=100, score=ScoreFunction(sc_target=sc0-2.0), decomposition_type=TreeDecomp())
    tc1, sc1, rw1 = tree_timespace_complexity(opttree, log2_sizes)
    @test sc1 < sc0 || (sc1 == sc0 && tc1 < tc0)
end

@testset "sa tree" begin
    function random_regular_eincode(n, k)
        g = Graphs.random_regular_graph(n, k)
        ixs = [[minmax(e.src,e.dst)...] for e in Graphs.edges(g)]
        return OMEinsumContractionOrders.EinCode([ixs..., [[i] for i in Graphs.vertices(g)]...], Int[])
    end
    Random.seed!(2)
    g = random_regular_graph(220, 3)
    code = random_regular_eincode(220, 3)
    res = optimize_greedy(code,uniformsize(code, 2); α=0.0, temperature=0.0)
    cc = contraction_complexity(res, uniformsize(code, 2))
    tc, sc = cc.tc, cc.sc

    @test optimize_tree(res, uniformsize(code, 2); βs=0.1:0.05:20.0, ntrials=0, niters=10, initializer=:greedy, score=ScoreFunction(sc_target=32), decomposition_type=TreeDecomp()) isa OMEinsumContractionOrders.NestedEinsum
    optcode = optimize_tree(res, uniformsize(code, 2); βs=0.1:0.05:20.0, ntrials=2, niters=10, initializer=:greedy, score=ScoreFunction(sc_target=32), decomposition_type=TreeDecomp())
    cc = contraction_complexity(optcode, uniformsize(code, 2))
    @test cc.sc <= 32

    # contraction test
    code = random_regular_eincode(50, 3)
    codek = optimize_greedy(code, uniformsize(code, 2); α=0.0, temperature=0.0)
    codeg = optimize_tree(code, uniformsize(code, 2); initializer=:random, βs=0.1:0.05:20.0, ntrials=2, niters=10, score=ScoreFunction(sc_target=12), decomposition_type=TreeDecomp())
    cc = contraction_complexity(codek, uniformsize(code, 2))
    @test cc.sc <= 12
    xs = [[2*randn(2, 2) for i=1:75]..., [randn(2) for i=1:50]...]
    resg = decorate(codeg)(xs...)
    resk = decorate(codek)(xs...)
    @test resg ≈ resk

    # contraction test
    code = random_regular_eincode(50, 3)
    codek = optimize_greedy(code, uniformsize(code, 2); α=0.0, temperature=0.0)
    codeg = optimize_tree(codek, uniformsize(code, 2); initializer=:specified, βs=0.1:0.05:20.0, ntrials=2, niters=10, score=ScoreFunction(sc_target=12), decomposition_type=TreeDecomp())
    cc = contraction_complexity(codek, uniformsize(code, 2))
    @test cc.sc <= 12
    xs = [[2*randn(2, 2) for i=1:75]..., [randn(2) for i=1:50]...]
    resg = decorate(codeg)(xs...)
    resk = decorate(codek)(xs...)
    @test resg ≈ resk
end

@testset "fast log2sumexp2" begin
    a, b, c = randn(3)
    @test fast_log2sumexp2(a, b) ≈ log2(sum(exp2.([a,b])))
    @test fast_log2sumexp2(a, b, c) ≈ log2(sum(exp2.([a,b,c])))
end

@testset "path decomposition" begin
    function random_regular_eincode(n, k)
        g = Graphs.random_regular_graph(n, k)
        ixs = [[minmax(e.src,e.dst)...] for e in Graphs.edges(g)]
        return OMEinsumContractionOrders.EinCode([ixs..., [[i] for i in Graphs.vertices(g)]...], Int[])
    end
    Random.seed!(2)
    code = random_regular_eincode(50, 3)
    codek = optimize_greedy(code, uniformsize(code, 2); α=0.0, temperature=0.0)
    codeg = optimize_tree(code, uniformsize(code, 2); initializer=:random, βs=0.1:0.05:20.0, ntrials=2, niters=10, score=ScoreFunction(sc_target=12), decomposition_type=PathDecomp())
    @test !OMEinsumContractionOrders.is_path_decomposition(codek)
    @test OMEinsumContractionOrders.is_path_decomposition(codeg)
    @test OMEinsumContractionOrders.is_path_decomposition(OMEinsumContractionOrders.SlicedEinsum([1,2], codeg))
    cc = contraction_complexity(codek, uniformsize(code, 2))
    @test cc.sc <= 12
    cc = contraction_complexity(codeg, uniformsize(code, 2))
    @test cc.sc <= 12
    xs = [[2*randn(2, 2) for i=1:75]..., [randn(2) for i=1:50]...]
    resg = decorate(codeg)(xs...)
    resk = decorate(codek)(xs...)
    @test resg ≈ resk

    # no optimization
    codeg = optimize_tree(code, uniformsize(code, 2); initializer=:random, βs=0.1:0.05:-20.0, ntrials=2, niters=10, score=ScoreFunction(sc_target=12), decomposition_type=PathDecomp())
    cc = contraction_complexity(codeg, uniformsize(code, 2))
    @test OMEinsumContractionOrders.is_path_decomposition(codeg)
    @test cc.sc > 12
end

function ein2hypergraph(args...; kwargs...)
    throw(ArgumentError("Extension `LuxorTensorPlot` not loaeded, please load it first by `using LuxorGraphPlot`."))
end

function ein2elimination(args...; kwargs...)
    throw(ArgumentError("Extension `LuxorTensorPlot` not loaeded, please load it first by `using LuxorGraphPlot`."))
end

"""
    viz_eins(code::AbstractEinsum; locs=StressLayout(), filename = nothing, kwargs...)

Visualizes an `AbstractEinsum` object by creating a tensor network graph and rendering it using GraphViz.

# Arguments
- `code::AbstractEinsum`: The `AbstractEinsum` object to visualize.

# Keyword Arguments
- `locs=StressLayout()`: The coordinates or layout algorithm to use for positioning the nodes in the graph.
- `filename = nothing`: The name of the file to save the visualization to. If `nothing`, the visualization will be displayed on the screen instead of saving to a file.
- `config = GraphDisplayConfig()`: The configuration for displaying the graph. Please refer to the documentation of [`GraphDisplayConfig`](https://giggleliu.github.io/LuxorGraphPlot.jl/dev/ref/#LuxorGraphPlot.GraphDisplayConfig) for more information.
- `kwargs...`: Additional keyword arguments to be passed to the [`GraphViz`](https://giggleliu.github.io/LuxorGraphPlot.jl/dev/ref/#LuxorGraphPlot.GraphViz) constructor.
"""
function viz_eins(args...; kwargs...)
    throw(ArgumentError("Extension `LuxorTensorPlot` not loaeded, please load it first by `using LuxorGraphPlot`."))
end

"""
    viz_contraction(code::Union{NestedEinsum, SlicedEinsum}; locs=StressLayout(), framerate=10, filename=tempname() * ".mp4", show_progress=true)

Visualize the contraction process of a tensor network.

# Arguments
- `code`: The tensor network to visualize.

# Keyword Arguments
- `locs`: The coordinates or layout algorithm to use for positioning the nodes in the graph. Default is `StressLayout()`.
- `framerate`: The frame rate of the animation. Default is `10`.
- `filename`: The name of the output file, with `.gif` or `.mp4` extension. Default is a temporary file with `.mp4` extension.
- `show_progress`: Whether to show progress information. Default is `true`.

# Returns
- the path of the generated file.
"""
function viz_contraction(args...; kwargs...)
    throw(ArgumentError("Extension `LuxorTensorPlot` not loaeded, please load it first by `using LuxorGraphPlot`."))
end

using OMEinsum, OMEinsumContractionOrders
using Test, Random, Graphs
using KaHyPar
using OMEinsum

@testset "interface" begin
    function random_regular_eincode(n, k)
        g = Graphs.random_regular_graph(n, k)
        ixs = [minmax(e.src,e.dst) for e in Graphs.edges(g)]
        return EinCode((ixs..., [(i,) for i in Graphs.vertices(g)]...), ())
    end
    Random.seed!(2)
    g = random_regular_graph(100, 3)
    code = random_regular_eincode(100, 3)
    xs = [[randn(2,2) for i=1:150]..., [randn(2) for i=1:100]...]

    results = Float64[]
    for optimizer in [TreeSA(ntrials=1), GreedyMethod(), SABipartite(sc_target=18, ntrials=1), HyperND()]
        for simplifier in (nothing, MergeVectors(), MergeGreedy())
            # (nothing, TreeSASlicer(score=ScoreFunction(sc_target=10)))
            for slicer in (nothing,)  # TODO: add this test later!!!
                @info "optimizer = $(optimizer), simplifier = $(simplifier), slicer = $(slicer)"
                res = optimize_code(code,uniformsize(code, 2), optimizer, simplifier)#, slicer)
                @test OMEinsumContractionOrders.is_binary(OMEinsum.rawcode(res))
                tc, sc = OMEinsum.timespace_complexity(res, uniformsize(code, 2))
                @test sc <= 18
                push!(results, res(xs...)[])
            end
        end
    end
    if isdefined(Base, :get_extension)
        optimizer = KaHyParBipartite(sc_target=18)
        for simplifier in (nothing, MergeVectors(), MergeGreedy())
            @info "optimizer = $(optimizer), simplifier = $(simplifier)"
            res = optimize_code(code, uniformsize(code, 2), optimizer, simplifier)
            tc, sc = OMEinsum.timespace_complexity(res, uniformsize(code, 2))
            @test sc <= 18
            push!(results, res(xs...)[])
        end
    end
    for i=1:length(results)-1
        @test results[i] ≈ results[i+1]
    end

    small_code = random_regular_eincode(10, 3)
    xs = [[randn(2,2) for i=1:15]..., [randn(2) for i=1:10]...]

    results = Float64[]
    for optimizer in [TreeSA(ntrials=1), GreedyMethod(), SABipartite(sc_target=18, ntrials=1), ExactTreewidth(), HyperND()]
        for simplifier in (nothing, MergeVectors(), MergeGreedy())
            @info "optimizer = $(optimizer), simplifier = $(simplifier)"
            res = optimize_code(small_code, uniformsize(small_code, 2), optimizer, simplifier)
            tc, sc = OMEinsum.timespace_complexity(res, uniformsize(small_code, 2))
            push!(results, res(xs...)[])
        end
    end
    if isdefined(Base, :get_extension)
        optimizer = KaHyParBipartite(sc_target=18)
        for simplifier in (nothing, MergeVectors(), MergeGreedy())
            @info "optimizer = $(optimizer), simplifier = $(simplifier)"
            res = optimize_code(small_code,uniformsize(small_code, 2), optimizer, simplifier)
            tc, sc = OMEinsum.timespace_complexity(res, uniformsize(small_code, 2))
            push!(results, res(xs...)[])
        end
    end
    for i=1:length(results)-1
        @test results[i] ≈ results[i+1]
    end
end

@testset "corner case: smaller contraction orders" begin
    code = ein"i->"
    sizes = uniformsize(code, 2)
    sne = StaticNestedEinsum((StaticNestedEinsum{Char}(1),), code)
    dne = DynamicNestedEinsum((DynamicNestedEinsum{Char}(1),), DynamicEinCode(code))
    @test optimize_code(code, sizes, GreedyMethod()) == sne
    @test optimize_code(code, sizes, TreeSA()) == dne
    isdefined(Base, :get_extension) &&  (@test optimize_code(code, sizes, KaHyParBipartite(sc_target=25)) == dne)
    @test optimize_code(code, sizes, SABipartite(sc_target=25)) == dne
end

@testset "peak memory" begin
    Random.seed!(2)
    code = ein"(ab,a),ac->bc"
    @test peak_memory(code, uniformsize(code, 5)) == 75

    function random_regular_eincode(n, k)
        g = Graphs.random_regular_graph(n, k)
        ixs = [minmax(e.src,e.dst) for e in Graphs.edges(g)]
        return EinCode((ixs..., [(i,) for i in Graphs.vertices(g)]...), ())
    end
    code = random_regular_eincode(50, 3)
    @test peak_memory(code, uniformsize(code, 5)) == (25 * 75 + 5 * 50)
    
    code1 = optimize_code(code, uniformsize(code, 5), GreedyMethod())
    pm1 = peak_memory(code1, uniformsize(code, 5))
    tc1, sc1, rw1 = timespacereadwrite_complexity(code1, uniformsize(code, 5))
    @test 10 * 2^sc1 > pm1 > 2^sc1

    # code2 = slice_code(code1, uniformsize(code, 5), TreeSASlicer(sc_target=10))
    # pm2 = peak_memory(code2, uniformsize(code, 5))
    # tc2, sc2, rw2 = timespacereadwrite_complexity(code2, uniformsize(code, 5))
    # @test sc2 <= 10
    # @test 10 * 2^sc2 > pm2 > 2^sc2
end



if isdefined(Base, :get_extension)
    @testset "kahypar regression test" begin
        code = ein"i->"
        optcode = optimize_code(code, Dict('i'=>4), KaHyParBipartite(; sc_target=10, max_group_size=10))
        @test optcode isa NestedEinsum
        x = randn(4)
        @test optcode(x) ≈ code(x)

        code = ein"i,j->"
        optcode = optimize_code(code, Dict('i'=>4, 'j'=>4), KaHyParBipartite(; sc_target=10, max_group_size=10))
        @test optcode isa NestedEinsum
        x = randn(4)
        y = randn(4)
        @test optcode(x, y) ≈ code(x, y)

        code = ein"ij,jk,kl->ijl"
        println(code)
        optcode = optimize_code(code, Dict('i'=>4, 'j'=>4, 'k'=>4, 'l'=>4), KaHyParBipartite(; sc_target=4, max_group_size=2))
        println(optcode)
        @test optcode isa NestedEinsum
        a, b, c = [rand(4,4) for i=1:4]
        @test optcode(a, b, c) ≈ code(a, b, c)

        code = ein"ij,jk,kl->ijl"
        optcode = optimize_code(code, Dict('i'=>3, 'j'=>3, 'k'=>3, 'l'=>3), KaHyParBipartite(; sc_target=4, max_group_size=2))
        @test optcode isa NestedEinsum
        a, b, c = [rand(3,3) for i=1:4]
        @test optcode(a, b, c) ≈ code(a, b, c)
    end
end

@testset "path decomposition" begin
    code = ein"i,j->"
    optcode = optimize_code(code, Dict('i'=>1024, 'j'=>1024), PathSA())
    @test OMEinsumContractionOrders.is_path_decomposition(OMEinsum.rawcode(optcode))
    code = ein"lm,jk,ij,kl->"
    optcode = optimize_code(code, Dict('i'=>1024, 'j'=>1024, 'k'=>1024, 'l'=>1024, 'm'=>1024), PathSA())
    @test OMEinsumContractionOrders.is_path_decomposition(OMEinsum.rawcode(optcode))
    cc = contraction_complexity(optcode, uniformsize(code, 1024))
    @test cc.sc ≈ 10
end

using OMEinsumContractionOrders.CliqueTrees, OMEinsumContractionOrders.Graphs, OMEinsumContractionOrders.AbstractTrees
using OMEinsumContractionOrders
using OMEinsumContractionOrders: EinCode

struct TensorNQ
    labels::Vector{Int}
end
struct TensorNQLattice
    lattice::Matrix{TensorNQ}
    pos10::Vector{Int}
    pos01::Vector{Int}
    pos11::Vector{Int}
end

function generate_TensorNQ_lattice(n::Int)
    # res = Matrix{TensorNQ}(undef,n,n)
    res = fill(TensorNQ(fill(-1,9)),n,n)
    label_count = 0

    pos_vec = [(0,-1), (1,-1), (-1,-1), (-1,0),(0,0), (1,0), (1,1),(-1,1),(0,1)]

    pos11 = Int[]
    pos01 = Int[]
    pos10 = Int[]
    for i in 1:n
        for j in 1:n
            index_vec = fill(-1,9)
            for (ind,pos) in enumerate(pos_vec)
                if checkbounds(Bool,res,i+pos[1],j+pos[2])
                    if res[i+pos[1],j+pos[2]].labels[10-ind] != -1
                        index_vec[ind] = res[i+pos[1],j+pos[2]].labels[10-ind]
                    else
                        label_count += 1
                        index_vec[ind] = label_count
                    end
                else
                    label_count += 1
                    index_vec[ind] = label_count
                    if ind < 5
                        push!(pos10,label_count)
                    elseif ind == 9 || ind == 6
                        push!(pos01,label_count)
                    else
                        push!(pos11,label_count)
                    end
                end
            end
            res[i,j] = TensorNQ(index_vec)
        end
    end
    return TensorNQLattice(res, pos10,pos01,pos11 ∪ [res[i,j].labels[5] for i in 1:n, j in 1:n])
end

function generate_3_tensor_network(n::Int)
    t9_lattice = generate_TensorNQ_lattice(n)
    return generate_3_tensor_network(t9_lattice)
end
function generate_3_tensor_network(t9_lattice::TensorNQLattice)
    lattice,pos10,pos01,pos11 = t9_lattice.lattice,t9_lattice.pos10,t9_lattice.pos01,t9_lattice.pos11
    t3_ixs = Vector{Vector{Int}}()
    t9_ixs = getfield.(vec(lattice),:labels)

    for vec in t9_ixs
        for i in 1:4
            push!(t3_ixs,[vec[i],vec[10-i],vec[5]])
        end
    end
    return EinCode(t3_ixs ∪ [[p] for p in pos10] ∪ [[p] for p in pos01] ∪  [[p] for p in pos11],Int[])
end

function main(optimizer)
    @info "Running N-Queens with optimizer: $(optimizer)"
    n = 28
    code = generate_3_tensor_network(n)
    time_elapsed = @elapsed optcode = optimize_code(code, uniformsize(code, 2), optimizer)
    @info "Contraction complexity: $(contraction_complexity(optcode, uniformsize(optcode, 2))), time cost: $(time_elapsed)s"
    return contraction_complexity(optcode, uniformsize(optcode, 2))
end

using Graphs
using OMEinsumContractionOrders
using OMEinsumContractionOrders: optimize_hyper_nd
using Random
using Test

import KaHyPar

@testset "chain and ring" begin
    # chain
    code = OMEinsumContractionOrders.EinCode([[1,2], [2,3], [3,4], [4,5], [5,6], [6,7], [7,8], [8,9], [9,10]], Int[1, 10])
    size_dict = Dict([i=>2 for i in 1:10])
    optcode = optimize_hyper_nd(HyperND(; width=5), code, size_dict)
    cc = contraction_complexity(optcode, size_dict)
    @test cc.sc == 2

    # ring
    ring = OMEinsumContractionOrders.EinCode([[1,2], [2,3], [3,4], [4,5], [5,6], [6,7], [7,8], [8,9], [9,10], [10,1]], Int[])
    optcode = optimize_hyper_nd(HyperND(; width=5), ring, size_dict)
    cc = contraction_complexity(optcode, size_dict)
    @test cc.sc == 2

    # petersen
    graph = smallgraph(:tutte)
    code = OMEinsumContractionOrders.EinCode([[e.src, e.dst] for e in edges(graph)], Int[])
    size_dict = Dict([i=>2 for i in 1:nv(graph)])
    optcode = optimize_hyper_nd(HyperND(; width=5), code, size_dict)
    cc = contraction_complexity(optcode, size_dict)
    @test cc.sc == 5
end

"""
    KaHyParBipartite{RT,IT,GM}
    KaHyParBipartite(; sc_target, imbalances=collect(0.0:0.005:0.8),
        max_group_size=40, greedy_config=GreedyMethod())

Optimize the einsum code contraction order using the KaHyPar + Greedy approach.
This program first recursively cuts the tensors into several groups using KaHyPar,
with maximum group size specifed by `max_group_size` and maximum space complexity specified by `sc_target`,
Then finds the contraction order inside each group with the greedy search algorithm. Other arguments are

# Fields
- `sc_target` is the target space complexity, defined as `log2(number of elements in the largest tensor)`,
- `imbalances` is a KaHyPar parameter that controls the group sizes in hierarchical bipartition,
- `max_group_size` is the maximum size that allowed to used greedy search,
- `sub_optimizer` is the sub-optimizer used to find the contraction order when the group size is small enough.

# References
- [Hyper-optimized tensor network contraction](https://arxiv.org/abs/2002.01935)
- [Simulating the Sycamore quantum supremacy circuits](https://arxiv.org/abs/2103.03074)
"""
Base.@kwdef struct KaHyParBipartite{RT,IT,SO} <: CodeOptimizer
    sc_target::RT
    imbalances::IT = 0.0:0.005:0.8
    max_group_size::Int = 40
    sub_optimizer::SO = GreedyMethod()
end

function induced_subhypergraph(s::SparseMatrixCSC, group)
    s0 = s[group,:]
    nvs = vec(sum(s0, dims=1))
    remaining_edges = findall(!iszero, nvs)
    s0[:,remaining_edges], remaining_edges
end

function convert2int(sizes::AbstractVector)
    round.(Int, sizes .* 100)
end

"""
    BipartiteResult{RT}
    BipartiteResult(part1, part2, sc, valid)

Result of the bipartite optimization. `part1` and `part2` are the two parts of the bipartition, `sc` is the space complexity of the bipartition, `valid` is a boolean indicating whether the bipartition is valid.
"""
struct BipartiteResult{RT}
    part1::Vector{Int}
    part2::Vector{Int}
    sc::RT
    valid::Bool
end

function bipartite_sc(bipartiter, adj::SparseMatrixCSC, vertices, log2_sizes)
    error("""Guess you are trying to use the `KaHyParBipartite` optimizer.
Then you need to add `using KaHyPar` first!""")
end

# the space complexity (external degree of freedoms) if we contract this group
function group_sc(adj, group, log2_sizes)
    degree_in = sum(adj[group,:], dims=1)
    degree_all = sum(adj, dims=1)
    sum(i->(degree_in[i]!=0 && degree_in[i]!=degree_all[i] ? Float64(log2_sizes[i]) : 0.0), 1:size(adj,2))
end

function bipartition_recursive(bipartiter, adj::SparseMatrixCSC, vertices::AbstractVector{T}, log2_sizes) where T
    if length(vertices) > bipartiter.max_group_size
        res = bipartite_sc(bipartiter, adj, vertices, log2_sizes)
        !res.valid && @warn "fail to find a valid partition for `sc_target = $(bipartiter.sc_target)`, got minimum value `$(res.sc)` (imbalances = $(bipartiter.imbalances))"
        groups = Vector{T}[]
        for part in (res.part1, res.part2)
            for component in _connected_components(adj, part)
                push!(groups, component)
            end
        end
        newparts = [bipartition_recursive(bipartiter, adj, groups[i], log2_sizes) for i=1:length(groups)]
        if length(groups) > 2
            # number of groups is small (2 or 3), thus I think it is not necessary to use more complex methods.
            tree = coarse_grained_optimize(adj, groups, log2_sizes, GreedyMethod())
            return map_tree_to_parts(tree, newparts)
        else
            return newparts
        end
    else
        return [vertices]
    end
end

# parts are vectors of Ts
function coarse_grained_optimize(adj, parts, log2_sizes, sub_optimizer)
    incidence_list = get_coarse_grained_graph(adj, parts)
    log2_edge_sizes = Dict([i=>log2_sizes[i] for i=1:length(log2_sizes)])
    tree, _, _ = tree_greedy(incidence_list, log2_edge_sizes; α = sub_optimizer.α, temperature = sub_optimizer.temperature)
    return tree
end

function get_coarse_grained_graph(adj, parts)
    ADJ = vcat([sum(adj[part,:], dims=1) for part in parts]...)
    degree_in = sum(ADJ, dims=1)
    degree_all = sum(adj, dims=1)
    openedges = filter(i->degree_in[i]!=0 && degree_in[i]!=degree_all[i], 1:size(adj, 2))
    v2e = Dict{Int,Vector{Int}}()
    for v=1:size(ADJ, 1)
        v2e[v] = findall(!iszero, view(ADJ,v,:))
    end
    incidence_list = IncidenceList(v2e; openedges=openedges)
    return incidence_list
end

function map_tree_to_parts(tree, parts)
    if tree isa ContractionTree
        [map_tree_to_parts(tree.left, parts), map_tree_to_parts(tree.right, parts)]
    else
        parts[tree]
    end
end

# KaHyPar
function adjacency_matrix(ixs::AbstractVector)
    rows = Int[]
    cols = Int[]
    edges = unique!([Iterators.flatten(ixs)...])
    for (i,ix) in enumerate(ixs)
        push!(rows, map(x->i, ix)...)
        push!(cols, map(x->findfirst(==(x), edges), ix)...)
    end
    return sparse(rows, cols, ones(Int, length(rows)), length(ixs), length(edges)), edges
end

function recursive_bipartite_optimize(bipartiter, code::AbstractEinsum, size_dict)
    ixs, iy = getixsv(code), getiyv(code)
    ixv = [ixs..., iy]
    
    adj, edges = adjacency_matrix(ixv)
    vertices = collect(1:length(ixv))
    parts = bipartition_recursive(bipartiter, adj, vertices, [log2(size_dict[e]) for e in edges])
    optcode = recursive_construct_nestedeinsum(ixv, empty(iy), parts, size_dict, 0, bipartiter.sub_optimizer)
    return fix_binary_tree(pivot_tree(optcode, length(ixs) + 1))
end

maplocs(ne::NestedEinsum{ET}, parts) where ET = isleaf(ne) ? NestedEinsum{ET}(parts[ne.tensorindex]) : NestedEinsum(maplocs.(ne.args, Ref(parts)), ne.eins)

function kahypar_recursive(ne::NestedEinsum; log2_size_dict, sc_target, min_size, imbalances=0.0:0.04:0.8)
    if length(ne.args >= min_size) && all(isleaf, ne.args)
        bipartite_eincode(adj, ne.args, ne.eins; log2_size_dict=log2_size_dict, sc_target=sc_target, min_size=min_size, imbalances=imbalances)
    end
    kahypar_recursive(ne.args; log2_size_dict, sc_target=sc_target, min_size=min_size, imbalances=imbalances)
end

recursive_flatten(obj::Tuple) = vcat(recursive_flatten.(obj)...)
recursive_flatten(obj::AbstractVector) = vcat(recursive_flatten.(obj)...)
recursive_flatten(obj) = obj

function recursive_construct_nestedeinsum(ixs::AbstractVector{<:AbstractVector}, iy::AbstractVector{L}, parts::AbstractVector, size_dict, level, sub_optimizer) where L
    if length(parts) == 2
        # code is a nested einsum
        code1 = recursive_construct_nestedeinsum(ixs, iy, parts[1], size_dict, level+1, sub_optimizer)
        code2 = recursive_construct_nestedeinsum(ixs, iy, parts[2], size_dict, level+1, sub_optimizer)
        AB = recursive_flatten(parts[2]) ∪ recursive_flatten(parts[1])
        inset12, outset12 = ixs[AB], ixs[setdiff(1:length(ixs), AB)]
        iy12 = Iterators.flatten(inset12) ∩  (Iterators.flatten(outset12) ∪ iy)
        iy1, iy2 = getiyv(code1.eins), getiyv(code2.eins)
        return NestedEinsum([code1, code2], EinCode([iy1, iy2], L[(level==0 ? iy : iy12)...]))
    elseif length(parts) == 1
        return recursive_construct_nestedeinsum(ixs, iy, parts[1], size_dict, level, sub_optimizer)
    else
        error("not a bipartition, got size $(length(parts))")
    end
end

function recursive_construct_nestedeinsum(ixs::AbstractVector{<:AbstractVector}, iy::AbstractVector{L}, parts::AbstractVector{<:Integer}, size_dict, level, sub_optimizer) where L
    if isempty(parts)
        error("got empty group!")
    end
    inset, outset = ixs[parts], ixs[setdiff(1:length(ixs), parts)]
    iy1 = level == 0 ? iy : Iterators.flatten(inset) ∩  (Iterators.flatten(outset) ∪ iy)
    res = optimize_code(EinCode(inset, iy1), size_dict, sub_optimizer)
    if res isa SlicedEinsum
        @assert length(res.slicing) == 0
        res = res.eins
    end
    return maplocs(res, parts)
end

"""
    struct Treewidth{EL <: EliminationAlgorithm, GM} <: CodeOptimizer
    Treewidth(; alg::EL = SafeRules(BT(), MMW{3}(), MF()))

Tree width based solver. The solvers are implemented in [CliqueTrees.jl](https://algebraicjulia.github.io/CliqueTrees.jl/stable/) and [TreeWidthSolver.jl](https://github.com/ArrogantGao/TreeWidthSolver.jl). They include:

| Algorithm | Description | Time Complexity | Space Complexity |
|:-----------|:-------------|:----------------|:-----------------|
| `AMF` | approximate minimum fill | O(mn) | O(m + n) |
| `MF` | minimum fill | O(mn²) | - |
| `MMD` | multiple minimum degree | O(mn²) | O(m + n) |

Detailed descriptions is available in the [CliqueTrees.jl](https://algebraicjulia.github.io/CliqueTrees.jl/stable/api/#Elimination-Algorithms).

# Fields
- `alg::EL`: The algorithm to use for the treewidth calculation. Available elimination algorithms are listed above.

# Example
```jldoctest
julia> optimizer = Treewidth();

julia> eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], ['a'])
ab, acd, bcef, e, df -> a

julia> size_dict = Dict([c=>(1<<i) for (i,c) in enumerate(['a', 'b', 'c', 'd', 'e', 'f'])]...)
Dict{Char, Int64} with 6 entries:
  'f' => 64
  'a' => 2
  'c' => 8
  'd' => 16
  'e' => 32
  'b' => 4

julia> optcode = optimize_code(eincode, size_dict, optimizer)
ab, ba -> a
├─ ab
└─ bcf, acf -> ba
   ├─ bcef, e -> bcf
   │  ├─ bcef
   │  └─ e
   └─ acd, df -> acf
      ├─ acd
      └─ df
```
"""
Base.@kwdef struct Treewidth{EL <: EliminationAlgorithm} <: CodeOptimizer 
    alg::EL = SafeRules(BT(), MMW{3}(), MF())
end

"""
    const ExactTreewidth = Treewidth{SafeRules{BT, MMW{3}(), MF}}
    ExactTreewidth() = Treewidth()

`ExactTreewidth` is a specialization of `Treewidth` for the `SafeRules` preprocessing algorithm with the `BT` elimination algorithm.
The `BT` algorithm is an exact solver for the treewidth problem that implemented in [`TreeWidthSolver.jl`](https://github.com/ArrogantGao/TreeWidthSolver.jl).
"""
const ExactTreewidth = Treewidth{SafeRules{BT, MMW{3}, MF}}
ExactTreewidth() = Treewidth()

"""
    optimize_treewidth(optimizer, eincode, size_dict)

Optimizing the contraction order via solve the exact tree width of the line graph corresponding to the eincode and return a `NestedEinsum` object.
Check the docstring of `treewidth_method` for detailed explaination of other input arguments.
"""
function optimize_treewidth(optimizer::Treewidth, code::AbstractEinsum, size_dict::Dict; binary::Bool=true)
    optimize_treewidth(optimizer, getixsv(code), getiyv(code), size_dict; binary)
end

function optimize_treewidth(optimizer::Treewidth, ixs::AbstractVector{<:AbstractVector}, iy::AbstractVector, size_dict::Dict{L, Int}; binary::Bool=true) where {L}
    log2_size_dict = _log2_size_dict(size_dict)
    marker = zeros(Int, max(length(ixs) + 1, length(size_dict)))

    # construct incidence matrix `ve`
    #           indices
    #         [         ]
    # tensors [    ve   ]
    #         [         ]
    # we only care about the sparsity pattern
    weights, ev, ve, el = einexpr_to_matrix!(marker, ixs, iy, size_dict)

    # compute a tree (forest) decomposition of `ve`
    tree = matrix_to_tree!(marker, weights, ev, ve, el, optimizer.alg)

    # transform tree decomposition in contraction tree
    code = tree_to_einexpr!(marker, tree, ve, el, ixs, iy)

    if binary
        # binarize contraction tree
        code = optimize_greedy_log2size(code, log2_size_dict; α = 0.0, temperature = 0.0)
    end

    return code
end

"""
    einexpr_to_matrix!(marker, ixs, iy, size_dict)

Construct the weighted incidence matrix correponding to an Einstein summation expression.
Returns a quadruple (weights, ev, ve, el).

Each Einstein summation expression has a set E ⊆ L of indices, a set V := {1, …, |V|} of
(inner) tensors, and an outer tensor * := |V| + 1. Each tensor v ∈ V is incident to a sequence
ixs[v] of indices, and the outer tensor is incident to the sequence iy. Note that an index
can appear multiple times in ixs[v], e.g.

    ixs[v] = ('a', 'a', 'b').

Each index l ∈ E also has a positive dimension, given by size_dict[l].

The function `einexpr_to_matrix` does two things. First of all, it enumerates the index set
E, mapping each index to a distinct natural number.

    el: {1, …, |E|} → E
    le: E → {1, …, |E|}

Next, it constructs a vector weights: {1, …, |E|} → [0, ∞) satisfying

    weights[e] := log2(size_dict[el[e]]),

and a sparse matrix ve: {1, …, |V| + 1} × {1, …, |E|} → {0, 1} satisfying

    ve[v, e] := { 1 if el[e] is incident to v
                { 0 otherwise

We can think of the pair H := (weights, ve) as an edge-weighted hypergraph
with incidence matrix ve.
"""
function einexpr_to_matrix!(marker::AbstractVector{Int}, ixs::AbstractVector{<:AbstractVector{L}}, iy::AbstractVector{L}, size_dict::AbstractDict{L}) where {L}
    m = length(size_dict)
    n = length(ixs) + 1
    o = sum(length, ixs) + length(iy)

    # construct incidence matrix `ve`
    #           indices
    #         [         ]
    # tensors [    ve   ]
    #         [         ]
    # we only care about the sparsity pattern
    le = sizehint!(Dict{L, Int}(), m); el = sizehint!(L[], m) # el ∘ le = id
    weights = sizehint!(Float64[], m)
    colptr = sizehint!(Int[1], n + 1)
    rowval = sizehint!(Int[], o)
    nzval = sizehint!(Int[], o)

    # for all tensors v...
    for (v, ix) in enumerate(ixs)
        # for each index l incident to v...
        for l in ix
            # let e := le[l]
            if haskey(le, l)
                e = le[l]
            else
                push!(weights, log2(size_dict[l]))
                push!(el, l)
                e = le[l] = length(el)
            end

            # if l has not been seen before in ixs[v]...
            if marker[e] < v
                # mark e as seen
                marker[e] = v

                # set ev[e, v] := 1
                push!(rowval, e)
                push!(nzval, 1)
            end           
        end

        push!(colptr, length(rowval) + 1)
    end

    # v is the outer tensor
    v = length(colptr)

    # for each index l incident to v...
    for l in iy
        # let e := le[l]
        if haskey(le, l)
            e = le[l]
        else
            push!(weights, log2(size_dict[l]))
            push!(el, l)
            e = le[l] = length(el)
        end

        # if l has not been seen before in iy...
        if marker[e] < v
            # mark e as seen
            marker[e] = v

            # set ev[e, v] = 1
            push!(rowval, e)
            push!(nzval, 1)
        end           
    end

    push!(colptr, length(rowval) + 1)

    m = length(el)
    n = length(colptr) - 1

    ev = SparseMatrixCSC{Int, Int}(m, n, colptr, rowval, nzval)
    ve = copy(transpose(ev))
    return weights, ev, ve, el
end

"""
    matrix_to_tree!(marker, weights, ev, ve, el, alg)

Construct a tree decomposition of an edge-weighted hypergraph using
the elimination algorithm `alg`. We ensure that the indices incident
to the outer tensor are contained in the root bag of the tree decomposition.
"""
function matrix_to_tree!(marker::AbstractVector{Int}, weights::AbstractVector{Float64}, ev::SparseMatrixCSC{Int, Int}, ve::SparseMatrixCSC{Int, Int}, el::AbstractVector{L}, alg::EliminationAlgorithm) where {L}
    n, m = size(ve); tag = n + 1

    # construct line graph `ee`
    #           indices
    #         [         ]
    # indices [    ee   ]
    #         [         ]
    # we only care about the sparsity pattern
    ee = ve' * ve

    # compute a tree (forest) decomposition of ee
    perm, tree = cliquetree(weights, ee; alg=ConnectedComponents(alg))

    # find the bag containing iy, call it root
    root = length(tree)

    # mark the indices in iy
    for e in view(rowvals(ev), nzrange(ev, n))
        marker[e] = tag
    end

    # the first bag containing an index in iy
    # must contain all of iy
    for (b, bag) in enumerate(tree)
        root < length(tree) && break

        for e in residual(bag)
            root < length(tree) && break

            if marker[perm[e]] == tag
                root = b
            end
        end
    end

    # make root a root node of the tree decomposition
    permute!(perm, cliquetree!(tree, root))

    # permute incidence matrix `ve` and label vector `el`.
    permute!(ve, axes(ve, 1), perm)
    permute!(el, perm)

    return tree
end

"""
    tree_to_einexpr!(marker, tree, ve, el, ixs, iy)

Transform a tree decomposition into a contraction tree.
"""
function tree_to_einexpr!(marker::AbstractVector{Int}, tree::CliqueTree{Int, Int}, ve::SparseMatrixCSC{Int, Int}, el::AbstractVector{L}, ixs::AbstractVector{<:AbstractVector{L}}, iy::AbstractVector{L}) where {L}
    n, m = size(ve); tag = n + 2

    # dynamic programming
    stack = NestedEinsum{L}[]

    # for each bag b...
    for (b, bag) in enumerate(tree)
        # sep is the separator at b
        sep = separator(bag)

        # res is the residual at b
        res = residual(bag)

        # code is the Einstein summation expression at b
        code = NestedEinsum(NestedEinsum{L}[], EinCode(Vector{L}[], L[]))

        for e in sep
            push!(code.eins.iy, el[e])
        end

        # for each index e in the residual...
        for e in res
            # for each tensor v indicent to e...
            for v in view(rowvals(ve), nzrange(ve, e))
                # if has not been seen before...
                if marker[v] < tag
                    # mark v as seen
                    marker[v] = tag

                    # if v is the outer tensor...
                    if v == n
                        # expose iy
                        append!(code.eins.iy, iy)
                    # if v is an inner tensor...
                    else
                        # make v a child of code
                        push!(code.args, NestedEinsum{L}(v))
                        push!(code.eins.ixs, ixs[v])
                    end
                end
            end
        end

        # for each child bag of b...
        for _ in childindices(tree, b)
            # the Einstein summation expression corresponding to
            # the child bag is at the top of the stack
            child = pop!(stack)

            # make this expression a child of code
            push!(code.args, child)
            push!(code.eins.ixs, child.eins.iy)
        end

        # push code to the stack
        push!(stack, code)
    end

    # we now have an expression for each root of the tree decomposition.
    # merge these together into a single Einstein expression code.
    if isone(length(stack))
        code = only(stack)
    else
        code = NestedEinsum(NestedEinsum{L}[], EinCode(Vector{L}[], L[]))
        append!(code.eins.iy, iy)

        while !isempty(stack)
            child = pop!(stack)
            push!(code.args, child)
            push!(code.eins.ixs, child.eins.iy)
        end
    end

    # append scalars to code
    for (v, ix) in enumerate(ixs)
        if isempty(ix)
            push!(code.args, NestedEinsum{L}(v))
            push!(code.eins.ixs, ix)
        end
    end

    return code
end

# no longer used
function il2lg(incidence_list::IncidenceList{VT, ET}, indicies::Vector{ET}) where {VT, ET}
    line_graph = SimpleGraph(length(indicies))
    
    for (i, e) in enumerate(indicies)
        for v in incidence_list.e2v[e]
            for ej in incidence_list.v2e[v]
                if e != ej add_edge!(line_graph, i, findfirst(==(ej), indicies)) end
            end
        end
    end

    return line_graph
end

using OMEinsumContractionOrders
using Test, Random
using OMEinsumContractionOrders: merge_vectors, merge_greedy, optimize_greedy, embed_simplifier, optimize_permute
using OMEinsum: decorate, rawcode, @ein_str
import OMEinsum

function apply_simplifier(s, xs)
    map(s.operations) do op
        return decorate(op)(xs...)
    end
end

function have_identity(ne::OMEinsumContractionOrders.NestedEinsum)
    if OMEinsumContractionOrders.isleaf(ne)
        return false
    elseif length(OMEinsumContractionOrders.getixsv(ne.eins)) == 1 && OMEinsumContractionOrders.getixsv(ne.eins)[1] == OMEinsumContractionOrders.getiyv(ne.eins)
        return true
    else
        return any(have_identity, ne.args)
    end
end

@testset "simplify vectors" begin
    tn = rawcode(ein"ab,bc,cd,de,a,b,c,d,f,f,e->ab")
    xs = [randn(fill(2, length(ix))...) for ix in OMEinsumContractionOrders.getixsv(tn)]
    simplifier, tn2 = merge_vectors(tn)
    @test tn2 == rawcode(ein"ab,bc,cd,de,f->ab")
    @test decorate(tn)(xs...) ≈ decorate(tn2)(apply_simplifier(simplifier, xs)...)
    tn3 = optimize_greedy(tn2, uniformsize(tn2, 2); α=0.0, temperature=0.0)
    tn4 = embed_simplifier(tn3, simplifier)
    @test !have_identity(tn4)
    @test decorate(tn)(xs...) ≈ decorate(tn4)(xs...)

    tn3 = optimize_greedy(tn2, uniformsize(tn2, 2); α=0.0, temperature=0.0)
    tn4 = embed_simplifier(tn3, simplifier)
    @test !have_identity(tn4)
    @test decorate(tn)(xs...) ≈ decorate(tn4)(xs...)
end

@testset "simplify greedy" begin
    tn = rawcode(ein"ab,bc,cd,de,a,b,c,d,f,f,e->ab")
    size_dict = uniformsize(tn, 2)
    xs = [randn(fill(2, length(ix))...) for ix in OMEinsumContractionOrders.getixsv(tn)]
    simplifier, tn2 = merge_greedy(tn, size_dict)
    @test tn2 == rawcode(ein"ab,->ab") || tn2 == rawcode(ein"ba,->ab")
    @test decorate(tn)(xs...) ≈ decorate(tn2)(apply_simplifier(simplifier, xs)...)
    tn3 = optimize_greedy(tn2, uniformsize(tn2, 2); α=0.0, temperature=0.0)
    tn4 = embed_simplifier(tn3, simplifier)
    @test !have_identity(tn4)
    @test decorate(tn)(xs...) ≈ decorate(tn4)(xs...)

    tn3 = optimize_greedy(tn2, uniformsize(tn2, 2); α=0.0, temperature=0.0)
    tn4 = embed_simplifier(tn3, simplifier)
    @test !have_identity(tn4)
    @test decorate(tn)(xs...) ≈ decorate(tn4)(xs...)
end

@testset "optimize permute" begin
    code = ein"lcij,lcjk->kcli" |> rawcode
    @test OMEinsumContractionOrders.optimize_output_permute(OMEinsumContractionOrders.getixsv(code), OMEinsumContractionOrders.getiyv(code)) == collect("iklc")
    code = ein"lcij,lcjk,c->kcli" |> rawcode
    @test OMEinsumContractionOrders.optimize_output_permute(OMEinsumContractionOrders.getixsv(code), OMEinsumContractionOrders.getiyv(code)) == collect("kcli")
    code = ein"lcij,lcjk->" |> rawcode
    @test OMEinsumContractionOrders.optimize_output_permute(OMEinsumContractionOrders.getixsv(code), OMEinsumContractionOrders.getiyv(code)) == Char[]
end

@testset "optimize permute" begin
    code = ein"(lcij,lcjk),lcik->" |> rawcode
    res = OMEinsumContractionOrders.NestedEinsum([OMEinsumContractionOrders.NestedEinsum([OMEinsumContractionOrders.NestedEinsum{Char}(1),
        OMEinsumContractionOrders.NestedEinsum{Char}(2)], ein"lcij,lcjk->iklc" |> rawcode), OMEinsumContractionOrders.NestedEinsum{Char}(3)], ein"iklc,lcik->" |> rawcode)
    @test optimize_permute(code) == res
    code = OMEinsumContractionOrders.SlicedEinsum(['c'], ein"(lcij,lcjk),lcik->" |> rawcode)
    @test optimize_permute(code) == OMEinsumContractionOrders.SlicedEinsum(['c'], res)
end

using OMEinsumContractionOrders, LuxorGraphPlot

using OMEinsumContractionOrders.SparseArrays
using LuxorGraphPlot.Graphs
using LuxorGraphPlot.Luxor
using LuxorGraphPlot.Luxor.FFMPEG

using OMEinsumContractionOrders: AbstractEinsum, NestedEinsum, SlicedEinsum
using OMEinsumContractionOrders: getixsv, getiyv
using OMEinsumContractionOrders: ein2hypergraph, ein2elimination

include("hypergraph.jl")
include("viz_eins.jl")
include("viz_contraction.jl")

using OMEinsumContractionOrders, Test, Random
using OMEinsumContractionOrders: random_exprtree, ExprTree, ExprInfo,
    ruleset, update_tree!, tcscrw, optimize_subtree!, optimize_tree_sa!, labels, tree_timespace_complexity, fast_log2sumexp2,
    ExprTree, _label_dict, Slicer, slice_tree, SlicedEinsum,
    optimize_greedy, optimize_tree, optimize_hyper_nd
using Graphs
using OMEinsum: decorate
using KaHyPar

@testset "slicing" begin
    function random_regular_eincode(n, k)
        g = Graphs.random_regular_graph(n, k)
        ixs = [[minmax(e.src,e.dst)...] for e in Graphs.edges(g)]
        return OMEinsumContractionOrders.EinCode([ixs..., [[i] for i in Graphs.vertices(g)]...], Int[])
    end
    # contraction test
    Random.seed!(2)
    code = random_regular_eincode(100, 3)

    for code0 in [optimize_greedy(code, uniformsize(code, 2); α=0.0, temperature=0.0),
            optimize_tree(code, uniformsize(code, 2); initializer=:greedy, βs=0.1:0.05:20.0, ntrials=2, niters=10, score=ScoreFunction(sc_target=10), decomposition_type=TreeDecomp()),
            optimize_hyper_nd(HyperND(), code, uniformsize(code, 2))]

        codet = slice_tree(code0, uniformsize(code, 2); score=ScoreFunction(sc_target=10), decomposition_type=TreeDecomp())
        @test codet isa SlicedEinsum

        cc0 = contraction_complexity(code0, uniformsize(code, 2))
        cc = contraction_complexity(codet, uniformsize(code, 2))

        @show cc.tc, cc.sc, cc0.tc, cc0.sc
        @show length(codet.slicing)
        @test cc.sc <= 10

        xs = [[2*randn(2, 2) for i=1:150]..., [randn(2) for i=1:100]...]
        res0 = decorate(code0)(xs...)
        rest = decorate(codet)(xs...)
        @test res0 ≈ rest
    end

    # with open edges
    Random.seed!(2)
    code = OMEinsumContractionOrders.EinCode(random_regular_eincode(100, 3).ixs, [3,81,2])

    for code0 in [optimize_greedy(code, uniformsize(code, 2); α=0.0, temperature=0.0),
            optimize_tree(code, uniformsize(code, 2); initializer=:greedy, βs=0.1:0.05:20.0, ntrials=2, niters=10, score=ScoreFunction(sc_target=10), decomposition_type=TreeDecomp()),
            optimize_hyper_nd(HyperND(), code, uniformsize(code, 2))]
        codet = slice_tree(code0, uniformsize(code, 2); score=ScoreFunction(sc_target=10), ntrials = 10, decomposition_type=TreeDecomp())
        @test codet isa SlicedEinsum

        cc0 = contraction_complexity(code0, uniformsize(code, 2))
        cc = contraction_complexity(codet, uniformsize(code, 2))

        @show cc.tc, cc.sc, cc0.tc, cc0.sc
        @test cc.sc <= 10

        xs = [[2*randn(2, 2) for i=1:150]..., [randn(2) for i=1:100]...]
        res0 = decorate(code0)(xs...)
        rest = decorate(codet)(xs...)
        @test res0 ≈ rest
    end

    # slice with fixed slices
    Random.seed!(2)
    code = OMEinsumContractionOrders.EinCode(random_regular_eincode(100, 3).ixs, [3,10,2])
    for code0 in [optimize_greedy(code, uniformsize(code, 2); α=0.0, temperature=0.0),
            optimize_tree(code, uniformsize(code, 2); initializer=:greedy, βs=0.1:0.05:20.0, ntrials=2, niters=10, score=ScoreFunction(sc_target=10), decomposition_type=TreeDecomp()),
            optimize_hyper_nd(HyperND(), code, uniformsize(code, 2))]
        code1 = slice_tree(code0, uniformsize(code, 2); score=ScoreFunction(sc_target=10), fixed_slices=[10, 89, 26, 3, 51], decomposition_type=TreeDecomp())
        code2 = slice_tree(code0, uniformsize(code, 2); score=ScoreFunction(sc_target=10), fixed_slices=[10, 89], decomposition_type=TreeDecomp())

        @test length(code1.slicing) >= 5 && Set([10, 89, 26, 3, 51]) ⊆ Set(code1.slicing)
        @test length(code2.slicing) >= 2 && Set([10, 89]) ⊆ Set(code2.slicing)
        @test contraction_complexity(code1, uniformsize(code, 2)).sc <= 10
        @test contraction_complexity(code2, uniformsize(code, 2)).sc <= 10

        xs = [[2*randn(2, 2) for i=1:150]..., [randn(2) for i=1:100]...]
        res0 = decorate(code0)(xs...)
        res1 = decorate(code1)(xs...)
        res2 = decorate(code2)(xs...)
        @test res0 ≈ res1
        @test res0 ≈ res2
    end

    function random_regular_eincode_char(n, k)
        g = Graphs.random_regular_graph(n, k)
        ixs = [[minmax('0' + e.src, '0'+e.dst)...] for e in Graphs.edges(g)]
        return OMEinsumContractionOrders.EinCode([ixs..., [['0'+i] for i in Graphs.vertices(g)]...], Char[])
    end
    code = OMEinsumContractionOrders.EinCode(random_regular_eincode_char(20, 3).ixs, ['3','8','2'])
    code0 = optimize_tree(code, uniformsize(code, 2); initializer=:greedy, βs=0.1:0.05:20.0, ntrials=2, niters=10, score=ScoreFunction(sc_target=10), decomposition_type=TreeDecomp())
    code1 = slice_tree(code0, uniformsize(code, 2); score=ScoreFunction(sc_target=5), fixed_slices=['7'], decomposition_type=TreeDecomp())
    @test eltype(code1.eins.eins.iy) == Char

    xs = [[2*randn(2, 2) for i=1:30]..., [randn(2) for i=1:20]...]
    res0 = decorate(code0)(xs...)
    res1 = decorate(code1)(xs...)
    @test res0 ≈ res1
end

@testset "slicer as kwargs" begin
    code = OMEinsumContractionOrders.EinCode([[1,2]], [2])
    optcode = OMEinsumContractionOrders.optimize_code(code, uniformsize(code, 2), TreeSA(ntrials=1), slicer=TreeSASlicer(score=ScoreFunction(sc_target=10)))
    @test optcode isa SlicedEinsum
    @test length(optcode.slicing) == 0

    code = OMEinsumContractionOrders.EinCode([[1,2], [1,2]], Int[])
    optcode = OMEinsumContractionOrders.optimize_code(code, uniformsize(code, 10), TreeSA(ntrials=1), slicer=TreeSASlicer(score=ScoreFunction(sc_target=5)))
    @test optcode isa SlicedEinsum
    @test length(optcode.slicing) == 1
    @test optcode.eins == OMEinsumContractionOrders.NestedEinsum([OMEinsumContractionOrders.NestedEinsum{Int}(1), OMEinsumContractionOrders.NestedEinsum{Int}(2)], OMEinsumContractionOrders.EinCode([[1,2], [1,2]], Int[]))

    optcode = OMEinsumContractionOrders.optimize_code(code, uniformsize(code, 10), TreeSA(ntrials=1), slicer=TreeSASlicer(score=ScoreFunction(sc_target=2)))
    @test optcode isa SlicedEinsum
    @test length(optcode.slicing) == 2
end

using TensorInference, OMEinsumContractionOrders

function main(optimizer)
    @info "Running inference with optimizer: $(optimizer)"
    problems = dataset_from_artifact("uai2014")["MAR"]
    problem_set_name = "relational"
    tamaki = [251, 3, 8, 101, 11]
    results = []
    for (id, problem) in problems[problem_set_name]
        @info "Testing: $(problem_set_name)_$id"
        time_elapsed = @elapsed tn = TensorNetworkModel(read_model(problem); optimizer, evidence=read_evidence(problem))
        # does not optimize over open vertices
        @info "Contraction complexity: $(contraction_complexity(tn)) (tamaki tw = $(tamaki[id])), time cost: $(time_elapsed)s"
        push!(results, (id, contraction_complexity(tn), tamaki[id], time_elapsed))
    end
    return results
end

function log2sumexp2(s)
    ms = maximum(s)
    return log2(sum(x->exp2(x - ms), s)) + ms
end

function _log2_size_dict(size_dict::Dict{L, T2}) where {L, T2}
    log2_size_dict = Dict{L,Float64}()
    for (k, v) in size_dict
        log2_size_dict[k] = log2(v)
    end
    return log2_size_dict
end

# Given a vertex-edge incidence matrix `adj` and a subset of vertices `part`,
# group `part` into connected components (vertices sharing an edge are adjacent).
function _connected_components(adj, part::AbstractVector{T}) where T
    A = adj[part,:]
    A = A * A'   # connectivility matrix
    n = length(part)
    visit_mask = zeros(Bool, n)
    groups = Vector{T}[]
    while !all(visit_mask)
        newset = Int[]
        push_connected!(newset, visit_mask, A, findfirst(==(false), visit_mask))
        push!(groups, getindex.(Ref(part), newset))
    end
    return groups
end

function push_connected!(set, visit_mask, adj, i)
    visit_mask[i] = true
    push!(set, i)
    for v = 1:size(adj, 2)
        if !visit_mask[v] && !iszero(adj[i,v])
            push_connected!(set, visit_mask, adj, v)
        end
    end
end

"""
    convert_label(ne::NestedEinsum, labelmap::Dict{T1,T2}) where {T1,T2}

Convert the labels of a `NestedEinsum` object to new labels.
`labelmap` is a dictionary that maps the old labels to the new labels.
"""
function convert_label(ne::NestedEinsum, labelmap::Dict{T1,T2}) where {T1,T2}
    isleaf(ne) && return NestedEinsum{T2}(ne.tensorindex)
    eins = EinCode([getindex.(Ref(labelmap), ix) for ix in ne.eins.ixs], getindex.(Ref(labelmap), ne.eins.iy))
    NestedEinsum([convert_label(arg, labelmap) for arg in ne.args], eins)
end

function OMEinsumContractionOrders.ein2elimination(code::NestedEinsum{T}) where{T}
    elimination_order = Vector{T}()
    _ein2elimination!(code, elimination_order)
    return elimination_order
end

function OMEinsumContractionOrders.ein2elimination(code::SlicedEinsum{T, NestedEinsum{T}}) where{T}
    elimination_order = Vector{T}()
    _ein2elimination!(code.eins, elimination_order)
    # the slicing indices are eliminated at the end
    return vcat(elimination_order, code.slicing)
end

function _ein2elimination!(code::NestedEinsum{T}, elimination_order::Vector{T}) where{T}
    if code.tensorindex == -1
        for arg in code.args
            _ein2elimination!(arg, elimination_order)
        end
        iy = unique(vcat(getiyv(code.eins)...))
        for ix in unique(vcat(getixsv(code.eins)...))
            if !(ix in iy) && !(ix in elimination_order)
                push!(elimination_order, ix)
            end
        end
    end
    return elimination_order
end

function elimination_frame(gviz::GraphViz, tng::TensorNetworkGraph{TG, TL}, elimination_order::Vector{TL}, i::Int; filename = nothing) where{TG, TL}
    gviz2 = deepcopy(gviz)
    for j in 1:i
        id = _get_key(tng.indices_labels, elimination_order[j])
        gviz2.vertex_colors[id] = (0.5, 0.5, 0.5, 0.5)
    end
    return show_graph(gviz2, filename = filename)
end

function OMEinsumContractionOrders.viz_contraction(code::T, args...; kwargs...) where{T <: AbstractEinsum}
    throw(ArgumentError("Only NestedEinsum and SlicedEinsum{T, NestedEinsum{T}} have contraction order"))
end

function OMEinsumContractionOrders.viz_contraction(
        code::Union{NestedEinsum, SlicedEinsum}; 
        locs=StressLayout(),
        framerate = 10,
        filename::String = tempname() * ".mp4",
        show_progress::Bool = true)

    # analyze the output format
    @assert endswith(filename, ".gif") || endswith(filename, ".mp4") "Unsupported file format: $filename, only :gif and :mp4 are supported"
    tempdirectory = mktempdir()

    # generate the frames
    elimination_order = ein2elimination(code)
    tng = TensorNetworkGraph(ein2hypergraph(code))
    gviz = GraphViz(tng, locs)

    le = length(elimination_order)
    for i in 0:le
        show_progress && @info "Frame $(i + 1) of $(le + 1)"
        fig_name = joinpath(tempdirectory, "$(lpad(i+1, 10, "0")).png")
        elimination_frame(gviz, tng, elimination_order, i; filename = fig_name)
    end

    if endswith(filename, ".gif")
        Luxor.FFMPEG.exe(`-loglevel panic -r $(framerate) -f image2 -i $(tempdirectory)/%10d.png -filter_complex "[0:v] split [a][b]; [a] palettegen=stats_mode=full:reserve_transparent=on:transparency_color=FFFFFF [p]; [b][p] paletteuse=new=1:alpha_threshold=128" -y $filename`)
    else
        Luxor.FFMPEG.ffmpeg_exe(`
            -loglevel panic
            -r $(framerate) 
            -f image2 
            -i $(tempdirectory)/%10d.png 
            -c:v libx264 
            -vf "pad=ceil(iw/2)*2:ceil(ih/2)*2"
            -r $(framerate) 
            -pix_fmt yuv420p 
            -y $filename`)
    end
    show_progress && @info "Generated output at: $filename"
    return filename
end

module YaoQASMReader
using Yao
using Yao.EasyBuild: FSimGate
const GATE_TENSORS = Dict{Symbol, AbstractBlock}()

GATE_TENSORS[:i] = I2
GATE_TENSORS[:x] = X
GATE_TENSORS[:y] = Y
GATE_TENSORS[:z] = Z

@const_gate X12 = [1 -1im; -1im 1]/sqrt(2)
GATE_TENSORS[:x_1_2] = X12
@const_gate Y12 = [1 -1; 1 1]/sqrt(2)
GATE_TENSORS[:y_1_2] = Y12
@const_gate HZ12 = [1 1+1im; 1-1im 1]/2
GATE_TENSORS[:hz_1_2] = HZ12

GATE_TENSORS[:h] = H
GATE_TENSORS[:s] = ConstGate.S
GATE_TENSORS[:t] = ConstGate.T

GATE_TENSORS[:cx] = control(2,1,2=>X)
GATE_TENSORS[:cz] = control(2,1,2=>Z)

rz(theta) = Rz(theta)
fsim(theta, phi) = FSimGate(theta, phi)

"""
    yaocircuit_from_qasm(qasm_str::String)

Function to create the yao circuit described in the given qasm file.
"""
function yaocircuit_from_qasm(qasm_file::String)
    qasm_string = open(f -> read(f, String), qasm_file)
    qasm_lines = split(qasm_string, "\n")
    num_qubits = parse(Int, qasm_lines[1])
    qubit_map = Dict{Int, Int}(-1 => 0)
    c = chain(num_qubits)

    for line in qasm_lines[2:end]
        words = filter(x->length(x)>0, split(line, ['(', ')', ' ', ',']))
        if length(words) > 0
            targets, tensor = parse_words(words, qubit_map)
            push!(c, put(num_qubits, (targets...,)=>tensor))
        end
    end
    c
end


"""
Map the given target qubits to indices according to qubit_map

If the target qubit isn't mapped to anything, increment the total number of qubits and map to total number.
"""
function transform_targets!(targets, qubit_map)
    for i = 1:length(targets)
        if haskey(qubit_map, targets[i])
            targets[i] = qubit_map[targets[i]]
        else
            qubit_map[-1] += 1
            qubit_map[targets[i]] = qubit_map[-1]
            targets[i] = qubit_map[-1]
        end
    end
    targets
end

function parse_words(words, qubit_map)
    if words[2] == "fsim"
        theta = parse(Float64, words[3])
        phi = parse(Float64, words[4])
        tensor = fsim(theta, phi)
        targets = parse.(Int, words[5:6])

    elseif words[2] == "rz"
        theta = parse(Float64, words[3])
        tensor = rz(theta)
        targets = parse.(Int, words[4:end])

    else
        gate_symbol = Symbol(words[2])
        targets = parse.(Int, words[3:end])
        tensor = GATE_TENSORS[gate_symbol]
    end

    transform_targets!(targets, qubit_map)
    targets, tensor
end
end


using Yao
# Load functions to read qflex qasm files.
using .YaoQASMReader: yaocircuit_from_qasm
using OMEinsumContractionOrders

function main(optimizer)
    # circuit source: https://github.com/brenjohn/Contraction-Order-Bench/tree/main/data/circuits
    cirq_name = "sycamore_53_20_0"
    @info("Running circuit `$(cirq_name)` with optimizer: $(optimizer)")

    # Create the TensorNetworkCircuit object for the circuit
    qasm_file = joinpath(@__DIR__, cirq_name * ".txt")
    c = yaocircuit_from_qasm(qasm_file)
    time_elapsed = @elapsed net = yao2einsum(c; initial_state=Dict(zip(1:nqubits(c), zeros(Int,nqubits(c)))), final_state=Dict(zip(1:nqubits(c), zeros(Int,nqubits(c)))), optimizer)
    @info "Contraction complexity: $(contraction_complexity(net)), time cost: $(time_elapsed)s"
    return contraction_complexity(net)
end

module OMEinsumContractionOrders

using JSON
using SparseArrays
using StatsBase
using Base: RefValue
using Base.Threads
using AbstractTrees
using TreeWidthSolver
using TreeWidthSolver.Graphs
using DataStructures: PriorityQueue
import CliqueTrees
using CliqueTrees: cliquetree, cliquetree!, separator, residual, CliqueTree, EliminationAlgorithm, MMW, BFS, MCS, LexBFS, RCMMD, RCMGL, MCSM, LexM, AMF, MF, MMD, MF, BT, SafeRules, KaHyParND, METISND, ND, BestWidth, ConnectedComponents

# interfaces
export simplify_code, optimize_code, slice_code, optimize_permute, label_elimination_order, uniformsize, ScoreFunction

# optimizers
export CodeOptimizer, KaHyParBipartite, GreedyMethod, TreeSA, SABipartite, Treewidth, ExactTreewidth, HyperND, PathSA, ExhaustiveSearch

# slicers
export CodeSlicer, TreeSASlicer

# decomposition types
export AbstractDecompositionType, TreeDecomp, PathDecomp

# preprocessing
export CodeSimplifier, MergeGreedy, MergeVectors

# time space complexity
export peak_memory, flop, contraction_complexity

# Note: writejson, readjson are not exported to avoid namespace conflict

# visiualization tools provided by extension `LuxorTensorPlot`
export viz_eins, viz_contraction

include("Core.jl")
include("utils.jl")

# greedy method
include("incidencelist.jl")
include("greedy.jl")

# exact "netcon" exhaustive search (reuses ContractionTree/parse_eincode! from greedy.jl)
include("exhaustivesearch.jl")

# bipartition based methods
include("sabipartite.jl")
include("kahypar.jl")

# local search method
include("treesa.jl")
include("treesaslicer.jl")

# tree width method
include("treewidth.jl")

# nested dissection method
include("hypernd.jl")

# simplification passes
include("simplify.jl")

# interfaces
include("complexity.jl")
include("interfaces.jl")

# saveload
include("json.jl")

# extension for visiualization
include("visualization.jl")

@deprecate timespacereadwrite_complexity(code, size_dict::Dict) (contraction_complexity(code, size_dict)...,)
@deprecate timespace_complexity(code, size_dict::Dict) (contraction_complexity(code, size_dict)...,)[1:2]
@deprecate optimize_code(code::Union{EinCode, NestedEinsum}, size_dict::Dict, optimizer::CodeOptimizer, simplifier, permute=true) optimize_code(code, size_dict, optimizer; simplifier=simplifier, permute=permute)

end

using OMEinsum
using OMEinsumContractionOrders: ein2hypergraph, ein2elimination
using Test, OMEinsumContractionOrders

# tests before the extension loaded
@testset "luxor tensor plot dependency check" begin
    @test_throws ArgumentError begin
        eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], ['a'])
        ein2hypergraph(eincode)
    end

    @test_throws ArgumentError begin
        eincode = OMEinsum.rawcode(ein"((ij, jk), kl), lm -> im")
        ein2elimination(eincode)
    end

    @test_throws ArgumentError begin
        eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], Vector{Char}())
        viz_eins(eincode)
    end

    @test_throws ArgumentError begin
        eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], Vector{Char}())
        nested_code = optimize_code(eincode, uniformsize(eincode, 2), GreedyMethod())
        viz_contraction(nested_code)
    end
end

using LuxorGraphPlot
using LuxorGraphPlot.Luxor

@testset "eincode to hypergraph" begin
    eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], ['a'])
    g1 = ein2hypergraph(eincode)

    nested_code = optimize_code(eincode, uniformsize(eincode, 2), GreedyMethod())
    g2 = ein2hypergraph(nested_code)

    sliced_code = slice_code(nested_code, uniformsize(eincode, 2), TreeSASlicer(score=ScoreFunction(sc_target=2)))
    g3 = ein2hypergraph(sliced_code)

    @test g1 == g2 == g3
    @test size(g1.adjacency_matrix, 1) == 5
    @test size(g1.adjacency_matrix, 2) == 6
end

@testset "eincode to elimination order" begin
    eincode = OMEinsum.rawcode(ein"((ij, jk), kl), lm -> im")
    elimination_order = ein2elimination(eincode)
    @test elimination_order == ['j', 'k', 'l']
end

@testset "visualize eincode" begin
    eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], Vector{Char}())
    t = viz_eins(eincode)
    @test t isa Luxor.Drawing

    nested_code = optimize_code(eincode, uniformsize(eincode, 2), GreedyMethod())
    t = viz_eins(nested_code)
    @test t isa Luxor.Drawing

    sliced_code = optimize_code(eincode, uniformsize(eincode, 2), TreeSA())
    t = viz_eins(sliced_code)
    @test t isa Luxor.Drawing

    open_eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], ['a'])
    t = viz_eins(open_eincode)
    @test t isa Luxor.Drawing

    # filename and location specified
    eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], Vector{Char}())
    filename = tempname() * ".png"
    viz_eins(eincode; filename, locs=vcat([(randn() * 60, 0.0) for i=1:5], [(randn() * 60, 320.0) for i=1:6]))
    @test isfile(filename)
end

@testset "visualize contraction" begin
    eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], Vector{Char}())
    nested_code = optimize_code(eincode, uniformsize(eincode, 2), GreedyMethod())
    t_mp4 = viz_contraction(nested_code)
    tempmp4 = tempname() * ".mp4"
    tempgif = tempname() * ".gif"
    t_mp4_2 = viz_contraction(nested_code, filename = tempmp4)
    @test t_mp4 isa String
    @test t_mp4_2 isa String
    t_gif = viz_contraction(nested_code, filename = tempgif)
    @test t_gif isa String

    @test_throws AssertionError begin
        viz_contraction(nested_code, filename = "test.avi")
    end

    sliced_code = optimize_code(eincode, uniformsize(eincode, 2), TreeSA())
    t_mp4 = viz_contraction(sliced_code)
    t_mp4_2 = viz_contraction(sliced_code, filename = tempmp4)
    @test t_mp4 isa String
    @test t_mp4_2 isa String
    t_gif = viz_contraction(sliced_code, filename = tempgif)
    @test t_gif isa String

    sliced_code2 = slice_code(nested_code, uniformsize(eincode, 2), TreeSASlicer(score=ScoreFunction(sc_target=2)))
    t_mp4 = viz_contraction(sliced_code2)
    t_mp4_2 = viz_contraction(sliced_code2, filename = tempmp4)
    @test t_mp4 isa String
    @test t_mp4_2 isa String
    t_gif = viz_contraction(sliced_code2, filename = tempgif)
    @test t_gif isa String
end

using OMEinsumContractionOrders
using OMEinsumContractionOrders: contract_pair!, evaluate_costs, contract_tree!, log2sumexp2, parse_tree
using OMEinsumContractionOrders: IncidenceList, LegInfo, tree_greedy, parse_eincode, optimize_greedy
using OMEinsumContractionOrders: compute_contraction_dims
using Graphs

using Test, Random

@testset "parse eincode" begin
    incidence_list = IncidenceList(Dict(1 => [1, 2], 2=>[1, 3, 4], 3=>[2, 3, 5, 6], 4=>[5], 5=>[4, 6]))
    tree = OMEinsumContractionOrders.ContractionTree(OMEinsumContractionOrders.ContractionTree(1, 2), OMEinsumContractionOrders.ContractionTree(3, 4))
    vertices = [1, 2, 3, 4, 5, 6]
    ti, optcode = OMEinsumContractionOrders.parse_eincode!(incidence_list, tree, vertices, Dict([v=>0 for v in vertices]))
    @test ti == 1
    @test optcode isa OMEinsumContractionOrders.NestedEinsum
end

@testset "tree greedy" begin
    Random.seed!(2)
    incidence_list = IncidenceList(Dict(1 => [1, 2], 2=>[1, 3, 4], 3=>[2, 3, 5, 6], 4=>[5], 5=>[4, 6]))
    log2_edge_sizes = Dict([i=>i for i in 1:6])
    edge_sizes = Dict([i=>(1<<i) for i in 1:6])
    il = copy(incidence_list)
    contract_pair!(il, 1, 2, log2_edge_sizes)
    target = IncidenceList(Dict(1 => [2, 3, 4], 3=>[2, 3, 5, 6], 4=>[5], 5=>[4, 6]))
    @test il.v2e == target.v2e
    @test length(target.e2v) == length(il.e2v)
    for (k,v) in il.e2v
        @test sort(target.e2v[k]) == sort(v)
    end
    costs, cost_graph = evaluate_costs(0.0, incidence_list, log2_edge_sizes)
    @test costs == Dict((1, 2)=>(2^9), (1, 3)=>2^15, (2,3)=>2^18, (2,5)=>2^10, (3,4)=>2^11, (3, 5)=>2^14)
    tree, log2_tcs, log2_scs = tree_greedy(incidence_list, log2_edge_sizes)
    tcs_, scs_ = [], []
    contract_tree!(copy(incidence_list), tree, log2_edge_sizes, tcs_, scs_)
    @test all((log2sumexp2(tcs_), maximum(scs_)) .<= (log2(exp2(10)+exp2(16)+exp2(15)+exp2(9)), 11))
    vertices = [1, 2, 3, 4, 5, 6]
    optcode1 = parse_eincode(incidence_list, tree, vertices=vertices)
    @test optcode1 isa OMEinsumContractionOrders.NestedEinsum
    tree2 = parse_tree(optcode1, vertices)
    @test tree2 == tree

    eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], Vector{Char}())
    size_dict = Dict([c=>(1<<i) for (i,c) in enumerate(['a', 'b', 'c', 'd', 'e', 'f'])]...)
    Random.seed!(2)
    optcode2 = optimize_greedy(eincode, size_dict; α=0.0, temperature=0.0)
    cc = contraction_complexity(optcode2, size_dict)
    # test flop
    @test cc.tc ≈ log2(flop(optcode2, size_dict))
    @test flop(OMEinsumContractionOrders.EinCode([['i']], Vector{Char}()), Dict('i'=>4)) == 4
    @test 16 <= cc.tc <= 17
    @test cc.sc == 11
    @test optcode1 == OMEinsumContractionOrders.convert_label(optcode2, Dict([c=>i for (i,c) in enumerate(['a', 'b', 'c', 'd', 'e', 'f'])]))
end

@testset "fullerene" begin
    Random.seed!(123)
    function fullerene()
        φ = (1+√5)/2
        res = NTuple{3,Float64}[]
        for (x, y, z) in ((0.0, 1.0, 3φ), (1.0, 2 + φ, 2φ), (φ, 2.0, 2φ + 1.0))
            for (α, β, γ) in ((x,y,z), (y,z,x), (z,x,y))
                for loc in ((α,β,γ), (α,β,-γ), (α,-β,γ), (α,-β,-γ), (-α,β,γ), (-α,β,-γ), (-α,-β,γ), (-α,-β,-γ))
                    if loc ∉ res
                        push!(res, loc)
                    end
                end
            end
        end
        return res
    end

    # flatten nested einsum
    function _flatten(code::OMEinsumContractionOrders.NestedEinsum, iy=nothing)
        isleaf(code) && return [tensorindex(code)=>iy]
        sibs = siblings(code)
        ixs = []
        for i=1:length(sibs)
            append!(ixs, _flatten(sibs[i], (rootcode(code).ixs)[i]))
        end
        return ixs
    end

    flatten(code::OMEinsumContractionOrders.EinCode) = code
    function flatten(code::OMEinsumContractionOrders.NestedEinsum{LT}) where LT
        ixd = Dict(_flatten(code))
        OMEinsumContractionOrders.EinCode([ixd[i] for i=1:length(ixd)], collect((code.eins).iy))
    end

    isleaf(ne::OMEinsumContractionOrders.NestedEinsum) = ne.tensorindex != -1
    siblings(ne::OMEinsumContractionOrders.NestedEinsum) = ne.args
    tensorindex(ne::OMEinsumContractionOrders.NestedEinsum) = ne.tensorindex
    rootcode(ne::OMEinsumContractionOrders.NestedEinsum) = ne.eins

    c60_xy = fullerene()
    c60_edges = [[i,j] for (i,(i2,j2,k2)) in enumerate(c60_xy), (j,(i1,j1,k1)) in enumerate(c60_xy) if i<j && (i2-i1)^2+(j2-j1)^2+(k2-k1)^2 < 5.0]
    code = OMEinsumContractionOrders.EinCode(vcat(c60_edges, [[i] for i=1:60]), Vector{Int}())
    size_dict = Dict([i=>2 for i in 1:60])
    log2_edge_sizes = Dict([i=>1 for i in 1:60])
    edge_sizes = Dict([i=>2 for i in 1:60])
    cc = contraction_complexity(code, edge_sizes)
    @test cc.tc == 60
    @test cc.sc == 0
    optcode = optimize_greedy(code, size_dict; α=0.0, temperature=0.0)
    cc2 = contraction_complexity(optcode, edge_sizes)
    @test cc2.sc == 10
    @test flatten(optcode) == code
    @test flatten(code) == code

    cc3 = Inf
    local optcode_hyper
    for irepeat = 1:20
        optcode_hyper = optimize_greedy(code, size_dict; α=0.0, temperature=100.0)
        cc3 = contraction_complexity(optcode_hyper, edge_sizes)
        if cc3.sc < cc3.sc
            optcode_hyper = optcode_hyper
            cc3 = cc3
        end
    end
    @test cc3.sc <= 12
    @test flatten(optcode_hyper) == code
end

@testset "chain and ring" begin
    # chain
    code = OMEinsumContractionOrders.EinCode([[1,2], [2,3], [3,4], [4,5], [5,6], [6,7], [7,8], [8,9], [9,10]], Int[1, 10])
    size_dict = Dict([i=>2 for i in 1:10])
    optcode = optimize_greedy(code, size_dict; α=0.0, temperature=0.0)
    cc = contraction_complexity(optcode, size_dict)
    @test cc.sc == 2

    # ring
    ring = OMEinsumContractionOrders.EinCode([[1,2], [2,3], [3,4], [4,5], [5,6], [6,7], [7,8], [8,9], [9,10], [10,1]], Int[])
    optcode = optimize_greedy(ring, size_dict; α=0.0, temperature=0.0)
    cc = contraction_complexity(optcode, size_dict)
    @test cc.sc == 2

    # petersen
    sc_list = Float64[]
    for i=1:20
        graph = smallgraph(:tutte)
        code = OMEinsumContractionOrders.EinCode([[e.src, e.dst] for e in edges(graph)], Int[])
        size_dict = Dict([i=>2 for i in 1:nv(graph)])
        optcode = optimize_greedy(code, size_dict; α=0.0, temperature=100.0)
        cc = contraction_complexity(optcode, size_dict)
        push!(sc_list, cc.sc)
    end
    @test minimum(sc_list) == 5
end

@testset "greedy_loss optimization" begin
    function analyze_contraction(incidence_list::IncidenceList{Int,ET}, vi::Int, vj::Int) where {ET}
        ei = OMEinsumContractionOrders.edges(incidence_list, vi)
        ej = OMEinsumContractionOrders.edges(incidence_list, vj)
        leg012,leg12,leg1,leg2,leg01,leg02 = ET[], ET[], ET[], ET[], ET[], ET[]
        # external legs
        for leg in ei ∪ ej
            isext = leg ∈ incidence_list.openedges || !all(x->x==vi || x==vj, OMEinsumContractionOrders.vertices(incidence_list, leg))
            if isext
                if leg ∈ ei
                    if leg ∈ ej
                        push!(leg012, leg)
                    else
                        push!(leg01, leg)
                    end
                else
                    push!(leg02, leg)
                end
            else
                if leg ∈ ei
                    if leg ∈ ej
                        push!(leg12, leg)
                    else
                        push!(leg1, leg)
                    end
                else
                    push!(leg2, leg)
                end
            end
        end
        return LegInfo(leg1, leg2, leg12, leg01, leg02, leg012)
    end
    @testset "analyze contraction" begin
        incidence_list = IncidenceList(Dict(1 => [1, 2, 11, 15, 6], 2=>[1, 3, 4, 13, 6], 3=>[2, 3, 5, 6], 4=>[5], 5=>[4, 6]), openedges=[3, 6, 15])
        info = analyze_contraction(incidence_list, 1, 2)
        @test Set(info.l1) == Set([11])
        @test Set(info.l2) == Set([13])
        @test Set(info.l12) == Set([1])
        @test Set(info.l01) == Set([2,15])
        @test Set(info.l02) == Set([3, 4])
        @test Set(info.l012) == Set([6])
    end

    @testset "compute_contraction_dims" begin
        # Test that compute_contraction_dims matches analyze_contraction
        
        # Create test incidence list
        incidence_list = IncidenceList(
            Dict(1 => [1, 2, 11, 15, 6], 2 => [1, 3, 4, 13, 6], 3 => [2, 3, 5, 6], 4 => [5], 5 => [4, 6]), 
            openedges=[3, 6, 15]
        )
        log2_edge_sizes = Dict(i => Float64(i % 3 + 1) for i in [1,2,3,4,5,6,11,13,15])
        
        # Test various vertex pairs
        for (vi, vj) in [(1, 2), (2, 3), (1, 3)]
            if vi in keys(incidence_list.v2e) && vj in keys(incidence_list.v2e)
                # Get dimensions using the new function
                D1, D2, D12, D01, D02, D012 = compute_contraction_dims(incidence_list, log2_edge_sizes, vi, vj, nothing, nothing)
                eout, eremove = Int[], Int[]
                D1_, D2_, D12_, D01_, D02_, D012_ = compute_contraction_dims(incidence_list, log2_edge_sizes, vi, vj, eout, eremove)
                @test D1_ == D1
                @test D2_ == D2
                @test D12_ == D12
                @test D01_ == D01
                @test D02_ == D02
                @test D012_ == D012
                
                # Compare with analyze_contraction
                legs = analyze_contraction(incidence_list, vi, vj)
                log2dim(legs_list) = isempty(legs_list) ? 0.0 : sum(l->log2_edge_sizes[l], legs_list)
                D1_ref = log2dim(legs.l1)
                D2_ref = log2dim(legs.l2)
                D12_ref = log2dim(legs.l12)
                D01_ref = log2dim(legs.l01)
                D02_ref = log2dim(legs.l02)
                D012_ref = log2dim(legs.l012)
                
                @test D1 ≈ D1_ref
                @test D2 ≈ D2_ref
                @test D12 ≈ D12_ref
                @test D01 ≈ D01_ref
                @test D02 ≈ D02_ref
                @test D012 ≈ D012_ref
                
                # Verify edge lists
                eout_ref = legs.l01 ∪ legs.l02 ∪ legs.l012
                eremove_ref = legs.l1 ∪ legs.l2 ∪ legs.l12
                @test Set(eout) == Set(eout_ref)
                @test Set(eremove) == Set(eremove_ref)
            end
        end
    end

    # Original implementation using analyze_contraction (for comparison)
    function greedy_loss_with_vectors(α, incidence_list, log2_edge_sizes, vi, vj)
        log2dim(legs) = isempty(legs) ? 0 : sum(l->log2_edge_sizes[l], legs)
        legs = analyze_contraction(incidence_list, vi, vj)
        D1, D2, D12, D01, D02, D012 = log2dim.(getfield.(Ref(legs), 1:6))
        return exp2(D01+D02+D012) - α * (exp2(D01+D12+D012) + exp2(D02+D12+D012))
    end
    
    # Create a simple tensor network
    code = OMEinsumContractionOrders.EinCode([[1,2], [2,3], [3,4], [4,5], [5,1]], Int[])
    ixs = OMEinsumContractionOrders.getixsv(code)
    iy = OMEinsumContractionOrders.getiyv(code)
    size_dict = Dict([i=>2 for i in 1:5])
    log2_edge_sizes = Dict([i=>log2(size_dict[i]) for i in keys(size_dict)])
    incidence_list = IncidenceList(Dict([i=>ixs[i] for i=1:length(ixs)]); openedges=iy)
    
    # Compare optimized vs original implementation
    for α in [0.0, 0.5, 1.0]
        for vi in keys(incidence_list.v2e), vj in keys(incidence_list.v2e)
            if vi < vj
                loss_new = OMEinsumContractionOrders.greedy_loss(α, incidence_list, log2_edge_sizes, vi, vj)
                loss_old = greedy_loss_with_vectors(α, incidence_list, log2_edge_sizes, vi, vj)
                @test loss_new ≈ loss_old
            end
        end
    end
end

"""
    optimize_code(eincode, size_dict, optimizer = GreedyMethod(); slicer=nothing, simplifier=nothing, permute=true) -> optimized_eincode

Optimize the einsum contraction code and reduce the time/space complexity of tensor network contraction.
Returns a `NestedEinsum` instance. Input arguments are

# Arguments
- `eincode` is an einsum contraction code instance, one of `DynamicEinCode`, `StaticEinCode` or `NestedEinsum`.
- `size` is a dictionary of "edge label=>edge size" that contains the size information, one can use `uniformsize(eincode, 2)` to create a uniform size.
- `optimizer` is a `CodeOptimizer` instance, should be one of `GreedyMethod`, `Treewidth`, `KaHyParBipartite`, `SABipartite` or `TreeSA`. Check their docstrings for details.

# Keyword Arguments
- `slicer` is for slicing the contraction code to reduce the space complexity, default is nothing. Currently only [`TreeSASlicer`](@ref) is supported.
- `simplifier` is one of `MergeVectors` or `MergeGreedy`. Default is nothing.
- `permute` is a boolean flag to indicate whether to optimize the permutation of the contraction order.

# Examples

```jldoctest
julia> using OMEinsum

julia> code = ein"ij, jk, kl, il->"
ij, jk, kl, il -> 

julia> optimize_code(code, uniformsize(code, 2), TreeSA());
```
"""
function optimize_code(code::Union{EinCode, NestedEinsum}, size_dict::Dict, optimizer::CodeOptimizer; slicer=nothing, simplifier=nothing, permute::Bool=true)
    if simplifier === nothing
        optcode = _optimize_code(code, size_dict, optimizer)
    else
        simpl, code = simplify_code(code, size_dict, simplifier)
        optcode0 = _optimize_code(code, size_dict, optimizer)
        optcode = embed_simplifier(optcode0, simpl)
    end
    if slicer !== nothing
        optcode = slice_code(optcode, size_dict, slicer)
    end
    if permute
        optimize_permute(optcode, 0)
    end
end

function _optimize_code(code, size_dict, optimizer::KaHyParBipartite)
    recursive_bipartite_optimize(optimizer, code, size_dict)
end
function _optimize_code(code, size_dict, optimizer::GreedyMethod)
    optimize_greedy(code, size_dict; α = optimizer.α, temperature = optimizer.temperature)
end
function _optimize_code(code, size_dict, optimizer::Treewidth)
    optimize_treewidth(optimizer, code, size_dict)
end
function _optimize_code(code, size_dict, optimizer::SABipartite)
    recursive_bipartite_optimize(optimizer, code, size_dict)
end
function _optimize_code(code, size_dict, optimizer::TreeSA)
    optimize_tree(code, size_dict; βs=optimizer.βs,
        ntrials=optimizer.ntrials, niters=optimizer.niters,
        initializer=optimizer.initializer, score=optimizer.score,
        decomposition_type=optimizer.decomposition_type)
end
function _optimize_code(code, size_dict, optimizer::HyperND)
    optimize_hyper_nd(optimizer, code, size_dict)
end
function _optimize_code(code, size_dict, optimizer::ExhaustiveSearch)
    optimize_exhaustive(code, size_dict; verbose = optimizer.verbose)
end

"""
    slice_code(code, size_dict, slicer) -> sliced_code

Slice the einsum contraction code to reduce the space complexity, returns a `SlicedEinsum` instance.

# Arguments
- `code` is a `NestedEinsum` instance.
- `size_dict` is a dictionary of "edge label=>edge size" that contains the size information, one can use `uniformsize(eincode, 2)` to create a uniform size.
- `slicer` is a `CodeSlicer` instance, currently only [`TreeSASlicer`](@ref) is supported.
"""
function slice_code(code::NestedEinsum, size_dict, slicer::TreeSASlicer)
    slice_tree(code, size_dict; score=slicer.score, βs=slicer.βs,
        ntrials=slicer.ntrials, niters=slicer.niters,
        optimization_ratio=slicer.optimization_ratio,
        decomposition_type=slicer.decomposition_type)
end

################### The data types in OMEinsum ###################
"""
    AbstractEinsum

Abstract type for einsum notations.

# Required Interfaces
- `getixsv`: a vector of vectors, each vector represents the labels associated with a input tensor.
- `getiyv`: a vector of labels associated with the output tensor.
- `uniquelabels`: a vector of labels that are unique in the einsum notation.

# Derived interfaces
- `labeltype`: the data type to represent the labels in the einsum notation.
"""
abstract type AbstractEinsum end

"""
    getixsv(code::AbstractEinsum) -> Vector{Vector{LT}}

Returns the input indices of the einsum notation.
Each vector represents the labels associated with a input tensor.
"""
function getixsv end

"""
    getiyv(code::AbstractEinsum) -> Vector{LT}

Returns the output index of the einsum notation.
"""
function getiyv end

"""
    uniquelabels(code::AbstractEinsum) -> Vector{LT}

Returns the unique labels in the einsum notation. The labels are the indices of the tensors.
"""
uniquelabels(code::AbstractEinsum) = unique!(vcat(getixsv(code)..., getiyv(code)))

"""
    labeltype(code::AbstractEinsum) -> Type

Returns the data type to represent the labels in the einsum notation.
"""
labeltype(code::AbstractEinsum) = eltype(getiyv(code))

"""
    EinCode{LT} <: AbstractEinsum
    EinCode(ixs::Vector{Vector{LT}}, iy::Vector{LT})

Einsum code with input indices `ixs` and output index `iy`.

# Examples
The einsum notation for matrix multiplication is:
```jldoctest
julia> code = OMEinsumContractionOrders.EinCode([[1,2], [2, 3]], [1, 3])
1∘2, 2∘3 -> 1∘3

julia> OMEinsumContractionOrders.getixsv(code)
2-element Vector{Vector{Int64}}:
 [1, 2]
 [2, 3]

julia> OMEinsumContractionOrders.getiyv(code)
2-element Vector{Int64}:
 1
 3
```
"""
struct EinCode{LT} <: AbstractEinsum
    ixs::Vector{Vector{LT}}
    iy::Vector{LT}
end
getixsv(rc::EinCode) = rc.ixs
getiyv(rc::EinCode) = rc.iy
Base.:(==)(a::EinCode, b::EinCode) = a.ixs == b.ixs && a.iy == b.iy

"""
    CodeOptimizer

Abstract type for code optimizers.
"""
abstract type CodeOptimizer end

"""
    CodeSlicer

Abstract type for code slicers.
"""
abstract type CodeSlicer end

"""
    AbstractDecompositionType

Abstract type for decomposition types, which includes [`TreeDecomp`](@ref) and [`PathDecomp`](@ref).
"""
abstract type AbstractDecompositionType end

"""
    TreeDecomp <: AbstractDecompositionType

Tree decomposition type.
"""
struct TreeDecomp <: AbstractDecompositionType end

"""
    PathDecomp <: AbstractDecompositionType

Path decomposition type.
"""
struct PathDecomp <: AbstractDecompositionType end

"""
    ScoreFunction

A function to compute the score of a contraction code:

```
score = tc_weight * 2^tc + rw_weight * 2^rw + sc_weight * max(0, 2^sc - 2^sc_target)
```

# Fields
- `tc_weight`: the weight of the time complexity, default is 1.0.
- `sc_weight`: the weight of the space complexity (the size of the largest tensor), default is 1.0.
- `rw_weight`: the weight of the read-write complexity, default is 0.0.
- `sc_target`: the target space complexity, below which the `sc_weight` will be set to 0 automatically, default is 0.0.
"""
struct ScoreFunction
    tc_weight::Float64
    sc_weight::Float64
    rw_weight::Float64
    sc_target::Float64
    function ScoreFunction(; tc_weight=1.0, sc_weight=1.0, rw_weight=0.0, sc_target=20.0)
        @assert tc_weight >= 0
        @assert sc_weight >= 0
        @assert rw_weight >= 0
        @assert sc_target >= 0
        new(Float64(tc_weight), Float64(sc_weight), Float64(rw_weight), Float64(sc_target))
    end
end

function (score::ScoreFunction)(tc, sc, rw)
    return score.tc_weight * exp2(tc) + score.rw_weight * exp2(rw) + score.sc_weight * max(0.0, exp2(sc) - exp2(score.sc_target))
end

"""
    NestedEinsum{LT} <: AbstractEinsum
    NestedEinsum(args::Vector{NestedEinsum}, eins::EinCode)

The einsum notation with a contraction order specified as a tree data structure.
It is automatically generated by the contraction code optimizer with the [`optimize_code`](@ref) function.

# Fields
- `args`: the children of the current node
- `tensorindex`: the index of the input tensor, required only for leaf nodes. For non-leaf nodes, it is `-1`.
- `eins`: the einsum notation for the operation at the current node.
"""
struct NestedEinsum{LT} <: AbstractEinsum
    args::Vector{NestedEinsum{LT}}
    tensorindex::Int  # -1 if not leaf
    eins::EinCode{LT}
    NestedEinsum(args::Vector{NestedEinsum{LT}}, eins::EinCode) where LT = new{LT}(args, -1, eins)
    NestedEinsum{LT}(arg::Int) where LT = new{LT}(NestedEinsum{LT}[], arg)
end
function Base.:(==)(a::NestedEinsum, b::NestedEinsum)
    return a.args == b.args && a.tensorindex == b.tensorindex && if isdefined(a, :eins)
        isdefined(b, :eins) && a.eins == b.eins
    else
        !isdefined(b, :eins)
    end
end
isleaf(ne::NestedEinsum) = ne.tensorindex != -1
function getixsv(ne::NestedEinsum{LT}) where LT
    d = collect_ixs!(ne, Dict{Int,Vector{LT}}())
    ks = sort!(collect(keys(d)))
    return @inbounds [d[i] for i in ks]
end
function collect_ixs!(ne::NestedEinsum, d::Dict{Int,Vector{LT}}) where LT
    @inbounds for i=1:length(ne.args)
        arg = ne.args[i]
        if isleaf(arg)
            d[arg.tensorindex] = getixsv(ne.eins)[i]
        else
            collect_ixs!(arg, d)
        end
    end
    return d
end
getiyv(ne::NestedEinsum) = getiyv(ne.eins)
function is_binary(code::NestedEinsum)
    isleaf(code) && return true
    length(code.args) == 2 && all(is_binary, code.args)
end
# a path decomposition is represented as a contraction tree like
# a,b,c,d,e -> (((a,b),c),d),e
is_path_decomposition(ne::NestedEinsum) = isleaf(ne) || length(ne.args) <= 2 && is_path_decomposition(ne.args[1]) && (length(ne.args) == 1 || isleaf(ne.args[2]))

"""
    SlicedEinsum{LT,ET<:Union{EinCode{LT},NestedEinsum{LT}}} <: AbstractEinsum
    SlicedEinsum(slicing::Vector{LT}, eins::ET)

The einsum notation with sliced indices. The sliced indices are the indices enumerated manually at the top level.
By slicing the indices, the space complexity of the einsum notation can be reduced.

# Fields
- `slicing`: the sliced indices.
- `eins`: the einsum notation of the current node, which is a [`NestedEinsum`](@ref) object.
"""
struct SlicedEinsum{LT,ET<:Union{EinCode{LT},NestedEinsum{LT}}} <: AbstractEinsum
    slicing::Vector{LT}
    eins::ET
end
Base.:(==)(a::SlicedEinsum, b::SlicedEinsum) = a.slicing == b.slicing && a.eins == b.eins
getixsv(se::SlicedEinsum) = getixsv(se.eins)
getiyv(se::SlicedEinsum) = getiyv(se.eins)
is_binary(code::SlicedEinsum) = is_binary(code.eins)
is_path_decomposition(ne::SlicedEinsum) = is_path_decomposition(ne.eins)

# Better printing
struct LeafString
    str::String
end
function AbstractTrees.children(ne::NestedEinsum)
    [isleaf(item) ? LeafString(_join(getixsv(ne.eins)[k])) : item for (k,item) in enumerate(ne.args)]
end
function AbstractTrees.printnode(io::IO, x::NestedEinsum)
    isleaf(x) ? print(io, x.tensorindex) : print(io, x.eins)
end
AbstractTrees.printnode(io::IO, e::LeafString) = print(io, e.str)
function Base.show(io::IO, e::EinCode)
    s = join([_join(ix) for ix in getixsv(e)], ", ") * " -> " * _join(getiyv(e))
    print(io, s)
end
function Base.show(io::IO, e::NestedEinsum)
    print_tree(io, e)
end
Base.show(io::IO, ::MIME"text/plain", e::NestedEinsum) = show(io, e)
Base.show(io::IO, ::MIME"text/plain", e::EinCode) = show(io, e)
_join(ix) = isempty(ix) ? "" : join(ix, connector(eltype(ix)))
connector(::Type{Char}) = ""
connector(::Type{Int}) = "∘"
connector(::Type) = "-"

function is_unary_or_binary(code::NestedEinsum)
    if isleaf(code) return true end
    if length(code.args) > 2 return false end
    return all(is_unary_or_binary, code.args)
end


# reformulate the nested einsum, removing a given tensor without change the space complexity
# consider only binary contraction tree with no openedges
function pivot_tree(code::NestedEinsum{LT}, removed_tensor_id::Int) where LT
    @assert is_unary_or_binary(code) "The contraction tree is not binary"
    @assert isempty(getiyv(code)) "The contraction tree has open edges"

    path = path_to_tensor(code, removed_tensor_id)
    isempty(path) && return code   # the tensor is at the root?

    right = popfirst!(path)
    left = right == 1 ? 2 : 1

    if isleaf(code.args[left]) && isleaf(code.args[right])
        ixsv = getixsv(code.eins)
        return NestedEinsum([code.args[left]], EinCode([ixsv[left]], ixsv[right]))
    elseif isleaf(code.args[right])
        return NestedEinsum([code.args[left].args...], EinCode(getixsv(code.args[left].eins), getixsv(code.eins)[right]))
    else
        # update the ein code to make sure the root of the left part and the right part are the same
        left_code = code.args[left]
        right_code = NestedEinsum([code.args[right].args...], EinCode(getixsv(code.args[right].eins), getixsv(code.eins)[left]))
    end
    tree = _pivot_tree!(left_code, right_code, path)

    return tree
end


function _pivot_tree!(left_code::NestedEinsum{LT}, right_code::NestedEinsum{LT}, path::Vector{Int}) where{LT}
    if !isleaf(right_code)
        right = popfirst!(path)
        left = right == 1 ? 2 : 1
        if length(right_code.args) == 1
            # orign: left: a, right: b -> a
            # reformulated: left: a -> b, right: b
            new_eins = EinCode([getiyv(right_code.eins)], getixsv(right_code.eins)[1])
            left_code = NestedEinsum([left_code], new_eins)
            left_code = _pivot_tree!(left_code, right_code.args[1], path)
        elseif length(right_code.args) == 2
            # origin: left: a, right: b, c -> a
            # reformulated: left: a, b -> c, right: c
            new_eins = EinCode([getiyv(right_code.eins), getixsv(right_code.eins)[left]], getixsv(right_code.eins)[right])
            left_code = NestedEinsum([left_code, right_code.args[left]], new_eins)
            left_code = _pivot_tree!(left_code, right_code.args[right], path)
        else
            error("The contraction tree is not binary")
        end
    end
    return left_code
end

# find the path to a given tensor in a nested einsum
function path_to_tensor(code::NestedEinsum, index::Int)
    path = Vector{Int}()
    _find_root!(code, index, path)
    return path
end

function _find_root!(code::NestedEinsum, index::Int, path::Vector{Int})
    if isleaf(code) return code.tensorindex == index end

    for (i, arg) in enumerate(code.args)
        if _find_root!(arg, index, path)
            pushfirst!(path, i)
            return true
        end
    end
    return false
end

# convert a tree with 1-2 children to a binary tree
function fix_binary_tree(code::NestedEinsum)
    isleaf(code) && return code
    args, ixs, iy = code.args, code.eins.ixs, code.eins.iy
    if length(args) == 1  # fix unary tree
        isleaf(args[1]) && return code
        subtree = fix_binary_tree(args[1])
        # Note: the resulting tree might still be unary, so the output is not guaranteed to be binary
        return NestedEinsum(subtree.args, EinCode(subtree.eins.ixs, iy))
    end
    @assert length(args) == 2 "The contraction tree can not be fixed, it has more than 2 children, got code = $code"
    newargs = empty(args)
    newixs = empty(ixs)
    for (ix, arg) in zip(ixs, args)
        arg = fix_binary_tree(arg)
        if length(arg.args) == 1  # remove the unary node
            push!(newargs, arg.args[1])
            push!(newixs, arg.eins.ixs[1])
        else
            push!(newargs, arg)
            push!(newixs, ix)
        end
    end
    return NestedEinsum(newargs, EinCode(newixs, iy))
end

using OMEinsumContractionOrders
using OMEinsumContractionOrders: IncidenceList, optimize_treewidth, getixsv
using OMEinsumContractionOrders: BFS, MCS, LexBFS, RCMMD, RCMGL, MCSM, LexM, AMF, MF, MMD, BT, SafeRules
using OMEinsum: decorate
using Test, Random, JSON

@testset "tree width" begin

    optimizer = ExactTreewidth()
    size_dict = Dict([c=>(1<<i) for (i,c) in enumerate(['a', 'b', 'c', 'd', 'e', 'f'])]...)

    # eincode with no open edges
    eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], Vector{Char}())
    tensors = [rand([size_dict[j] for j in ixs]...) for ixs in getixsv(eincode)]
    optcode = optimize_treewidth(optimizer, eincode, size_dict)
    cc = contraction_complexity(optcode, size_dict)
    # test flop
    @test cc.tc ≈ log2(flop(optcode, size_dict))
    @test (16 <= cc.tc <= log2(exp2(10)+exp2(16)+exp2(15)+exp2(9))) | (cc.tc ≈ log2(exp2(10)+exp2(16)+exp2(15)+exp2(9)))
    @test cc.sc == 11
    @test decorate(eincode)(tensors...) ≈ decorate(optcode)(tensors...)

    # eincode with open edges
    eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], ['a'])
    tensors = [rand([size_dict[j] for j in ixs]...) for ixs in getixsv(eincode)]
    optcode = optimize_treewidth(optimizer, eincode, size_dict)
    cc = contraction_complexity(optcode, size_dict)
    @test cc.sc == 11
    @test decorate(eincode)(tensors...) ≈ decorate(optcode)(tensors...)

    # disconnect contraction tree
    eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e'], ['e'], ['f']], ['a', 'f'])
    tensors = [rand([size_dict[j] for j in ixs]...) for ixs in getixsv(eincode)]
    optcode = optimize_treewidth(optimizer, eincode, size_dict)
    cc = contraction_complexity(optcode, size_dict)
    @test cc.sc == 7
    @test decorate(eincode)(tensors...) ≈ decorate(optcode)(tensors...)

    eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e'], ['e'], ['f'], Char[]], ['a', 'f'])
    tensors = tensors ∪ [fill(2.0,())]
    optcode = optimize_treewidth(optimizer, eincode, size_dict)
    cc = contraction_complexity(optcode, size_dict)
    @test decorate(eincode)(tensors...) ≈ decorate(optcode)(tensors...)
end

@testset "tcsc" begin
    optimizer = ExactTreewidth()
    size_dict = Dict([c=>2 for (i,c) in enumerate(['a' + (i-1) for i in 1:10])]...)

    eincode = OMEinsumContractionOrders.EinCode([['a', 'b', 'c', 'd', 'e', 'f'], ['e', 'f', 'g', 'h', 'i', 'j'], ['a', 'b', 'c', 'd', 'g', 'h', 'i', 'j']], Vector{Char}())
    ixs = getixsv(eincode)
    tensors = [rand([size_dict[j] for j in ix]...) for ix in ixs]
    optcode = optimize_treewidth(optimizer, eincode, size_dict)
    incidence_list = IncidenceList(Dict([i=>ix for (i,ix) in enumerate(ixs)] ∪ [(length(ixs) + 1 => eincode.iy)]))
    lg = OMEinsumContractionOrders.il2lg(incidence_list, collect(keys(size_dict)))
    tw = OMEinsumContractionOrders.TreeWidthSolver.exact_treewidth(lg)
    cc = contraction_complexity(optcode, size_dict)
    @test isapprox(cc.tc, tw + 1, atol=0.9)
end

@testset "treewidth" begin
    for alg in [SafeRules(BT()), MF(), MMD(), AMF(), LexM(), LexBFS(), BFS(), MCS(), RCMMD(), RCMGL(), MCSM()]
        optimizer = Treewidth(alg=alg)
        size_dict = Dict([c=>(1<<i) for (i,c) in enumerate(['a', 'b', 'c', 'd', 'e', 'f'])]...)

        # eincode with no open edges
        eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], Vector{Char}())
        tensors = [rand([size_dict[j] for j in ixs]...) for ixs in getixsv(eincode)]
        optcode = optimize_treewidth(optimizer, eincode, size_dict)
        cc = contraction_complexity(optcode, size_dict)
        # test flop
        @test cc.tc ≈ log2(flop(optcode, size_dict))
        @test (16 <= cc.tc <= log2(exp2(10)+exp2(16)+exp2(15)+exp2(9))) | (cc.tc ≈ log2(exp2(10)+exp2(16)+exp2(15)+exp2(9)))
        @test cc.sc == 11
        @test decorate(eincode)(tensors...) ≈ decorate(optcode)(tensors...)
    end
end

@testset "fix issue 87" begin
    file = "rnd_mixed_07.json"
    dict = JSON.parsefile(joinpath(@__DIR__, file))

    einsum = dict["einsum"]

    ixs = Vector{Vector{Int}}(einsum["ixs"])
    iy = Vector{Int}(einsum["iy"])

    size_dict = Dict(
        parse(Int, key) => val
        for (key, val) in dict["size"]
    )

    code = OMEinsumContractionOrders.EinCode(ixs, iy)
    optimizer = Treewidth(; alg=AMF())
    optcode = optimize_code(code, size_dict, optimizer);
    @test optcode isa OMEinsumContractionOrders.NestedEinsum
end

@testset "trace operation" begin
    code = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'a', 'd'], ['b', 'c', 'e', 'f']], Char['f'])
    size_dict = Dict([c=>2 for c in ['a', 'b', 'c', 'd', 'e', 'f']])
    tensors = [rand([size_dict[j] for j in ixs]...) for ixs in getixsv(code)]
    optcode = optimize_code(code, size_dict, Treewidth(; alg=AMF()))
    @test decorate(code)(tensors...) ≈ decorate(optcode)(tensors...)
end

function LuxorGraphPlot.GraphViz(tng::TensorNetworkGraph, locs=StressLayout(); highlight::Vector=[], highlight_color = (0.0, 0.0, 255.0, 0.5), kwargs...)

    white = (255.0, 255.0, 255.0, 0.8)
    black = (0.0, 0.0, 0.0, 1.0)
    r = (255.0, 0.0, 0.0, 0.8)
    g = (0.0, 255.0, 0.0, 0.8)

    colors = Vector{typeof(r)}()
    text = Vector{String}()
    sizes = Vector{Float64}()

    for i in 1:nv(tng.graph)
        if i in keys(tng.tensors_labels)
            push!(colors, white)
            push!(text, string(tng.tensors_labels[i]))
            push!(sizes, 20.0)
        else
            push!(colors, r)
            push!(text, string(tng.indices_labels[i]))
            push!(sizes, 10.0)
        end
    end

    for oi in tng.open_indices
        id = _get_key(tng.indices_labels, oi)
        colors[id] = g
    end

    for hl in highlight
        id = _get_key(tng.indices_labels, hl)
        colors[id] = highlight_color
    end

    return GraphViz(tng.graph, locs, texts = text, vertex_colors = colors, vertex_sizes = sizes, kwargs...)
end

function _get_key(dict::Dict, value)
    for (key, val) in dict
        if val == value
            return key
        end
    end
    @error "Value not found in dictionary"
end

function OMEinsumContractionOrders.ein2hypergraph(code::T) where{T <: AbstractEinsum}
    ixs = getixsv(code)
    iy = getiyv(code)

    edges = unique!([Iterators.flatten(ixs)...])
    open_edges = [iy[i] for i in 1:length(iy) if iy[i] in edges]

    rows = Int[]
    cols = Int[]
    for (i,ix) in enumerate(ixs)
        push!(rows, map(x->i, ix)...)
        push!(cols, map(x->findfirst(==(x), edges), ix)...)
    end
    adj = sparse(rows, cols, ones(Int, length(rows)))

    return LabeledHyperGraph(adj, el = edges, oe = open_edges)
end

function OMEinsumContractionOrders.viz_eins(code::AbstractEinsum; locs=StressLayout(), filename = nothing, config=LuxorTensorPlot.GraphDisplayConfig(), kwargs...)
    tng = TensorNetworkGraph(ein2hypergraph(code))
    gviz = GraphViz(tng, locs; kwargs...)
    return show_graph(gviz; filename, config)
end

"""
    SABipartite{RT,BT}
    SABipartite(; sc_target=25, ntrials=50, βs=0.1:0.2:15.0, niters=1000
        max_group_size=40, greedy_config=GreedyMethod(), initializer=:random)

Optimize the einsum code contraction order using the Simulated Annealing bipartition + Greedy approach.
This program first recursively cuts the tensors into several groups using simulated annealing,
with maximum group size specifed by `max_group_size` and maximum space complexity specified by `sc_target`,
Then finds the contraction order inside each group with the greedy search algorithm. Other arguments are

# Fields
- `sc_target` is the target space complexity, defined as `log2(number of elements in the largest tensor)`,
- `ntrials` is the number of repetition (with different random seeds),
- `βs` is a list of inverse temperature `1/T`,
- `niters` is the number of iteration in each temperature,
- `max_group_size` is the maximum size that allowed to used greedy search,
- `sub_optimizer` is the optimizer for the bipartited sub graphs, one can choose `GreedyMethod()` or `TreeSA()`,
- `initializer` is the partition configuration initializer, one can choose `:random` or `:greedy` (slow but better).

# References
- [Hyper-optimized tensor network contraction](https://arxiv.org/abs/2002.01935)
"""
Base.@kwdef struct SABipartite{RT,BT,SO} <: CodeOptimizer
    sc_target::RT = 25
    ntrials::Int = 50  # number of trials
    βs::BT = 0.1:0.2:15.0  # temperatures
    niters::Int = 1000  # number of iterations in each temperature
    max_group_size::Int = 40
    # configure greedy algorithm
    sub_optimizer::SO = GreedyMethod()
    initializer::Symbol = :random
end

struct PartitionState
    config::Vector{Int}
    loss::RefValue{Float64}

    group_sizes::Vector{Int}     # group sizes
    group_scs::Vector{Float64}   # space complexities
    group_degrees::Matrix{Int}   # degree of edges
end

function partition_state(adj, group, config, log2_sizes)
    group1 = [group[i] for (i,c) in enumerate(config) if c==1]
    group2 = [group[i] for (i,c) in enumerate(config) if c==2]
    group_sizes = [length(group1), length(group2)]   # group size in terms of number of vertices.
    group_scs = [group_sc(adj, group1, log2_sizes), group_sc(adj, group2, log2_sizes)]  # space complexity of each group.
    group_degrees = hcat(sum(adj[group1,:]; dims=1)', sum(adj[group2,:]; dims=1)')
    loss = compute_loss(group_scs..., group_sizes...)
    return PartitionState(config, Ref(loss), group_sizes, group_scs, group_degrees)
end

function bipartite_sc(bipartiter::SABipartite, adj::SparseMatrixCSC, vertices, log2_sizes)
    @assert length(vertices) >= 2
    degrees_all = sum(adj, dims=1)
    adjt = SparseMatrixCSC(adj')
    config = _initialize(bipartiter.initializer, adj, vertices, log2_sizes)
    if all(config .== 1) || all(config .== 2)
        config[1] = 3 - config[1]  # flip the first group to avoid empty group
    end
    best = partition_state(adj, vertices, config, log2_sizes)  # this is the `state` of current partition.

    for _ = 1:bipartiter.ntrials
        config = _initialize(bipartiter.initializer,adj, vertices, log2_sizes)
        state = partition_state(adj, vertices, config, log2_sizes)  # this is the `state` of current partition.

        @inbounds for β in bipartiter.βs, iter = 1:bipartiter.niters
            idxi = rand(1:length(vertices))
            ti = state.config[idxi]
            state.group_sizes[ti] <= 1 && continue

            sc_ti, sc_tinew = space_complexity_singlestep_update(state, adjt, degrees_all, log2_sizes, vertices, idxi)
            newloss = compute_loss(sc_ti, sc_tinew, state.group_sizes[ti]-1, state.group_sizes[3-ti]+1)
            sc_ti0, sc_tinew0 = state.group_scs[ti], state.group_scs[3-ti]
            accept = if max(sc_ti0, sc_tinew0) <= bipartiter.sc_target
                max(sc_ti, sc_tinew) <= bipartiter.sc_target && (rand() < exp2(β*(state.loss[] - newloss)))
            else
                rand() < exp2(-β*(max(sc_ti, sc_tinew) - max(sc_ti0, sc_tinew0)))
            end
            accept && update_state!(state, adjt, vertices, idxi, sc_ti, sc_tinew, newloss)
        end
        (state.group_sizes[1]==0 || state.group_sizes[2] == 0) && continue
        tc, sc1, sc2 = timespace_complexity_singlestep(state.config, adj, vertices, log2_sizes)
        @assert state.group_scs ≈ [sc1, sc2]  # sanity check
        if maximum(state.group_scs) <= max(bipartiter.sc_target, maximum(best.group_scs)) && (maximum(best.group_scs) >= bipartiter.sc_target || state.loss[] < best.loss[])
            best = state
        end
    end
    @debug "best loss = $(round(best.loss[]; digits=3)) space complexities = $(best.group_scs) time complexity = $(timespace_complexity_singlestep(best.config, adj, vertices, log2_sizes)[1]) groups_sizes = $(best.group_sizes)"
    sc = maximum(best.group_scs)
    return BipartiteResult(vertices[findall(==(1), best.config)], vertices[findall(==(2), best.config)], sc, sc <= bipartiter.sc_target)
end

function timespace_complexity_singlestep(config, adj, group, log2_sizes)
    g1 = group[findall(==(1), config)]
    g2 = group[findall(==(2), config)]
    d1 = sum(adj[g1,:], dims=1)
    d2 = sum(adj[g2,:], dims=1)
    dall = sum(adj, dims=1)
    sc1 = sum(i->(d1[i]!=0 && d1[i]!=dall[i] ? Float64(log2_sizes[i]) : 0.0), 1:size(adj,2))
    sc2 = sum(i->(d2[i]!=0 && d2[i]!=dall[i] ? Float64(log2_sizes[i]) : 0.0), 1:size(adj,2))
    tc = sum(i->((d2[i]!=0 || d1[i]!=0) && (d2[i]!=dall[i] && d1[i]!=dall[i]) ? Float64(log2_sizes[i]) : 0.0), 1:size(adj,2))
    return tc, sc1, sc2
end

function space_complexity_singlestep_update(state, adjt, degrees_all, log2_sizes, group, idxi)
    @inbounds begin
        vertex = group[idxi]
        ti = state.config[idxi]
        tinew = 3-ti
        δsc_ti = δsc(-, view(state.group_degrees, :, ti), adjt, vertex, degrees_all, log2_sizes)
        δsc_tinew = δsc(+, view(state.group_degrees, :, tinew), adjt, vertex, degrees_all, log2_sizes)
        sc_ti = state.group_scs[ti] + δsc_ti
        sc_tinew = state.group_scs[tinew] + δsc_tinew
    end
    return sc_ti, sc_tinew
end

@inline function δsc(f, group_degrees, adjt, vertex, degrees_all, log2_sizes)
    res = 0.0
    @inbounds for k in nzrange(adjt, vertex)
        i = adjt.rowval[k]
        d0 = group_degrees[i]
        D = degrees_all[i]
        d = f(d0, adjt.nzval[k])
        if d0 == D || d0 == 0     # absent
            if d != D && d != 0   # absent
                res += Float64(log2_sizes[i])
            end
        else                      # not absent
            if d == D || d == 0   # absent
                res -= Float64(log2_sizes[i])
            end
        end
    end
    return res
end


@inline function compute_loss(sc1, sc2, gs1, gs2)
    small = min(gs1, gs2)
    max(sc1, sc2) / small * (gs1 + gs2)
end

function update_state!(state, adjt, group, idxi, sc_ti, sc_tinew, newloss)
    @inbounds begin
        ti = state.config[idxi]
        tinew = 3-ti
        state.group_scs[tinew] = sc_tinew
        state.group_scs[ti] = sc_ti
        state.config[idxi] = tinew
        state.group_sizes[ti] -= 1
        state.group_sizes[tinew] += 1
        for i = nzrange(adjt,group[idxi])
            state.group_degrees[adjt.rowval[i], ti] -= adjt.nzval[i]
            state.group_degrees[adjt.rowval[i], tinew] += adjt.nzval[i]
        end
        state.loss[] = newloss
    end
    return state
end

_initialize(method, adj, vertices, log2_sizes) = if method == :random
    initialize_random(length(vertices))
elseif method == :greedy
    initialize_greedy(adj, vertices, log2_sizes)
else
    error("initializer not implemented: `$method`")
end

function initialize_greedy(adj, vertices, log2_sizes)
    adjt = SparseMatrixCSC(adj')
    indegrees = sum(adj[vertices,:], dims=1)
    all = sum(adj, dims=1)
    openedges = findall(i->all[i] > indegrees[i] > 0, 1:size(adj, 2))
    v2e = Dict{Int,Vector{Int}}()
    for v=1:size(adj, 1)
        v2e[v] = adjt.rowval[nzrange(adjt, v)]
    end
    incidence_list = IncidenceList(v2e; openedges=openedges)
    log2_edge_sizes = Dict([i=>log2_sizes[i] for i=1:length(log2_sizes)])
    tree, _, _ = tree_greedy(incidence_list, log2_edge_sizes)

    # build configuration from the tree
    res = ones(Int, size(adj, 1))
    res[get_vertices!(Int[],tree.right)] .= 2
    return res[vertices]
end
initialize_random(n::Int) = [rand() < 0.5 ? 1 : 2 for _ = 1:n]

function get_vertices!(out, tree)
    if tree isa Integer
        push!(out, tree)
    else
        get_vertices!(out, tree.left)
        get_vertices!(out, tree.right)
    end
    return out
end

# legacy interface
"""
    optimize_sa(code, size_dict; sc_target, max_group_size=40, βs=0.1:0.2:15.0, niters=1000, ntrials=50,
           sub_optimizer = GreedyMethod(), initializer=:random)

Optimize the einsum `code` contraction order using the Simulated Annealing bipartition + Greedy approach.
`size_dict` is a dictionary that specifies leg dimensions. 
Check the docstring of `SABipartite` for detailed explaination of other input arguments.

# References
- [Hyper-optimized tensor network contraction](https://arxiv.org/abs/2002.01935)
"""
function optimize_sa(code::EinCode, size_dict; sc_target, max_group_size=40,
             βs=0.01:0.02:15.0, niters=1000, ntrials=50, sub_optimizer=GreedyMethod(),
             initializer=:random)
    bipartiter = SABipartite(; sc_target=sc_target, βs=βs, niters=niters, ntrials=ntrials,
    sub_optimizer=sub_optimizer,
        max_group_size=max_group_size, initializer=initializer)
    recursive_bipartite_optimize(bipartiter, code, size_dict)
end

# Reference

## Data structures and interfaces
```@autodocs
Modules = [OMEinsumContractionOrders]
Pages = ["Core.jl", "utils.jl"]
```

## Time and space complexity
```@autodocs
Modules = [OMEinsumContractionOrders]
Pages = ["complexity.jl"]
```

## Contraction order optimizers
```@autodocs
Modules = [OMEinsumContractionOrders]
Pages = ["interfaces.jl", "greedy.jl", "treesa.jl", "treewidth.jl", "hypernd.jl", "kahypar.jl", "sabipartite.jl", "exhaustivesearch.jl"]
```

## Slicing
```@autodocs
Modules = [OMEinsumContractionOrders]
Pages = ["treesaslicer.jl"]
```

## Preprocessing code
Some optimizers (e.g. [`TreeSA`](@ref)) are too costly to run. We provide a preprocessing step to reduce the time of calling optimizers.
```@autodocs
Modules = [OMEinsumContractionOrders]
Pages = ["simplify.jl"]
```

## Dump and load contraction orders
```@autodocs
Modules = [OMEinsumContractionOrders]
Pages = ["json.jl"]
```

## Visualization
Requires `using LuxorGraphPlot` to load the extension.

```@autodocs
Modules = [OMEinsumContractionOrders]
Pages = ["visualization.jl"]
```

# AGENTS.md

This file provides guidance to AI coding agents when working with code in this repository. For full project context, see [CLAUDE.md](./CLAUDE.md).

## Common Commands

```bash
make init          # Initialize project dependencies
make test          # Run full test suite
julia --project -e 'using Pkg; Pkg.test(test_args=["greedy"])'  # Run single test
```

## Architecture Summary

Tensor network contraction order optimizer. Core flow: `EinCode` → `optimize_code()` → `NestedEinsum` (binary contraction tree).

**Key types:** `EinCode`, `NestedEinsum`, `SlicedEinsum` (in `src/Core.jl`). Optimizers (`<: CodeOptimizer`): `GreedyMethod`, `TreeSA`, `Treewidth`, `SABipartite`, `KaHyParBipartite`, `HyperND`, `ExhaustiveSearch`. Entry point: `optimize_code()` in `src/interfaces.jl`.

See CLAUDE.md for detailed type hierarchy, data flow, and file-by-file descriptions.

## Coding Conventions

- Julia 1.8+ required
- Tests use `@testset` blocks in `test/runtests.jl` with per-algorithm test files
- Package extensions in `ext/` for optional dependencies (KaHyPar, LuxorGraphPlot)
- Performance-sensitive code — avoid unnecessary allocations (see recent commits for allocation-free patterns in `greedy.jl`)

```@meta
CurrentModule = OMEinsumContractionOrders
```

# OMEinsumContractionOrders

This is the documentation for [OMEinsumContractionOrders](https://github.com/TensorBFS/OMEinsumContractionOrders.jl),
a Julia package for the optimization of the contraction order of tensor networks.

**Installation** guide is available in [README.md](https://github.com/TensorBFS/OMEinsumContractionOrders.jl). You can also access its features in [OMEinsum](https://github.com/under-Peter/OMEinsum.jl), which uses it as the default contraction order optimizer.

## Related Packages

### Derived packages
- [OMEinsum.jl](https://github.com/under-Peter/OMEinsum.jl): a Julia package for tensor network contraction.
- [TensorInference.jl](https://github.com/TensorBFS/TensorInference.jl): a Julia package for exact probabilistic inference based on the tensor network representation.
- [Yao.jl](https://github.com/QuantumBFS/Yao.jl): a Julia package for quantum computing. Its tensor network based simulation backend use OMEinsumContractionOrders.jl as the default contraction order optimizer.
- [GenericTensorNetworks.jl](https://github.com/TensorBFS/GenericTensorNetworks.jl): a Julia package for computing solution space properties of computational hard problems. It is based on the generic tensor network method and its contraction order optimization backend is OMEinsumContractionOrders.jl.
- [ITensorNetworks.jl](https://github.com/mtfishman/ITensorNetworks.jl): a Julia package for physics simulation, which uses OMEinsumContractionOrders.jl as alternative contraction order optimization backend.

### Similar packages
- [Cotengra](https://cotengra.readthedocs.io/en/latest/) : a python library for contracting tensor networks or einsum expressions involving large numbers of tensors.

# CLAUDE.md

This file provides guidance to Claude Code (claude.ai/code) when working with code in this repository.

## Project Overview

OMEinsumContractionOrders.jl is a Julia package for finding optimal contraction orders for tensor networks (Einstein summation expressions). It provides multiple optimization algorithms and is used by OMEinsum.jl, Yao.jl, GenericTensorNetworks.jl, TensorInference.jl, and ITensorNetworks.jl.

## Common Commands

```bash
make init          # Initialize project dependencies
make test          # Run full test suite
make coverage      # Run tests with coverage
make serve         # Live-serve documentation locally
make update        # Update all dependencies
```

Run a single test file:
```bash
julia --project -e 'using Pkg; Pkg.test(test_args=["greedy"])'
```

Run tests interactively:
```bash
julia --project test/runtests.jl
```

## Architecture

### Core Type Hierarchy

**Einsum representations** (`src/Core.jl`):
- `EinCode{LT}` — flat einsum with input index vectors (`ixs`) and output indices (`iy`)
- `NestedEinsum{LT}` — binary tree of contractions (the optimized output)
- `SlicedEinsum{LT,ET}` — wraps a NestedEinsum with sliced indices for memory reduction

**Optimizers** (each `<: CodeOptimizer`):
| Type | File | Algorithm |
|------|------|-----------|
| `GreedyMethod` | `greedy.jl` | Fast greedy pair selection using `IncidenceList` graph |
| `TreeSA` | `treesa.jl` | Simulated annealing over `ExprTree` structures |
| `Treewidth` / `ExactTreewidth` | `treewidth.jl` | Tree decomposition via CliqueTrees.jl |
| `SABipartite` | `sabipartite.jl` | SA-based recursive bipartitioning |
| `KaHyParBipartite` | `kahypar.jl` | KaHyPar graph partitioning (extension) |
| `HyperND` | `hypernd.jl` | Nested dissection using CliqueTrees |
| `ExhaustiveSearch` | `exhaustivesearch.jl` | Exact "netcon" DP (ported from TensorOperations.jl); minimizes total FLOPs |

**Slicers** (`<: CodeSlicer`): `TreeSASlicer` in `treesaslicer.jl`

**Simplifiers** (`<: CodeSimplifier`): `MergeVectors`, `MergeGreedy` in `simplify.jl`

**Complexity** (`complexity.jl`): `ContractionComplexity` with `tc` (time), `sc` (space), `rwc` (read-write) fields. Scoring via `ScoreFunction` with configurable weights.

### Data Flow

1. User calls `optimize_code(eincode, size_dict, optimizer)` (`interfaces.jl`)
2. Dispatcher converts `EinCode` → algorithm-specific internal representation
3. Algorithm optimizes contraction order using `size_dict` for complexity estimation
4. Returns `NestedEinsum` (binary contraction tree)
5. Optional: `slice_code` wraps result in `SlicedEinsum`; `optimize_permute` optimizes index ordering

### Key Internal Structures

- `IncidenceList` (`incidencelist.jl`) — sparse hypergraph for greedy algorithm; maps vertices to edges and tracks edge sizes
- `ExprTree` (`treesa.jl`) — mutable binary tree for simulated annealing; supports random initialization and local mutations

### Extensions

- `ext/KaHyParExt.jl` — enables `KaHyParBipartite` optimizer when KaHyPar.jl is loaded
- `ext/LuxorTensorPlot/` — provides `viz_eins()` and `viz_contraction()` when LuxorGraphPlot.jl is loaded

### Serialization

`json.jl` handles round-trip JSON serialization of contraction orders (`NestedEinsum` ↔ JSON).

## Julia Version

Requires Julia 1.8+. Current package version: 1.2.3.

# Tutorial

## Example 1: Optimize contraction order without backend specified
`OMEinsumContractionOrders` can be used as a standalone package to optimize the contraction order of an einsum notation.
The first step is to construct an [`OMEinsumContractionOrders.EinCode`](@ref) object, which is a data type to represent the [einsum notation](https://numpy.org/doc/stable/reference/generated/numpy.einsum.html).
```@repl tutorial
using OMEinsumContractionOrders, Graphs, KaHyPar
function random_regular_eincode(n, k; optimize=nothing, seed)
    g = Graphs.random_regular_graph(n, k; seed)
    ixs = [[minmax(e.src,e.dst)...] for e in Graphs.edges(g)]  # input indices
    iy = Int[]  # output indices (scalar output)
    return OMEinsumContractionOrders.EinCode(ixs, iy)
end
code = random_regular_eincode(100, 3; seed=42);
```

Here, we define an einsum notation with 3-regular graph topology. The vertices correspond to indices. On each edge, we specify a rank 2 tensor that associates with the vertices it connects. The output is a scalar.

One can use [`contraction_complexity`](@ref) function to get the time, space and rewrite cost for contracting this einsum notation. This function takes two arguments: the einsum notation and a dictionary to specify the size of the variables. Here, we use the [`uniformsize`](@ref) function to specify that all variables have the same size $2$. This function returns a dictionary that maps each variable to $2$: `Dict(i=>2 for i in uniquelabels(code))`, where [`OMEinsumContractionOrders.uniquelabels`](@ref) returns the unique labels in the einsum notation.

```@repl tutorial
size_dict = uniformsize(code, 2)
contraction_complexity(code, size_dict)
```

Since we do not specify a contraction order, the direct contraction corresponds to brute force enumeration and costs $2^{\text{number of vertices}}$ operations. No space is required to store the intermediate contraction result and the space complexity is $0$. The read-write complexity corresponds to how many element-wise read and write operations are required to perform contraction.

The order of contraction is optimized by the [`optimize_code`](@ref) function. It takes three arguments: `code`, `size_dict`, and `optimizer`. The `optimizer` argument is the optimizer to be used. The available optimizers are listed in the [optimizers](optimizers.md) page.

```@repl tutorial
score = ScoreFunction(sc_target=10, sc_weight=3.0)
optcode_tree = optimize_code(code, uniformsize(code, 2),
	TreeSA(; βs=0.1:0.1:10, ntrials=2, niters=20, score);
	slicer=TreeSASlicer(; score)
    );
contraction_complexity(optcode_tree, size_dict)
optcode_tree.slicing
```

The `optimize_code` function returns the optimized contraction order. The optimized contraction order is a [`OMEinsumContractionOrders.NestedEinsum`](@ref) object, which is a data type to represent the nested einsum notation.

## Example 2: Use it in `OMEinsum`

`OMEinsumContractionOrders` is shipped with [`OMEinsum`](https://github.com/under-Peter/OMEinsum.jl) package, which is a powerful package for tensor network contraction (or einsum contraction). You can use it to optimize the contraction order of an `OMEinsum` notation.

```@repl tutorial
using OMEinsum

code = ein"ij, jk, kl, il->"

optimized_code = optimize_code(code, uniformsize(code, 2), TreeSA())
```

## Example 3: Visualization

The visualization is provided by the `LuxorTensorPlot` extension. To use it, just load the extension by `using LuxorGraphPlot`.
```julia
pkg> add OMEinsumContractionOrders, LuxorGraphPlot

julia> using OMEinsumContractionOrders, LuxorGraphPlot
```

The extension provides the following two functions, [`viz_eins`](@ref) and [`viz_contraction`](@ref), where the former will plot the tensor network as a graph, and the latter will generate a video or gif of the contraction process.

Here is an example:
```julia-repl tutorial
julia> using OMEinsumContractionOrders, LuxorGraphPlot

julia> eincode = OMEinsumContractionOrders.EinCode([['a', 'b'], ['a', 'c', 'd'], ['b', 'c', 'e', 'f'], ['e'], ['d', 'f']], ['a'])
ab, acd, bcef, e, df -> a

julia> viz_eins(eincode, filename = "eins.png")

julia> nested_eins = optimize_code(eincode, uniformsize(eincode, 2), GreedyMethod())
ab, ab -> a
├─ ab
└─ acf, bcf -> ab
   ├─ acd, df -> acf
   │  ├─ acd
   │  └─ df
   └─ bcef, e -> bcf
      ├─ bcef
      └─ e


julia> viz_contraction(nested_code)
[ Info: Generating frames, 7 frames in total
[ Info: Creating video at: /var/folders/3y/xl2h1bxj4ql27p01nl5hrrnc0000gn/T/jl_SiSvrH/contraction.mp4
"/var/folders/3y/xl2h1bxj4ql27p01nl5hrrnc0000gn/T/jl_SiSvrH/contraction.mp4"
```

The resulting image and video will be saved in the current working directory, and the image is shown below:
```@raw html
<div style="text-align:center">
	<img src="/assets/eins.png" alt="Image" width="40%" />
</div>
```
The large white nodes represent the tensors, and the small colored nodes represent the indices, red for closed indices and green for open indices.

# Choosing Optimizers

Supported solvers include:

| Optimizer | Description |
| :----------- | :------------- |
| [`GreedyMethod`](@ref Sec_GreedyMethod) | Fast, but poor contraction order |
| [`TreeSA`](@ref Sec_TreeSA) | Reliable, local search based optimizer [^Kalachev2021], but is a bit slow |
| [`HyperND`](@ref Sec_HyperND) | Nested dissection algorithm, similar to [`KaHyParBipartite`](@ref). Requires importing either [`KaHyPar`](https://github.com/kahypar/KaHyPar.jl) or [`Metis`](https://github.com/JuliaSparse/Metis.jl). |
| [`KaHyParBipartite` and `SABipartite`](@ref Sec_Bipartite) | Graph bipartition based, suited for large tensor networks [^Gray2021], requires using [`KaHyPar`](https://github.com/kahypar/KaHyPar.jl) package. Alternatively, a simulated annealing bipartition method is provided in [`SABipartite`](@ref). |
| [`ExactTreewidth`](@ref Sec_ExactTreewidth) (alias of `Treewidth{RuleReduction{BT}}`) | Exact, but takes exponential time [^Bouchitté2001], based on package [`TreeWidthSolver`](https://github.com/ArrogantGao/TreeWidthSolver.jl). Minimizes treewidth (space complexity). |
| [`Treewidth`](@ref Sec_Treewidth) | Tree width solver based, based on package [`CliqueTrees`](https://github.com/AlgebraicJulia/CliqueTrees.jl), performance is elimination algorithm dependent. |
| [`ExhaustiveSearch`](@ref Sec_ExhaustiveSearch) | Exact, but takes exponential time [^Robert2014], the "netcon" dynamic program ported from [`TensorOperations`](https://github.com/Jutho/TensorOperations.jl). Minimizes the total contraction cost (time complexity). |

There is a tradeoff between the time and the quality of the contraction order. The following figure shows the Pareto front of the multi-objective optimization of the time to optimize the contraction order and the time to contract the tensor network.

![](assets/tradeoff.svg)

Among these methods, the `ExactTreewidth` method produces the lowest treewidth, but it does not scale up to tensor networks with more than 50 tensors. The `TreeSA` is the second best in terms of the treewidth. It works well in most cases, and supports [slicing](@ref "Reduce space complexity by slicing").
The only limitation is that it is a bit slow.
For application sensitive to overhead, the `GreedyMethod` and `Treewidth` method (blue region) are recommended.
The `Treewidth` method is a zoo of methods provided by the package [`CliqueTrees`](https://github.com/AlgebraicJulia/CliqueTrees.jl), which is a collection of methods for finding the approximate tree decomposition of a graph. Most of them have similar performance with the `GreedyMethod`, and most of them are very efficient. The `HyperND` method has a very good overall performance in benchmarks (to be added), and it is much faster than the `TreeSA` method. It relies on the `KaHyPar` package, which is platform picky.

## [`GreedyMethod`](@id Sec_GreedyMethod)
Implemented as [`GreedyMethod`](@ref) in the package.
The Greedy method is one of the simplest and fastest method for optimizing the contraction order. The idea is to greedily select the pair of tensors with the smallest cost to contract at each step.
The cost is defined as:
```math
L = \text{size}(\text{out}) - α \times (\text{size}(\text{in}_1) + \text{size}(\text{in}_2))
```
where $\text{out}$ is the output tensor, and $\text{in}_1$ and $\text{in}_2$ are the input tensors. $α$ is a hyperparameter, which is set to $0.0$ by default, meaning that we greedily select the pair of tensors with the smallest size of the output tensor. For $\alpha = 1$, the size increase in each step is greedily optimized.

The greedy method implemented in this package uses the priority queue to select the pair of tensors with the smallest cost to contract at each step. The time complexity is $O(n^2 \log n)$ for $n$ tensors, since in each of the $n$ steps, we pick the pair with the smallest cost in $O(n \log n)$ time.

## [`TreeSA`](@id Sec_TreeSA)

Implemented as [`TreeSA`](@ref) in the package.
The local search method [^Kalachev2021] is a heuristic method based on the idea of simulated annealing.
The method starts from a random contraction order and then applies the following four possible transforms as shown in the following figure

![](assets/treesa.svg)

They correspond to the different ways to contract three sub-networks:
```math
(A * B) * C = (A * C) * B = (C * B) * A, \\
A * (B * C) = B * (A * C) = C * (B * A),
```
where we slightly abuse the notation "$*$" to denote the tensor contraction, and $A, B, C$ are the sub-networks to be contracted.
Due to the commutative property of the tensor contraction, such transformations do not change the result of the contraction.
Even through these transformations are simple, all possible contraction orders can be reached from any initial contraction order.
The local search method starts from a random contraction tree.
In each step, the above rules are randomly applied to transform the tree and then the cost of the new tree is evaluated, which is defined as
```math
\mathcal{L} = \text{tc} + w_s \times \text{sc} + w_{\text{rw}} \times \text{rwc},
```
where $w_s$ and $w_{\text{rw}}$ are the weights of the space complexity and read-write complexity compared to the time complexity, respectively.
The optimal choice of weights depends on the specific device and tensor contraction algorithm. One can freely tune the weights to achieve a best performance for their specific problem.
Then the transformation is accepted with a probability given by the Metropolis criterion, which is
```math
p_{\text{accept}} = \min(1, e^{-\beta \Delta \mathcal{L}}),
```
where $\beta$ is the inverse temperature, and $\Delta \mathcal{L}$ is the difference of the cost of the new and old contraction trees.
During the process, the temperature is gradually decreased, and the process stop when the temperature is low enough.

This simple algorithm is flexible and works suprisingly well in most cases. Given enough time, it almost always finds the contraction order with the lowest cost.
The only weakness is the runtime. It usually takes minutes to optimize a network with 1k tensors.
Additionally, the `TreeSA` method supports using the [slicing](@ref "Reduce space complexity by slicing") technique to reduce the space complexity.

## [`HyperND`](@id Sec_HyperND)

Implemented as [`HyperND`](@ref) in the package.

## [`KaHyParBipartite` and `SABipartite`](@id Sec_Bipartite)

Implemented as [`KaHyParBipartite`](@ref) and [`SABipartite`](@ref) in the package. These two methods are based on the graph bipartition, 
```math
\min \sum_{e \in \text{cut}}\omega(e)\\
\text{s.t.} \quad c(V_i) \leq (1+\epsilon) \left\lceil \frac{c(V)}{2} \right\rceil.
```
where $\text{cut}$ is the set of hyperedges cut by the partition, $\omega(e)$ is the weight of the hyperedge $e$, $V_i$ is the $i$-th part of the partition, $c(V)$ is the node weight of the partition, and $\epsilon$ is the imbalance parameter.
It tries to minimize the cut crossing two blocks, while the size of each block is balanced.
The algorithm is implemented in the package [KaHyPar.jl](https://github.com/kahypar/KaHyPar.jl)[^Schlag2021], and the implementation in [OMEinsumContractionOrders.jl](https://github.com/TensorBFS/OMEinsumContractionOrders.jl) is mainly based on it.

```@raw html
<img src="https://cloud.githubusercontent.com/assets/484403/25314222/3a3bdbda-2840-11e7-9961-3bbc59b59177.png" alt="alt text" width="50%" height="50%"><img src="https://cloud.githubusercontent.com/assets/484403/25314225/3e061e42-2840-11e7-860c-028a345d1641.png" alt="alt text" width="50%" height="50%">
```

Some platforms may have some issues in installation of `KaHyPar`, please refer to [#12](https://github.com/kahypar/KaHyPar.jl/issues/12) and [#19](https://github.com/kahypar/KaHyPar.jl/issues/19).
The [`SABipartite`](@ref) is a simulated annealing based alternative to [`KaHyParBipartite`](@ref), it can produce similar results while being much more costly.

Note: Benchmarks (to be added) show that the later implementation of [`HyperND`](@ref) method is better and faster. These two methods are no longer the first choice.

## [`ExactTreewidth`](@id Sec_ExactTreewidth)

Implemented as [`ExactTreewidth`](@ref) in the package.
This method is supported by the [Google Summer of Code 2024](https://summerofcode.withgoogle.com) project ["Tensor network contraction order optimization and visualization"](https://summerofcode.withgoogle.com/programs/2024/projects/B8qSy9dO) released by **The Julia Language**.
In this project, we developed [TreeWidthSolver.jl](https://github.com/ArrogantGao/TreeWidthSolver.jl), which implements the Bouchitté–Todinca algorithm[^Bouchitté2001]. It later becomes a backend of [OMEinsumContracionOrders.jl](https://github.com/TensorBFS/OMEinsumContractionOrders.jl).

The Bouchitté–Todinca (BT) algorithm [^Bouchitté2001] is a method for calculating the treewidth of a graph exactly. It makes use of the theory of minimal triangulations, characterizing the minimal triangulations of a graph via objects called minimal separators and potential maximal cliques of the graph.
The BT algorithm has a time complexity of $O(|\Pi|nm)$, which are dependent on the graph structure. (TODO: add more details of the algorithm complexity, what is it suited for?).

The blog post [Finding the Optimal Tree Decomposition with Minimal Treewidth - Xuan-Zhao Gao](https://arrogantgao.github.io/blogs/treewidth/) has a more detailed description of this method.

## [`Treewidth`](@id Sec_Treewidth)

Implemented as [`Treewidth`](@ref) in the package.

## [`ExhaustiveSearch`](@id Sec_ExhaustiveSearch)

Implemented as [`ExhaustiveSearch`](@ref) in the package.

The exhaustive search [^Robert2014] is a method to get the exact optimal contraction complexity.
There are three different ways to implement the exhaustive search:
* **Depth-first constructive approach**: in each step, choose a pair of tensors to contract a new tensor until all tensors are contracted, and then iterate over all possible contraction sequences without duplication. Note the cheapest contraction sequence thus found.
* **Breadth-first constructive approach**: the breadth-first method construct the set of intermediate tensors by contracting $c$ tensors ($c \in [1, n - 1]$, where $n$ is the number of tensors) in each step, and record the optimal cost for constructing each intermediate tensor. Then in the last step, the optimal cost for contracting all $n$ tensors is obtained.
* **Dynamic programming**: in each step, consider all bipartition that split the tensor network into two parts, if the optimal cost for each part is not recorded, further split them until the cost has been already obtained or only one tensor is left. Then combine the two parts and record the optimal cost of contracting the sub-networks. In this end the optimal cost for the whole network is obtained.
In more recent work [^Robert2014], by reordering the search process in favor of cheapest-first and excluding large numbers of outer product contractions which are shown to be unnecessary, the efficiency of the exhaustive search has been greatly improved.

[`ExhaustiveSearch`](@ref) implements this cheapest-first breadth-first dynamic program (the "netcon" algorithm), ported from [TensorOperations.jl](https://github.com/Jutho/TensorOperations.jl). It minimizes the total contraction cost within each connected component (the sum of FLOPs over all pairwise contractions, i.e. the time complexity `tc`), then combines disconnected components cheapest-first via outer products. This is complementary to [`ExactTreewidth`](@ref), which instead minimizes the treewidth (the size of the largest intermediate tensor, i.e. the space complexity `sc`). Like `ExactTreewidth`, the search is exponential and is intended for small to moderate networks (a few tens of tensors).

The current implementation supports hyperedges (an index shared by more than two tensors) and batch/diagonal output indices. Nontrivial inputs handled by the dynamic program reject partial traces and dangling summed indices; trivial one- and two-tensor inputs are returned directly.

## Performance Benchmark

The following figure shows the performance of the different optimizers on the Sycamore 53-20-0 benchmark. This network is for computing the expectation value of a quantum circuit. Its optimal space complexity is known to be 52.

![](https://raw.githubusercontent.com/TensorBFS/OMEinsumContractionOrdersBenchmark/refs/heads/main/figures/sycamore_53_20_0.svg)

- The x-axis (contraction cost) here is defined by the space complexity (the size of the largest intermediate tensor).
- The y-axis (time) is the time taken to find the optimal contraction order.

By checking the Pareto front, we can see that the `TreeSA`, `HyperND` and `GreedyMethod` method are among the best. If you want the speed to find the optimal contraction order, the `GreedyMethod` is the best choice. If you want the quality of the contraction order, the `TreeSA` and `HyperND` method are the best choices. `HyperND` is basically a better version of `KaHyParBipartite` method, we are going to deprecate the `KaHyParBipartite` (and also `SABipartite`) method in the future.

More benchmarks, and the platform details can be found in the [benchmark repo](https://github.com/TensorBFS/OMEinsumContractionOrdersBenchmark). Or just check this full report: [Benchmark Report](https://raw.githubusercontent.com/TensorBFS/OMEinsumContractionOrdersBenchmark/refs/heads/main/report.pdf).

## References

[^Bouchitté2001]: Bouchitté, V., Todinca, I., 2001. Treewidth and Minimum Fill-in: Grouping the Minimal Separators. SIAM J. Comput. 31, 212–232. https://doi.org/10.1137/S0097539799359683
[^Gray2021]: Gray, Johnnie, and Stefanos Kourtis. "Hyper-optimized tensor network contraction." Quantum 5 (2021): 410.
[^Kalachev2021]: Kalachev, Gleb, Pavel Panteleev, and Man-Hong Yung. "Recursive multi-tensor contraction for XEB verification of quantum circuits." arXiv preprint arXiv:2108.05665 (2021).
[^Robert2014]: Pfeifer, R.N.C., Haegeman, J., Verstraete, F., 2014. Faster identification of optimal contraction sequences for tensor networks. Phys. Rev. E 90, 033315. https://doi.org/10.1103/PhysRevE.90.033315
[^Schlag2021]: Schlag, S., Heuer, T., Gottesbüren, L., Akhremtsev, Y., Schulz, C., Sanders, P., 2021. High-Quality Hypergraph Partitioning. https://doi.org/10.48550/arXiv.2106.08696

# Tensor Network Contraction Order Optimization

## Tensor network
_Tensor network_ is a powerful tool for modeling and simulating quantum many-body systems, probabilistic inference, combinatorial optimization, etc. It is a diagrammatic representation of tensor _contractions_.
In this representation, a tensor is represented as a node, and an index is represented as a hyperedge (a hyperedge can connect to any number of nodes). For example, vectors, matrices and higher order tensors can be represented as:

![](assets/tensortypes.svg)

To understand the basic concepts of tensor network, we recommend the following references for readers with different background:
* For readers with physics background: [https://tensornetwork.org/diagrams/](https://tensornetwork.org/diagrams/)
* For readers want to get a formal definition: Chapter 2 of [https://epubs.siam.org/doi/abs/10.1137/22M1501787](https://epubs.siam.org/doi/abs/10.1137/22M1501787)

The defining operation of a tensor network is _contraction_, which is also named as sum-product operation. It can be viewed as the generalization of matrix multiplication to tensors. We illustrate tensor network contraction with the following example.

### Example: Trace permutation rule

Let $A, B$ and $C$ be three square matrices with the same size. The trace operation $\text{tr}(A B C)$ is defined as the sum of the products of the elements of the matrices:
```math
\text{tr}(A B C) = \sum_{i,j,k} A_{ij} B_{ik} C_{jk}.
```
It can be represented as a tensor network diagram as follows:

![](assets/traceperm.svg)

So, each tensor is represented as a node, and each index is represented as an edge. Tensors sharing the same index are connected by the edge. The contraction of the tensor network is the summation of the products of the elements of the tensors over all possible values of the indices.

The contraction can happen in different orders. The famous trace permutation rule states that the trace is invariant under cyclic permutations of the matrices:
```math
\text{tr}(A B C) = \text{tr}(C A B) = \text{tr}(B C A).
```
Hence, we observe that tensor network contraction is associative and commutative, i.e., the order of evaluation does not change the result.
In the tensor network diagram, the order of evaluation is neglected, so the trace permutation rule is trivially satisfied.

By drawing diagrams, we prove the trace permutation rule. Isn't it cool?

## Einsum notation

For simplicity, in the following sections, we will use the einsum notation in [OMEinsum.jl](https://github.com/under-Peter/OMEinsum.jl) to represent the tensor network contraction. It is almost the same as the [numpy einsum notation](https://numpy.org/doc/stable/reference/generated/numpy.einsum.html).
For example, the contraction of the tensor network in the previous trace permutation example can be represented as:
```julia
julia> using OMEinsum

julia> trace_perm = ein"ij, jk, ki -> "
ij, jk, ki ->
```
The string `ij, jk, ki -> ` is the einsum notation, where labels of the input tensors and the output tensor are separated by `->`, and labels of different input tensors are separated by `,`. Here, `ij, jk, ki` are the labels of the input tensors of rank 2 (matrices), and the label of the output tensor is empty, representing a scalar.

Einsum notation is a powerful tool to represent linear operations, e.g. batched matrix multiplication is represented as `ijb,jkb->ikb`, taking diagonal part of a matrix is represented as `ii->i`. Sometimes, a single notation may have thousands or more tensors. Then the contraction order becomes relevant to computational cost of evaluating it.

## Contraction order and complexity
_Contraction order_ is a key factor for the performance of tensor network contraction.
It is represented by a binary tree, where the leaves are the tensors to be contracted and the internal nodes are the intermediate tensors.
The quality of the contraction order is quantified by the _contraction complexity_, which consists of the following metrics
* **time complexity**: the number of floating point operations required to calculate the result;
* **space complexity**: the largest size of the intermediate tensors. For larger tensor networks, the contraction order is important, since it can greatly reduce the time complexity of the calculation.
* **read-write complexity**: the number of times the intermediate tensors are read and written.
The contraction order optimization aims to find the _optimal contraction order_ with the lowest cost, which is usually defined as some linear combination of the above complexities.

Finding the optimal contraction order is NP-complete, but fortunately, a close-to-optimal contraction order is usually good enough, which could be found in a reasonable time with a heuristic optimizer.
In the past decade, methods have been developed to optimize the contraction orders, including both exact ones and heuristic ones.
Among these methods, multiple heuristic methods can handle networks with more than $10^4$ tensors efficiently [^Gray2021], [^Roa2024].

### Example: Optimizing the contraction order with OMEinsum.jl
Considering the following simple tensor network:
```julia
julia> einsum = ein"ij, ik, jl, lk -> "
ij, ik, jl, lk ->
```

![](assets/ABCD.svg)

Here we simply assume that all indices are of the same dimension $D$.
Then the naive way to calculate the result is to loop over all the indices, which requires $O(D^4)$ operations and no intermediate tensors are produced.

Alternatively, we can contract step by step. We first contraction tensors $A, B \mapsto A B$, and $C, D \mapsto C D$, which produces two rank-2 intermediate tensors, and then contract $A B$ with $C D$ to get the scalar $s$.

![](assets/ABCD_contraction.svg)

It is equivalent to the following einsum notation:
```julia
julia> nested_ein = ein"(ij, ik), (jl, lk) -> "
jk, jk ->
├─ ij, ik -> jk
│  ├─ ij
│  └─ ik
└─ jl, lk -> jk
   ├─ jl
   └─ lk
```
In this way, the total number of operations is $O(2 D^{3} + D^{2})$, which is smaller than the naive calculation, while the trade-off is that we need to store the intermediate tensors $AB$ and $CD$ with size of $O(D^{2})$, as shown below:
```julia
# here we take D = 16
julia> size_dict = uniformsize(einsum, 2^4)

julia> contraction_complexity(einsum, size_dict)
Time complexity: 2^16.0
Space complexity: 2^0.0
Read-write complexity: 2^10.001408194392809

julia> contraction_complexity(nested_ein, size_dict)
Time complexity: 2^13.044394119358454
Space complexity: 2^8.0
Read-write complexity: 2^11.000704269011246
```
We say such a contraction is with **time complexity** of $O(D^{3})$ and **space complexity** of $O(D^{2})$.

In actual calculation, we prefer binary contractions, i.e., contracting two tensors at a time, by converting these two tensors as matrices, so that we can make use of BLAS libraries to speed up the calculation.
In this way, a given contraction order can be represented as a binary tree.
The contraction tree can be represented as a rooted tree, where the leaves are the tensors to be contracted and the internal nodes are the intermediate tensors.
The contraction tree corresponding to the above example is shown below:

![](assets/ABCD_tree.svg)

Generally speaking, our target is to find a binary contraction order, with minimal time complexity or space complexity, which is called the **optimal contraction order**.

## Tree decomposition and tree width

Finding the optimal contraction order is related to another NP-complete problem: finding the [_tree decomposition_](https://en.wikipedia.org/wiki/Tree_decomposition) of a graph with minimal [_treewidth_](https://en.wikipedia.org/wiki/Treewidth) [^Markov2008].
Tree width is a graph characteristic that measures how similar a graph is to a tree, the lower the tree width, the more similar the graph is to a tree.
The way to relate a graph to a tree is to find a tree decomposition of the graph, which is a tree whose nodes are subsets of the vertices of the graph, and the following conditions are satisfied:

1. Each vertex of the graph is in at least one node of the tree.
2. For each edge of the graph, there is a node of the tree containing both vertices of the edge.
3. Bags containing the same vertex have to be connected in the tree.

All the nodes of the tree are called *tree bags*, and intersection of two bags is called a *separator*.
The width of a tree decomposition is the size of the largest bag minus one.
Clearly, one graph can have multiple tree decomposition with different corresponding widths. The tree width of a graph is the minimal width of all such decompositions, and a particular decomposition (not necessarily unique) that realises this minimal width is called an optimal tree decomposition.
Its width is the tree width of the graph, denoted as $\text{tw}(G)$.

Let $G$ be the hypergraph topology of a tensor network, where a tensor is mapped to a vertex and an index is mapped to an edge. Two tensors are connected if they share a common index.
Instead, if we treat each index as a vertex and each tensor as an edge, we can get its _line graph_ $L(G)$.
Ref.[^Markov2008] shows that the bottleneck time complexity of the contraction of a tensor network is $O(2^{\text{tw}(L(G))})$, where $\text{tw}(L(G))$ is the treewidth of $L(G)$. Therefore, if we can find the tree decomposition of the tensor network with minimal treewidth, we can find the optimal contraction order of the tensor network.

### Example: Line graph and tree decomposition

Consider the einsum notation:
```julia
julia> ein"ABC,BFG,EGH,CDE->"
```
Its graph $G$, its line graph $L(G)$ and its tree decomposition are shown in the following figure:

![Fig.1](assets/treedecomposition.svg)

The tree decomposition in figure (c) is related to the contraction order of the tensor network in the following way:
- By defintion of tree decomposition, each edge of the line graph is contained in at least one tree bag. Hence, every tensor (represented as a hyperedge in $L(G)$) can fit into a tree bag.
- We contract the tensor networks from the leaves to the root. Tensor network contraction requires the indices used in the future steps must be kept in the output tensor. This is automatically satisfied by the third requirement of tree decomposition: If two bags containing two tensors sharing the same index, then this index must appear in all bags between them, such that they can be connected.

As a remark, the tree decomposition considered here handles with weighted vertices. Since we are considering a tensor network, dimension of the indices have to be considered. 
Therefore, for each vertex of the line graph $L(G)$, we define its weight as $\log_2(d)$, where $d$ is the dimension of the index.
In this way, size of a tensor can be represented as the sum of weights of the vertices in $L(G)$.

## Reduce space complexity by slicing

Slicing is a technique to reduce the space complexity of the tensor network by looping over a subset of indices.
This effectively reduces the size of the tensor network inside the loop, and the space complexity can potentially be reduced.
For example, in the following figure, we slice the tensor network over the index $i$. The label $i$ is removed from the tensor network, at the cost of contraction multiple tensor networks.

![](assets/slicing.svg)

## References

[^Gray2021]: Gray, Johnnie, and Stefanos Kourtis. "Hyper-optimized tensor network contraction." Quantum 5 (2021): 410.
[^Markov2008]: Markov, I.L., Shi, Y., 2008. Simulating Quantum Computation by Contracting Tensor Networks. SIAM J. Comput. 38, 963–981. https://doi.org/10.1137/050644756
[^Roa2024]: Roa-Villescas, M., Gao, X., Stuijk, S., Corporaal, H., Liu, J.-G., 2024. Probabilistic Inference in the Era of Tensor Networks and Differential Programming. Phys. Rev. Research 6, 033261. https://doi.org/10.1103/PhysRevResearch.6.033261
